/* Tweet.c generated by valac 0.22.0, the Vala compiler
 * generated from Tweet.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <json-glib/json-glib.h>
#include <gio/gio.h>


#define TYPE_TWEET (tweet_get_type ())
#define TWEET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWEET, Tweet))
#define TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWEET, TweetClass))
#define IS_TWEET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWEET))
#define IS_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWEET))
#define TWEET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWEET, TweetClass))

typedef struct _Tweet Tweet;
typedef struct _TweetClass TweetClass;
typedef struct _TweetPrivate TweetPrivate;

#define TWEET_UTILS_TYPE_SEQUENCE (tweet_utils_sequence_get_type ())
typedef struct _TweetUtilsSequence TweetUtilsSequence;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __g_slist_free__tweet_utils_sequence_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__tweet_utils_sequence_free0_ (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define TYPE_TWITTER (twitter_get_type ())
#define TWITTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWITTER, Twitter))
#define TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWITTER, TwitterClass))
#define IS_TWITTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWITTER))
#define IS_TWITTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWITTER))
#define TWITTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWITTER, TwitterClass))

typedef struct _Twitter Twitter;
typedef struct _TwitterClass TwitterClass;

struct _Tweet {
	GObject parent_instance;
	TweetPrivate * priv;
	gint64 id;
	gint64 rt_id;
	gboolean retweeted;
	gboolean favorited;
	gchar* text;
	gint64 user_id;
	gchar* user_name;
	gchar* retweeted_by;
	gchar* rt_by_screen_name;
	gint64 rt_by_id;
	gboolean is_retweet;
	GdkPixbuf* inline_media;
	gchar* time_delta;
	gchar* avatar_url;
	gchar* avatar_name;
	gchar* screen_name;
	gint64 created_at;
	gint64 rt_created_at;
	gboolean verified;
	gint64 my_retweet;
	gint64 reply_id;
	gchar* media;
	gchar* media_thumb;
	gboolean has_inline_media;
	gint type;
	gint retweet_count;
	gint favorite_count;
};

struct _TweetClass {
	GObjectClass parent_class;
};

struct _TweetUtilsSequence {
	gint start;
	gint end;
	gchar* url;
	gchar* display_url;
	gboolean visual_display_url;
};

struct _TweetPrivate {
	GdkPixbuf* _avatar;
	GSList* urls;
};

typedef void (*TwitterAvatarDownloadedFunc) (GdkPixbuf* avatar, void* user_data);

static gpointer tweet_parent_class = NULL;
extern GdkPixbuf* twitter_no_avatar;

GType tweet_get_type (void) G_GNUC_CONST;
GType tweet_utils_sequence_get_type (void) G_GNUC_CONST;
TweetUtilsSequence* tweet_utils_sequence_dup (const TweetUtilsSequence* self);
void tweet_utils_sequence_free (TweetUtilsSequence* self);
void tweet_utils_sequence_copy (const TweetUtilsSequence* self, TweetUtilsSequence* dest);
void tweet_utils_sequence_destroy (TweetUtilsSequence* self);
#define TWEET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_TWEET, TweetPrivate))
enum  {
	TWEET_DUMMY_PROPERTY,
	TWEET_AVATAR
};
static void _tweet_utils_sequence_free0_ (gpointer var);
static void _g_slist_free__tweet_utils_sequence_free0_ (GSList* self);
#define TWEET_MAX_LENGTH 140
#define TWEET_TYPE_NORMAL 1
#define TWEET_TYPE_MENTION 2
#define TWEET_TYPE_FAVORITE 3
Tweet* tweet_new (void);
Tweet* tweet_construct (GType object_type);
void tweet_set_avatar (Tweet* self, GdkPixbuf* value);
void tweet_load_from_json (Tweet* self, JsonNode* status_node, GDateTime* now);
GDateTime* utils_parse_date (const gchar* input);
gchar* utils_get_avatar_name (const gchar* path);
static void __lambda19_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
void inline_media_downloader_try_load_media (Tweet* t, const gchar* url, GAsyncReadyCallback _callback_, gpointer _user_data_);
void inline_media_downloader_try_load_media_finish (GAsyncResult* _res_);
static void ___lambda19__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void __lambda26_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
static void ___lambda26__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void __lambda27_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
static void ___lambda27__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
static void ___lambda28_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node);
static void ____lambda28__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self);
gchar* utils_get_time_delta (GDateTime* time, GDateTime* now);
GType twitter_get_type (void) G_GNUC_CONST;
Twitter* twitter_get (void);
GdkPixbuf* twitter_get_avatar (Twitter* self, const gchar* url, TwitterAvatarDownloadedFunc func, void* func_target, GDestroyNotify func_target_destroy_notify);
static void __lambda29_ (Tweet* self, GdkPixbuf* a);
static void ___lambda29__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self);
gchar* tweet_get_formatted_text (Tweet* self);
gchar* tweet_utils_get_formatted_text (const gchar* tweet_text, GSList* urls);
gchar* tweet_get_real_text (Tweet* self);
gchar* tweet_utils_get_real_text (const gchar* tweet_text, GSList* urls);
GdkPixbuf* tweet_get_avatar (Tweet* self);
static void tweet_finalize (GObject* obj);
static void _vala_tweet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_tweet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _tweet_utils_sequence_free0_ (gpointer var) {
#line 68 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	(var == NULL) ? NULL : (var = (tweet_utils_sequence_free (var), NULL));
#line 169 "Tweet.c"
}


static void _g_slist_free__tweet_utils_sequence_free0_ (GSList* self) {
#line 68 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_slist_foreach (self, (GFunc) _tweet_utils_sequence_free0_, NULL);
#line 68 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_slist_free (self);
#line 178 "Tweet.c"
}


Tweet* tweet_construct (GType object_type) {
	Tweet * self = NULL;
	GdkPixbuf* _tmp0_ = NULL;
#line 73 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self = (Tweet*) g_object_new (object_type, NULL);
#line 74 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = twitter_no_avatar;
#line 74 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_set_avatar (self, _tmp0_);
#line 73 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return self;
#line 193 "Tweet.c"
}


Tweet* tweet_new (void) {
#line 73 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return tweet_construct (TYPE_TWEET);
#line 200 "Tweet.c"
}


/**
   * Fills all the data of this tweet from Json data.
   * @param status The Json object to get the data from
   * @param now The current time
   */
static gpointer _json_object_ref0 (gpointer self) {
#line 83 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return self ? json_object_ref (self) : NULL;
#line 212 "Tweet.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 225 "Tweet.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 255 "Tweet.c"
				goto __catch7_g_regex_error;
			}
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 264 "Tweet.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 280 "Tweet.c"
				goto __catch7_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 291 "Tweet.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 299 "Tweet.c"
	}
	goto __finally7;
	__catch7_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 313 "Tweet.c"
	}
	__finally7:
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return NULL;
#line 324 "Tweet.c"
	}
}


static gpointer _json_array_ref0 (gpointer self) {
#line 136 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return self ? json_array_ref (self) : NULL;
#line 332 "Tweet.c"
}


static gpointer _tweet_utils_sequence_dup0 (gpointer self) {
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return self ? tweet_utils_sequence_dup (self) : NULL;
#line 339 "Tweet.c"
}


static void __lambda19_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* url = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gchar* expanded_url = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp5_ = NULL;
	JsonArray* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint64 _tmp10_ = 0LL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	TweetUtilsSequence _tmp15_ = {0};
	TweetUtilsSequence _tmp16_ = {0};
	TweetUtilsSequence* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 141 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = node;
#line 141 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 141 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 141 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	url = _tmp2_;
#line 142 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp3_ = json_object_get_string_member (url, "expanded_url");
#line 142 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 142 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	expanded_url = _tmp4_;
#line 144 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp5_ = json_object_get_array_member (url, "indices");
#line 144 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp6_ = _json_array_ref0 (_tmp5_);
#line 144 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	indices = _tmp6_;
#line 145 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp7_ = expanded_url;
#line 145 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp8_ = string_replace (_tmp7_, "&", "&amp;");
#line 145 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 145 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	expanded_url = _tmp8_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp9_ = json_array_get_int_element (indices, (guint) 0);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp10_ = json_array_get_int_element (indices, (guint) 1);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_ = expanded_url;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp13_ = json_object_get_string_member (url, "display_url");
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	memset (&_tmp15_, 0, sizeof (TweetUtilsSequence));
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.start = (gint) _tmp9_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.end = (gint) _tmp10_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp15_.url);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.url = _tmp12_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp15_.display_url);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.display_url = _tmp14_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.visual_display_url = FALSE;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp16_ = _tmp15_;
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp17_ = _tweet_utils_sequence_dup0 (&_tmp16_);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp17_);
#line 146 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp16_);
#line 153 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp18_ = expanded_url;
#line 153 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	inline_media_downloader_try_load_media (self, _tmp18_, NULL, NULL);
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (url);
#line 444 "Tweet.c"
}


static void ___lambda19__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__lambda19_ (self, array, index_, element_node);
#line 451 "Tweet.c"
}


static void __lambda26_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* hashtag = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp3_ = NULL;
	JsonArray* _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	gint64 _tmp6_ = 0LL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	TweetUtilsSequence _tmp11_ = {0};
	TweetUtilsSequence _tmp12_ = {0};
	TweetUtilsSequence* _tmp13_ = NULL;
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 157 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = node;
#line 157 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 157 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 157 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	hashtag = _tmp2_;
#line 158 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp3_ = json_object_get_array_member (hashtag, "indices");
#line 158 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 158 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	indices = _tmp4_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp5_ = json_array_get_int_element (indices, (guint) 0);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp6_ = json_array_get_int_element (indices, (guint) 1);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp7_ = json_object_get_string_member (hashtag, "text");
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp8_ = g_strconcat ("#", _tmp7_, NULL);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp9_ = json_object_get_string_member (hashtag, "text");
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp10_ = g_strconcat ("#", _tmp9_, NULL);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	memset (&_tmp11_, 0, sizeof (TweetUtilsSequence));
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.start = (gint) _tmp5_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.end = (gint) _tmp6_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp11_.url);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.url = _tmp8_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp11_.display_url);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.display_url = _tmp10_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.visual_display_url = FALSE;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp12_ = _tmp11_;
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp13_ = _tweet_utils_sequence_dup0 (&_tmp12_);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp13_);
#line 159 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp12_);
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (hashtag);
#line 530 "Tweet.c"
}


static void ___lambda26__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__lambda26_ (self, array, index_, element_node);
#line 537 "Tweet.c"
}


static void __lambda27_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* mention = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp3_ = NULL;
	JsonArray* _tmp4_ = NULL;
	gint64 _tmp5_ = 0LL;
	gint64 _tmp6_ = 0LL;
	const gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	TweetUtilsSequence _tmp11_ = {0};
	TweetUtilsSequence _tmp12_ = {0};
	TweetUtilsSequence* _tmp13_ = NULL;
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 169 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = node;
#line 169 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 169 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 169 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	mention = _tmp2_;
#line 170 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp3_ = json_object_get_array_member (mention, "indices");
#line 170 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp4_ = _json_array_ref0 (_tmp3_);
#line 170 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	indices = _tmp4_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp5_ = json_array_get_int_element (indices, (guint) 0);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp6_ = json_array_get_int_element (indices, (guint) 1);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp7_ = json_object_get_string_member (mention, "id_str");
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp8_ = g_strconcat ("@", _tmp7_, NULL);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp9_ = json_object_get_string_member (mention, "screen_name");
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp10_ = g_strconcat ("@", _tmp9_, NULL);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	memset (&_tmp11_, 0, sizeof (TweetUtilsSequence));
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.start = (gint) _tmp5_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.end = (gint) _tmp6_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp11_.url);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.url = _tmp8_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp11_.display_url);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.display_url = _tmp10_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_.visual_display_url = TRUE;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp12_ = _tmp11_;
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp13_ = _tweet_utils_sequence_dup0 (&_tmp12_);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp13_);
#line 172 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp12_);
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (mention);
#line 616 "Tweet.c"
}


static void ___lambda27__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__lambda27_ (self, array, index_, element_node);
#line 623 "Tweet.c"
}


static void ___lambda28_ (Tweet* self, JsonArray* arr, guint index, JsonNode* node) {
	JsonObject* url = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	gchar* expanded_url = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	JsonArray* indices = NULL;
	JsonArray* _tmp7_ = NULL;
	JsonArray* _tmp8_ = NULL;
	gint64 _tmp9_ = 0LL;
	gint64 _tmp10_ = 0LL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	TweetUtilsSequence _tmp15_ = {0};
	TweetUtilsSequence _tmp16_ = {0};
	TweetUtilsSequence* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (arr != NULL);
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (node != NULL);
#line 186 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = node;
#line 186 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 186 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 186 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	url = _tmp2_;
#line 187 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->has_inline_media = TRUE;
#line 188 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp3_ = json_object_get_string_member (url, "expanded_url");
#line 188 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 188 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	expanded_url = _tmp4_;
#line 189 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp5_ = expanded_url;
#line 189 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp6_ = string_replace (_tmp5_, "&", "&amp;");
#line 189 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 189 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	expanded_url = _tmp6_;
#line 190 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp7_ = json_object_get_array_member (url, "indices");
#line 190 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp8_ = _json_array_ref0 (_tmp7_);
#line 190 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	indices = _tmp8_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp9_ = json_array_get_int_element (indices, (guint) 0);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp10_ = json_array_get_int_element (indices, (guint) 1);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_ = expanded_url;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp12_ = g_strdup (_tmp11_);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp13_ = json_object_get_string_member (url, "display_url");
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp14_ = g_strdup (_tmp13_);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	memset (&_tmp15_, 0, sizeof (TweetUtilsSequence));
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.start = (gint) _tmp9_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.end = (gint) _tmp10_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp15_.url);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.url = _tmp12_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (_tmp15_.display_url);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.display_url = _tmp14_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_.visual_display_url = FALSE;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp16_ = _tmp15_;
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp17_ = _tweet_utils_sequence_dup0 (&_tmp16_);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->urls = g_slist_prepend (self->priv->urls, _tmp17_);
#line 191 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_utils_sequence_destroy (&_tmp16_);
#line 198 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp18_ = json_object_get_string_member (url, "media_url");
#line 198 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	inline_media_downloader_try_load_media (self, _tmp18_, NULL, NULL);
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (indices);
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (expanded_url);
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (url);
#line 730 "Tweet.c"
}


static void ____lambda28__json_array_foreach (JsonArray* array, guint index_, JsonNode* element_node, gpointer self) {
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	___lambda28_ (self, array, index_, element_node);
#line 737 "Tweet.c"
}


static void __lambda29_ (Tweet* self, GdkPixbuf* a) {
	GdkPixbuf* _tmp0_ = NULL;
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (GDK_IS_PIXBUF (a));
#line 211 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = a;
#line 211 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_set_avatar (self, _tmp0_);
#line 749 "Tweet.c"
}


static void ___lambda29__twitter_avatar_downloaded_func (GdkPixbuf* avatar, gpointer self) {
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__lambda29_ (self, avatar);
#line 756 "Tweet.c"
}


void tweet_load_from_json (Tweet* self, JsonNode* status_node, GDateTime* now) {
	JsonObject* status = NULL;
	JsonNode* _tmp0_ = NULL;
	JsonObject* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* user = NULL;
	JsonObject* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	JsonObject* _tmp5_ = NULL;
	JsonObject* entities = NULL;
	JsonObject* _tmp6_ = NULL;
	gint64 _tmp7_ = 0LL;
	JsonObject* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	JsonObject* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	JsonObject* _tmp12_ = NULL;
	gint64 _tmp13_ = 0LL;
	JsonObject* _tmp14_ = NULL;
	gint64 _tmp15_ = 0LL;
	JsonObject* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	GDateTime* _tmp18_ = NULL;
	GDateTime* _tmp19_ = NULL;
	gint64 _tmp20_ = 0LL;
	JsonObject* _tmp21_ = NULL;
	gboolean _tmp22_ = FALSE;
	JsonObject* _tmp90_ = NULL;
	gboolean _tmp91_ = FALSE;
	const gchar* _tmp95_ = NULL;
	gchar* _tmp96_ = NULL;
	const gchar* _tmp97_ = NULL;
	gchar* _tmp98_ = NULL;
	JsonArray* urls = NULL;
	JsonObject* _tmp99_ = NULL;
	JsonArray* _tmp100_ = NULL;
	JsonArray* _tmp101_ = NULL;
	JsonArray* hashtags = NULL;
	JsonObject* _tmp102_ = NULL;
	JsonArray* _tmp103_ = NULL;
	JsonArray* _tmp104_ = NULL;
	JsonArray* user_mentions = NULL;
	JsonObject* _tmp105_ = NULL;
	JsonArray* _tmp106_ = NULL;
	JsonArray* _tmp107_ = NULL;
	JsonArray* _tmp108_ = NULL;
	JsonArray* _tmp109_ = NULL;
	JsonArray* _tmp110_ = NULL;
	JsonObject* _tmp111_ = NULL;
	gboolean _tmp112_ = FALSE;
	gint64 _tmp117_ = 0LL;
	gboolean _tmp118_ = FALSE;
	GDateTime* dt = NULL;
	gint64 _tmp121_ = 0LL;
	GDateTime* _tmp122_ = NULL;
	GDateTime* _tmp123_ = NULL;
	gchar* _tmp124_ = NULL;
	Twitter* _tmp125_ = NULL;
	Twitter* _tmp126_ = NULL;
	const gchar* _tmp127_ = NULL;
	GdkPixbuf* _tmp128_ = NULL;
	GdkPixbuf* _tmp129_ = NULL;
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (status_node != NULL);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (now != NULL);
#line 83 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = status_node;
#line 83 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = json_node_get_object (_tmp0_);
#line 83 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = _json_object_ref0 (_tmp1_);
#line 83 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	status = _tmp2_;
#line 84 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp3_ = status;
#line 84 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp4_ = json_object_get_object_member (_tmp3_, "user");
#line 84 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp5_ = _json_object_ref0 (_tmp4_);
#line 84 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	user = _tmp5_;
#line 86 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp6_ = status;
#line 86 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp7_ = json_object_get_int_member (_tmp6_, "id");
#line 86 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->id = _tmp7_;
#line 87 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp8_ = status;
#line 87 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp9_ = json_object_get_boolean_member (_tmp8_, "favorited");
#line 87 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->favorited = _tmp9_;
#line 88 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp10_ = status;
#line 88 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp11_ = json_object_get_boolean_member (_tmp10_, "retweeted");
#line 88 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->retweeted = _tmp11_;
#line 89 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp12_ = status;
#line 89 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp13_ = json_object_get_int_member (_tmp12_, "retweet_count");
#line 89 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->retweet_count = (gint) _tmp13_;
#line 90 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp14_ = status;
#line 90 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp15_ = json_object_get_int_member (_tmp14_, "favorite_count");
#line 90 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->favorite_count = (gint) _tmp15_;
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp16_ = status;
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp17_ = json_object_get_string_member (_tmp16_, "created_at");
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp18_ = utils_parse_date (_tmp17_);
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp19_ = _tmp18_;
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp20_ = g_date_time_to_unix (_tmp19_);
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->created_at = _tmp20_;
#line 91 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_date_time_unref0 (_tmp19_);
#line 95 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp21_ = status;
#line 95 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp22_ = json_object_has_member (_tmp21_, "retweeted_status");
#line 95 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	if (_tmp22_) {
#line 894 "Tweet.c"
		JsonObject* rt = NULL;
		JsonObject* _tmp23_ = NULL;
		JsonObject* _tmp24_ = NULL;
		JsonObject* _tmp25_ = NULL;
		JsonObject* rt_user = NULL;
		JsonObject* _tmp26_ = NULL;
		JsonObject* _tmp27_ = NULL;
		JsonObject* _tmp28_ = NULL;
		JsonObject* _tmp29_ = NULL;
		JsonObject* _tmp30_ = NULL;
		JsonObject* _tmp31_ = NULL;
		JsonObject* _tmp32_ = NULL;
		gint64 _tmp33_ = 0LL;
		JsonObject* _tmp34_ = NULL;
		const gchar* _tmp35_ = NULL;
		gchar* _tmp36_ = NULL;
		JsonObject* _tmp37_ = NULL;
		const gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		JsonObject* _tmp40_ = NULL;
		gint64 _tmp41_ = 0LL;
		JsonObject* _tmp42_ = NULL;
		const gchar* _tmp43_ = NULL;
		gchar* _tmp44_ = NULL;
		JsonObject* _tmp45_ = NULL;
		const gchar* _tmp46_ = NULL;
		gchar* _tmp47_ = NULL;
		JsonObject* _tmp48_ = NULL;
		const gchar* _tmp49_ = NULL;
		gchar* _tmp50_ = NULL;
		JsonObject* _tmp51_ = NULL;
		gint64 _tmp52_ = 0LL;
		JsonObject* _tmp53_ = NULL;
		const gchar* _tmp54_ = NULL;
		gchar* _tmp55_ = NULL;
		JsonObject* _tmp56_ = NULL;
		const gchar* _tmp57_ = NULL;
		GDateTime* _tmp58_ = NULL;
		GDateTime* _tmp59_ = NULL;
		gint64 _tmp60_ = 0LL;
		JsonObject* _tmp61_ = NULL;
		gboolean _tmp62_ = FALSE;
		JsonObject* _tmp63_ = NULL;
		gboolean _tmp64_ = FALSE;
#line 96 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp23_ = status;
#line 96 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp24_ = json_object_get_object_member (_tmp23_, "retweeted_status");
#line 96 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp25_ = _json_object_ref0 (_tmp24_);
#line 96 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		rt = _tmp25_;
#line 97 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp26_ = rt;
#line 97 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp27_ = json_object_get_object_member (_tmp26_, "user");
#line 97 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp28_ = _json_object_ref0 (_tmp27_);
#line 97 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		rt_user = _tmp28_;
#line 98 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp29_ = rt;
#line 98 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp30_ = json_object_get_object_member (_tmp29_, "entities");
#line 98 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp31_ = _json_object_ref0 (_tmp30_);
#line 98 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_json_object_unref0 (entities);
#line 98 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		entities = _tmp31_;
#line 99 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->is_retweet = TRUE;
#line 100 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp32_ = rt;
#line 100 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp33_ = json_object_get_int_member (_tmp32_, "id");
#line 100 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->rt_id = _tmp33_;
#line 101 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp34_ = user;
#line 101 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp35_ = json_object_get_string_member (_tmp34_, "name");
#line 101 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp36_ = string_replace (_tmp35_, "&", "&amp;");
#line 101 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->retweeted_by);
#line 101 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->retweeted_by = _tmp36_;
#line 102 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp37_ = user;
#line 102 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp38_ = json_object_get_string_member (_tmp37_, "screen_name");
#line 102 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp39_ = g_strdup (_tmp38_);
#line 102 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->rt_by_screen_name);
#line 102 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->rt_by_screen_name = _tmp39_;
#line 103 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp40_ = user;
#line 103 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp41_ = json_object_get_int_member (_tmp40_, "id");
#line 103 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->rt_by_id = _tmp41_;
#line 104 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp42_ = rt;
#line 104 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp43_ = json_object_get_string_member (_tmp42_, "text");
#line 104 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp44_ = g_strdup (_tmp43_);
#line 104 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->text);
#line 104 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->text = _tmp44_;
#line 105 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp45_ = rt_user;
#line 105 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp46_ = json_object_get_string_member (_tmp45_, "name");
#line 105 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp47_ = g_strdup (_tmp46_);
#line 105 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->user_name);
#line 105 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->user_name = _tmp47_;
#line 106 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp48_ = rt_user;
#line 106 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp49_ = json_object_get_string_member (_tmp48_, "profile_image_url");
#line 106 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp50_ = g_strdup (_tmp49_);
#line 106 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->avatar_url);
#line 106 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->avatar_url = _tmp50_;
#line 107 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp51_ = rt_user;
#line 107 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp52_ = json_object_get_int_member (_tmp51_, "id");
#line 107 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->user_id = _tmp52_;
#line 108 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp53_ = rt_user;
#line 108 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp54_ = json_object_get_string_member (_tmp53_, "screen_name");
#line 108 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp55_ = g_strdup (_tmp54_);
#line 108 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->screen_name);
#line 108 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->screen_name = _tmp55_;
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp56_ = rt;
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp57_ = json_object_get_string_member (_tmp56_, "created_at");
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp58_ = utils_parse_date (_tmp57_);
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp59_ = _tmp58_;
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp60_ = g_date_time_to_unix (_tmp59_);
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->rt_created_at = _tmp60_;
#line 109 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_date_time_unref0 (_tmp59_);
#line 111 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp61_ = rt_user;
#line 111 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp62_ = json_object_get_boolean_member (_tmp61_, "verified");
#line 111 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->verified = _tmp62_;
#line 112 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp63_ = rt;
#line 112 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp64_ = json_object_get_null_member (_tmp63_, "in_reply_to_status_id");
#line 112 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		if (!_tmp64_) {
#line 1071 "Tweet.c"
			JsonObject* _tmp65_ = NULL;
			gint64 _tmp66_ = 0LL;
#line 113 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			_tmp65_ = rt;
#line 113 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			_tmp66_ = json_object_get_int_member (_tmp65_, "in_reply_to_status_id");
#line 113 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			self->reply_id = _tmp66_;
#line 1080 "Tweet.c"
		}
#line 95 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_json_object_unref0 (rt_user);
#line 95 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_json_object_unref0 (rt);
#line 1086 "Tweet.c"
	} else {
		JsonObject* _tmp67_ = NULL;
		JsonObject* _tmp68_ = NULL;
		JsonObject* _tmp69_ = NULL;
		JsonObject* _tmp70_ = NULL;
		const gchar* _tmp71_ = NULL;
		gchar* _tmp72_ = NULL;
		JsonObject* _tmp73_ = NULL;
		const gchar* _tmp74_ = NULL;
		gchar* _tmp75_ = NULL;
		JsonObject* _tmp76_ = NULL;
		gint64 _tmp77_ = 0LL;
		JsonObject* _tmp78_ = NULL;
		const gchar* _tmp79_ = NULL;
		gchar* _tmp80_ = NULL;
		JsonObject* _tmp81_ = NULL;
		const gchar* _tmp82_ = NULL;
		gchar* _tmp83_ = NULL;
		JsonObject* _tmp84_ = NULL;
		gboolean _tmp85_ = FALSE;
		JsonObject* _tmp86_ = NULL;
		gboolean _tmp87_ = FALSE;
#line 115 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp67_ = status;
#line 115 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp68_ = json_object_get_object_member (_tmp67_, "entities");
#line 115 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp69_ = _json_object_ref0 (_tmp68_);
#line 115 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_json_object_unref0 (entities);
#line 115 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		entities = _tmp69_;
#line 116 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp70_ = status;
#line 116 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp71_ = json_object_get_string_member (_tmp70_, "text");
#line 116 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp72_ = g_strdup (_tmp71_);
#line 116 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->text);
#line 116 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->text = _tmp72_;
#line 117 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp73_ = user;
#line 117 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp74_ = json_object_get_string_member (_tmp73_, "name");
#line 117 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp75_ = g_strdup (_tmp74_);
#line 117 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->user_name);
#line 117 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->user_name = _tmp75_;
#line 118 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp76_ = user;
#line 118 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp77_ = json_object_get_int_member (_tmp76_, "id");
#line 118 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->user_id = _tmp77_;
#line 119 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp78_ = user;
#line 119 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp79_ = json_object_get_string_member (_tmp78_, "screen_name");
#line 119 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp80_ = g_strdup (_tmp79_);
#line 119 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->screen_name);
#line 119 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->screen_name = _tmp80_;
#line 120 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp81_ = user;
#line 120 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp82_ = json_object_get_string_member (_tmp81_, "profile_image_url");
#line 120 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp83_ = g_strdup (_tmp82_);
#line 120 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_g_free0 (self->avatar_url);
#line 120 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->avatar_url = _tmp83_;
#line 121 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp84_ = user;
#line 121 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp85_ = json_object_get_boolean_member (_tmp84_, "verified");
#line 121 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->verified = _tmp85_;
#line 122 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp86_ = status;
#line 122 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp87_ = json_object_get_null_member (_tmp86_, "in_reply_to_status_id");
#line 122 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		if (!_tmp87_) {
#line 1177 "Tweet.c"
			JsonObject* _tmp88_ = NULL;
			gint64 _tmp89_ = 0LL;
#line 123 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			_tmp88_ = status;
#line 123 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			_tmp89_ = json_object_get_int_member (_tmp88_, "in_reply_to_status_id");
#line 123 "/builddir/build/BUILD/corebird/src/Tweet.vala"
			self->reply_id = _tmp89_;
#line 1186 "Tweet.c"
		}
	}
#line 125 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp90_ = status;
#line 125 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp91_ = json_object_has_member (_tmp90_, "current_user_retweet");
#line 125 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	if (_tmp91_) {
#line 1195 "Tweet.c"
		JsonObject* _tmp92_ = NULL;
		JsonObject* _tmp93_ = NULL;
		gint64 _tmp94_ = 0LL;
#line 126 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp92_ = status;
#line 126 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp93_ = json_object_get_object_member (_tmp92_, "current_user_retweet");
#line 126 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp94_ = json_object_get_int_member (_tmp93_, "id");
#line 126 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->my_retweet = _tmp94_;
#line 127 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		self->retweeted = TRUE;
#line 1209 "Tweet.c"
	}
#line 130 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp95_ = self->user_name;
#line 130 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp96_ = string_replace (_tmp95_, "&", "&amp;");
#line 130 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->user_name);
#line 130 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->user_name = _tmp96_;
#line 131 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp97_ = self->avatar_url;
#line 131 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp98_ = utils_get_avatar_name (_tmp97_);
#line 131 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->avatar_name);
#line 131 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->avatar_name = _tmp98_;
#line 136 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp99_ = entities;
#line 136 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp100_ = json_object_get_array_member (_tmp99_, "urls");
#line 136 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp101_ = _json_array_ref0 (_tmp100_);
#line 136 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	urls = _tmp101_;
#line 137 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp102_ = entities;
#line 137 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp103_ = json_object_get_array_member (_tmp102_, "hashtags");
#line 137 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp104_ = _json_array_ref0 (_tmp103_);
#line 137 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	hashtags = _tmp104_;
#line 138 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp105_ = entities;
#line 138 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp106_ = json_object_get_array_member (_tmp105_, "user_mentions");
#line 138 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp107_ = _json_array_ref0 (_tmp106_);
#line 138 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	user_mentions = _tmp107_;
#line 139 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__g_slist_free__tweet_utils_sequence_free0_0 (self->priv->urls);
#line 139 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->urls = NULL;
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp108_ = urls;
#line 140 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	json_array_foreach_element (_tmp108_, ___lambda19__json_array_foreach, self);
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp109_ = hashtags;
#line 156 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	json_array_foreach_element (_tmp109_, ___lambda26__json_array_foreach, self);
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp110_ = user_mentions;
#line 168 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	json_array_foreach_element (_tmp110_, ___lambda27__json_array_foreach, self);
#line 183 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp111_ = entities;
#line 183 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp112_ = json_object_has_member (_tmp111_, "media");
#line 183 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	if (_tmp112_) {
#line 1273 "Tweet.c"
		JsonArray* medias = NULL;
		JsonObject* _tmp113_ = NULL;
		JsonArray* _tmp114_ = NULL;
		JsonArray* _tmp115_ = NULL;
		JsonArray* _tmp116_ = NULL;
#line 184 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp113_ = entities;
#line 184 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp114_ = json_object_get_array_member (_tmp113_, "media");
#line 184 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp115_ = _json_array_ref0 (_tmp114_);
#line 184 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		medias = _tmp115_;
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp116_ = medias;
#line 185 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		json_array_foreach_element (_tmp116_, ____lambda28__json_array_foreach, self);
#line 183 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_json_array_unref0 (medias);
#line 1293 "Tweet.c"
	}
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp118_ = self->is_retweet;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	if (_tmp118_) {
#line 1299 "Tweet.c"
		gint64 _tmp119_ = 0LL;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp119_ = self->rt_created_at;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp117_ = _tmp119_;
#line 1305 "Tweet.c"
	} else {
		gint64 _tmp120_ = 0LL;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp120_ = self->created_at;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		_tmp117_ = _tmp120_;
#line 1312 "Tweet.c"
	}
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp121_ = _tmp117_;
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp122_ = g_date_time_new_from_unix_local (_tmp121_);
#line 206 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	dt = _tmp122_;
#line 207 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp123_ = now;
#line 207 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp124_ = utils_get_time_delta (dt, _tmp123_);
#line 207 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->time_delta);
#line 207 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->time_delta = _tmp124_;
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp125_ = twitter_get ();
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp126_ = _tmp125_;
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp127_ = self->avatar_url;
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp128_ = twitter_get_avatar (_tmp126_, _tmp127_, ___lambda29__twitter_avatar_downloaded_func, g_object_ref (self), g_object_unref);
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp129_ = _tmp128_;
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_set_avatar (self, _tmp129_);
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_object_unref0 (_tmp129_);
#line 210 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_object_unref0 (_tmp126_);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_date_time_unref0 (dt);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (user_mentions);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (hashtags);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_array_unref0 (urls);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (entities);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (user);
#line 82 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_json_object_unref0 (status);
#line 1358 "Tweet.c"
}


/**
   * Returns the text of this tweet in pango markup form,
   * i.e. formatted with the html tags used by pango.
   *
   * @return The tweet's formatted text.
   */
gchar* tweet_get_formatted_text (Tweet* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GSList* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 228 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 229 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = self->text;
#line 229 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = self->priv->urls;
#line 229 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = tweet_utils_get_formatted_text (_tmp0_, _tmp1_);
#line 229 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	result = _tmp2_;
#line 229 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return result;
#line 1385 "Tweet.c"
}


/**
   * Returns the text of this tweet, with its long urls.
   * Twitter automatically shortens them.
   *
   * @return The tweet's text with long urls
   */
gchar* tweet_get_real_text (Tweet* self) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	GSList* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
#line 238 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 239 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = self->text;
#line 239 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp1_ = self->priv->urls;
#line 239 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp2_ = tweet_utils_get_real_text (_tmp0_, _tmp1_);
#line 239 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	result = _tmp2_;
#line 239 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return result;
#line 1412 "Tweet.c"
}


GdkPixbuf* tweet_get_avatar (Tweet* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_val_if_fail (IS_TWEET (self), NULL);
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = self->priv->_avatar;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	result = _tmp0_;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	return result;
#line 1427 "Tweet.c"
}


void tweet_set_avatar (Tweet* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_return_if_fail (IS_TWEET (self));
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = value;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv->_avatar = _tmp0_;
#line 45 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_object_notify ((GObject *) self, "avatar");
#line 1441 "Tweet.c"
}


static void tweet_class_init (TweetClass * klass) {
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	tweet_parent_class = g_type_class_peek_parent (klass);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_type_class_add_private (klass, sizeof (TweetPrivate));
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tweet_get_property;
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tweet_set_property;
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	G_OBJECT_CLASS (klass)->finalize = tweet_finalize;
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TWEET_AVATAR, g_param_spec_object ("avatar", "avatar", "avatar", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	g_signal_new ("inline_media_added", TYPE_TWEET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GDK_TYPE_PIXBUF);
#line 1460 "Tweet.c"
}


static void tweet_instance_init (Tweet * self) {
	gchar* _tmp0_ = NULL;
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->priv = TWEET_GET_PRIVATE (self);
#line 35 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->rt_id = (gint64) 0;
#line 36 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->retweeted = FALSE;
#line 37 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->favorited = FALSE;
#line 47 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_tmp0_ = g_strdup ("-1s");
#line 47 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->time_delta = _tmp0_;
#line 55 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->verified = FALSE;
#line 60 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->reply_id = (gint64) 0;
#line 64 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->has_inline_media = FALSE;
#line 67 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self->type = -1;
#line 1486 "Tweet.c"
}


static void tweet_finalize (GObject* obj) {
	Tweet * self;
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TWEET, Tweet);
#line 38 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->text);
#line 40 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->user_name);
#line 41 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->retweeted_by);
#line 42 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->rt_by_screen_name);
#line 46 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_object_unref0 (self->inline_media);
#line 47 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->time_delta);
#line 49 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->avatar_url);
#line 51 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->avatar_name);
#line 52 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->screen_name);
#line 61 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->media);
#line 62 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	_g_free0 (self->media_thumb);
#line 68 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	__g_slist_free__tweet_utils_sequence_free0_0 (self->priv->urls);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	G_OBJECT_CLASS (tweet_parent_class)->finalize (obj);
#line 1520 "Tweet.c"
}


GType tweet_get_type (void) {
	static volatile gsize tweet_type_id__volatile = 0;
	if (g_once_init_enter (&tweet_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TweetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tweet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tweet), 0, (GInstanceInitFunc) tweet_instance_init, NULL };
		GType tweet_type_id;
		tweet_type_id = g_type_register_static (G_TYPE_OBJECT, "Tweet", &g_define_type_info, 0);
		g_once_init_leave (&tweet_type_id__volatile, tweet_type_id);
	}
	return tweet_type_id__volatile;
}


static void _vala_tweet_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Tweet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET, Tweet);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		case TWEET_AVATAR:
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		g_value_set_object (value, tweet_get_avatar (self));
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		break;
#line 1547 "Tweet.c"
		default:
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		break;
#line 1553 "Tweet.c"
	}
}


static void _vala_tweet_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Tweet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TWEET, Tweet);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
	switch (property_id) {
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		case TWEET_AVATAR:
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		tweet_set_avatar (self, g_value_get_object (value));
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		break;
#line 1569 "Tweet.c"
		default:
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/builddir/build/BUILD/corebird/src/Tweet.vala"
		break;
#line 1575 "Tweet.c"
	}
}



