/* UserCounter.c generated by valac 0.22.0, the Vala compiler
 * generated from UserCounter.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */
/*
  So, this is the plan:
  we wil just save every single time the user encounters another user.
  We then save the first 200 or so results and load them on startup.
  If the user types a name and no result is found, we try to search
  for that name via Twitter's search API.

 XXX: Check if this works well with sqlite, if not move to a simple text file.
*/

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gobject/gvaluecollector.h>


#define TYPE_USER_INFO (user_info_get_type ())
#define USER_INFO(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_INFO, UserInfo))
#define USER_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_INFO, UserInfoClass))
#define IS_USER_INFO(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_INFO))
#define IS_USER_INFO_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_INFO))
#define USER_INFO_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_INFO, UserInfoClass))

typedef struct _UserInfo UserInfo;
typedef struct _UserInfoClass UserInfoClass;
typedef struct _UserInfoPrivate UserInfoPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _ParamSpecUserInfo ParamSpecUserInfo;

#define TYPE_USER_COUNTER (user_counter_get_type ())
#define USER_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_COUNTER, UserCounter))
#define USER_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_COUNTER, UserCounterClass))
#define IS_USER_COUNTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_COUNTER))
#define IS_USER_COUNTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_COUNTER))
#define USER_COUNTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_COUNTER, UserCounterClass))

typedef struct _UserCounter UserCounter;
typedef struct _UserCounterClass UserCounterClass;
typedef struct _UserCounterPrivate UserCounterPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _user_info_unref0(var) ((var == NULL) ? NULL : (var = (user_info_unref (var), NULL)))

#define SQL_TYPE_DATABASE (sql_database_get_type ())
#define SQL_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_DATABASE, SqlDatabase))
#define SQL_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_DATABASE, SqlDatabaseClass))
#define SQL_IS_DATABASE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_DATABASE))
#define SQL_IS_DATABASE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_DATABASE))
#define SQL_DATABASE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_DATABASE, SqlDatabaseClass))

typedef struct _SqlDatabase SqlDatabase;
typedef struct _SqlDatabaseClass SqlDatabaseClass;

#define SQL_TYPE_SELECT_STATEMENT (sql_select_statement_get_type ())
#define SQL_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatement))
#define SQL_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))
#define SQL_IS_SELECT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_SELECT_STATEMENT))
#define SQL_IS_SELECT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_SELECT_STATEMENT))
#define SQL_SELECT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_SELECT_STATEMENT, SqlSelectStatementClass))

typedef struct _SqlSelectStatement SqlSelectStatement;
typedef struct _SqlSelectStatementClass SqlSelectStatementClass;
#define _sql_select_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_select_statement_unref (var), NULL)))

#define SQL_TYPE_INSERT_STATEMENT (sql_insert_statement_get_type ())
#define SQL_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatement))
#define SQL_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))
#define SQL_IS_INSERT_STATEMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SQL_TYPE_INSERT_STATEMENT))
#define SQL_IS_INSERT_STATEMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SQL_TYPE_INSERT_STATEMENT))
#define SQL_INSERT_STATEMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SQL_TYPE_INSERT_STATEMENT, SqlInsertStatementClass))

typedef struct _SqlInsertStatement SqlInsertStatement;
typedef struct _SqlInsertStatementClass SqlInsertStatementClass;
#define _sql_insert_statement_unref0(var) ((var == NULL) ? NULL : (var = (sql_insert_statement_unref (var), NULL)))

struct _UserInfo {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UserInfoPrivate * priv;
	gint64 id;
	gchar* screen_name;
	gchar* name;
	gint score;
	gboolean changed;
};

struct _UserInfoClass {
	GTypeClass parent_class;
	void (*finalize) (UserInfo *self);
};

struct _ParamSpecUserInfo {
	GParamSpec parent_instance;
};

struct _UserCounter {
	GObject parent_instance;
	UserCounterPrivate * priv;
};

struct _UserCounterClass {
	GObjectClass parent_class;
};

struct _UserCounterPrivate {
	gboolean changed;
	GeeArrayList* names;
};

typedef gboolean (*SqlSelectCallback) (gchar** vals, int vals_length1, void* user_data);

static gpointer user_info_parent_class = NULL;
static gpointer user_counter_parent_class = NULL;

gpointer user_info_ref (gpointer instance);
void user_info_unref (gpointer instance);
GParamSpec* param_spec_user_info (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void value_set_user_info (GValue* value, gpointer v_object);
void value_take_user_info (GValue* value, gpointer v_object);
gpointer value_get_user_info (const GValue* value);
GType user_info_get_type (void) G_GNUC_CONST;
enum  {
	USER_INFO_DUMMY_PROPERTY
};
UserInfo* user_info_new (void);
UserInfo* user_info_construct (GType object_type);
static void user_info_finalize (UserInfo* obj);
GType user_counter_get_type (void) G_GNUC_CONST;
#define USER_COUNTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_COUNTER, UserCounterPrivate))
enum  {
	USER_COUNTER_DUMMY_PROPERTY
};
UserCounter* user_counter_new (void);
UserCounter* user_counter_construct (GType object_type);
void user_counter_user_seen (UserCounter* self, gint64 id, const gchar* screen_name, const gchar* name);
UserInfo** user_counter_query_by_prefix (UserCounter* self, const gchar* prefix, gint max_results, gint* num_results, int* result_length1);
gpointer sql_database_ref (gpointer instance);
void sql_database_unref (gpointer instance);
GParamSpec* sql_param_spec_database (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_database (GValue* value, gpointer v_object);
void sql_value_take_database (GValue* value, gpointer v_object);
gpointer sql_value_get_database (const GValue* value);
GType sql_database_get_type (void) G_GNUC_CONST;
void user_counter_load (UserCounter* self, SqlDatabase* db);
gpointer sql_select_statement_ref (gpointer instance);
void sql_select_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_select_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_select_statement (GValue* value, gpointer v_object);
void sql_value_take_select_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_select_statement (const GValue* value);
GType sql_select_statement_get_type (void) G_GNUC_CONST;
SqlSelectStatement* sql_database_select (SqlDatabase* self, const gchar* table_name);
SqlSelectStatement* sql_select_statement_cols (SqlSelectStatement* self, const gchar* first, ...);
SqlSelectStatement* sql_select_statement_order (SqlSelectStatement* self, const gchar* order_by);
gint sql_select_statement_run (SqlSelectStatement* self, SqlSelectCallback callback, void* callback_target);
static gboolean __lambda4_ (UserCounter* self, gchar** vals, int vals_length1);
static gboolean ___lambda4__sql_select_callback (gchar** vals, int vals_length1, gpointer self);
void user_counter_save (UserCounter* self, SqlDatabase* db);
gpointer sql_insert_statement_ref (gpointer instance);
void sql_insert_statement_unref (gpointer instance);
GParamSpec* sql_param_spec_insert_statement (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags);
void sql_value_set_insert_statement (GValue* value, gpointer v_object);
void sql_value_take_insert_statement (GValue* value, gpointer v_object);
gpointer sql_value_get_insert_statement (const GValue* value);
GType sql_insert_statement_get_type (void) G_GNUC_CONST;
SqlInsertStatement* sql_database_replace (SqlDatabase* self, const gchar* table_name);
SqlInsertStatement* sql_insert_statement_vali64 (SqlInsertStatement* self, const gchar* col_name, gint64 col_value);
SqlInsertStatement* sql_insert_statement_vali (SqlInsertStatement* self, const gchar* col_name, gint col_value);
SqlInsertStatement* sql_insert_statement_val (SqlInsertStatement* self, const gchar* col_name, const gchar* col_value);
gint64 sql_insert_statement_run (SqlInsertStatement* self);
static void user_counter_finalize (GObject* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);


UserInfo* user_info_construct (GType object_type) {
	UserInfo* self = NULL;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self = (UserInfo*) g_type_create_instance (object_type);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return self;
#line 203 "UserCounter.c"
}


UserInfo* user_info_new (void) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return user_info_construct (TYPE_USER_INFO);
#line 210 "UserCounter.c"
}


static void value_user_info_init (GValue* value) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	value->data[0].v_pointer = NULL;
#line 217 "UserCounter.c"
}


static void value_user_info_free_value (GValue* value) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		user_info_unref (value->data[0].v_pointer);
#line 226 "UserCounter.c"
	}
}


static void value_user_info_copy_value (const GValue* src_value, GValue* dest_value) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (src_value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		dest_value->data[0].v_pointer = user_info_ref (src_value->data[0].v_pointer);
#line 236 "UserCounter.c"
	} else {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		dest_value->data[0].v_pointer = NULL;
#line 240 "UserCounter.c"
	}
}


static gpointer value_user_info_peek_pointer (const GValue* value) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return value->data[0].v_pointer;
#line 248 "UserCounter.c"
}


static gchar* value_user_info_collect_value (GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (collect_values[0].v_pointer) {
#line 255 "UserCounter.c"
		UserInfo* object;
		object = collect_values[0].v_pointer;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		if (object->parent_instance.g_class == NULL) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 262 "UserCounter.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 266 "UserCounter.c"
		}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = user_info_ref (object);
#line 270 "UserCounter.c"
	} else {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = NULL;
#line 274 "UserCounter.c"
	}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return NULL;
#line 278 "UserCounter.c"
}


static gchar* value_user_info_lcopy_value (const GValue* value, guint n_collect_values, GTypeCValue* collect_values, guint collect_flags) {
	UserInfo** object_p;
	object_p = collect_values[0].v_pointer;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (!object_p) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 289 "UserCounter.c"
	}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (!value->data[0].v_pointer) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		*object_p = NULL;
#line 295 "UserCounter.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		*object_p = value->data[0].v_pointer;
#line 299 "UserCounter.c"
	} else {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		*object_p = user_info_ref (value->data[0].v_pointer);
#line 303 "UserCounter.c"
	}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return NULL;
#line 307 "UserCounter.c"
}


GParamSpec* param_spec_user_info (const gchar* name, const gchar* nick, const gchar* blurb, GType object_type, GParamFlags flags) {
	ParamSpecUserInfo* spec;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_USER_INFO), NULL);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return G_PARAM_SPEC (spec);
#line 321 "UserCounter.c"
}


gpointer value_get_user_info (const GValue* value) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_USER_INFO), NULL);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return value->data[0].v_pointer;
#line 330 "UserCounter.c"
}


void value_set_user_info (GValue* value, gpointer v_object) {
	UserInfo* old;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_USER_INFO));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	old = value->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (v_object) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_USER_INFO));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = v_object;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		user_info_ref (value->data[0].v_pointer);
#line 350 "UserCounter.c"
	} else {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = NULL;
#line 354 "UserCounter.c"
	}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (old) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		user_info_unref (old);
#line 360 "UserCounter.c"
	}
}


void value_take_user_info (GValue* value, gpointer v_object) {
	UserInfo* old;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_USER_INFO));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	old = value->data[0].v_pointer;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (v_object) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_USER_INFO));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = v_object;
#line 379 "UserCounter.c"
	} else {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		value->data[0].v_pointer = NULL;
#line 383 "UserCounter.c"
	}
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (old) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		user_info_unref (old);
#line 389 "UserCounter.c"
	}
}


static void user_info_class_init (UserInfoClass * klass) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	user_info_parent_class = g_type_class_peek_parent (klass);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	USER_INFO_CLASS (klass)->finalize = user_info_finalize;
#line 399 "UserCounter.c"
}


static void user_info_instance_init (UserInfo * self) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->ref_count = 1;
#line 406 "UserCounter.c"
}


static void user_info_finalize (UserInfo* obj) {
	UserInfo * self;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_INFO, UserInfo);
#line 31 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_free0 (self->screen_name);
#line 32 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_free0 (self->name);
#line 418 "UserCounter.c"
}


GType user_info_get_type (void) {
	static volatile gsize user_info_type_id__volatile = 0;
	if (g_once_init_enter (&user_info_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_user_info_init, value_user_info_free_value, value_user_info_copy_value, value_user_info_peek_pointer, "p", value_user_info_collect_value, "p", value_user_info_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UserInfoClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_info_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserInfo), 0, (GInstanceInitFunc) user_info_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType user_info_type_id;
		user_info_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UserInfo", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&user_info_type_id__volatile, user_info_type_id);
	}
	return user_info_type_id__volatile;
}


gpointer user_info_ref (gpointer instance) {
	UserInfo* self;
	self = instance;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_atomic_int_inc (&self->ref_count);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return instance;
#line 443 "UserCounter.c"
}


void user_info_unref (gpointer instance) {
	UserInfo* self;
	self = instance;
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		USER_INFO_GET_CLASS (self)->finalize (self);
#line 29 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 456 "UserCounter.c"
	}
}


UserCounter* user_counter_construct (GType object_type) {
	UserCounter * self = NULL;
#line 42 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self = (UserCounter*) g_object_new (object_type, NULL);
#line 42 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return self;
#line 467 "UserCounter.c"
}


UserCounter* user_counter_new (void) {
#line 42 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return user_counter_construct (TYPE_USER_COUNTER);
#line 474 "UserCounter.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return self ? g_object_ref (self) : NULL;
#line 481 "UserCounter.c"
}


void user_counter_user_seen (UserCounter* self, gint64 id, const gchar* screen_name, const gchar* name) {
	gboolean found = FALSE;
	gboolean _tmp19_ = FALSE;
#line 44 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (IS_USER_COUNTER (self));
#line 44 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (screen_name != NULL);
#line 44 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (name != NULL);
#line 46 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	found = FALSE;
#line 47 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->priv->changed = TRUE;
#line 498 "UserCounter.c"
	{
		GeeArrayList* _ui_list = NULL;
		GeeArrayList* _tmp0_ = NULL;
		GeeArrayList* _tmp1_ = NULL;
		gint _ui_size = 0;
		GeeArrayList* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _ui_index = 0;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp0_ = self->priv->names;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_list = _tmp1_;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp2_ = _ui_list;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp3_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEE_TYPE_COLLECTION, GeeCollection));
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp4_ = _tmp3_;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_size = _tmp4_;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_index = -1;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		while (TRUE) {
#line 526 "UserCounter.c"
			gint _tmp5_ = 0;
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			UserInfo* ui = NULL;
			GeeArrayList* _tmp8_ = NULL;
			gint _tmp9_ = 0;
			gpointer _tmp10_ = NULL;
			UserInfo* _tmp11_ = NULL;
			gint64 _tmp12_ = 0LL;
			gint64 _tmp13_ = 0LL;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp5_ = _ui_index;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_ui_index = _tmp5_ + 1;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp6_ = _ui_index;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp7_ = _ui_size;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				break;
#line 549 "UserCounter.c"
			}
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp8_ = _ui_list;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp9_ = _ui_index;
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp10_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp9_);
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			ui = (UserInfo*) _tmp10_;
#line 49 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp11_ = ui;
#line 49 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp12_ = _tmp11_->id;
#line 49 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp13_ = id;
#line 49 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (_tmp12_ == _tmp13_) {
#line 567 "UserCounter.c"
				UserInfo* _tmp14_ = NULL;
				gint _tmp15_ = 0;
				UserInfo* _tmp16_ = NULL;
				gint _tmp17_ = 0;
				UserInfo* _tmp18_ = NULL;
#line 50 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				found = TRUE;
#line 51 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp14_ = ui;
#line 51 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp15_ = _tmp14_->score;
#line 51 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp14_->score = _tmp15_ + 1;
#line 52 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp16_ = ui;
#line 52 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp17_ = _tmp16_->score;
#line 52 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				g_message ("UserCounter.vala:52: New score: %d", _tmp17_);
#line 53 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp18_ = ui;
#line 53 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp18_->changed = TRUE;
#line 54 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_user_info_unref0 (ui);
#line 54 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				break;
#line 595 "UserCounter.c"
			}
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_user_info_unref0 (ui);
#line 599 "UserCounter.c"
		}
#line 48 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_g_object_unref0 (_ui_list);
#line 603 "UserCounter.c"
	}
#line 58 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp19_ = found;
#line 58 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (!_tmp19_) {
#line 609 "UserCounter.c"
		UserInfo* ui = NULL;
		UserInfo* _tmp20_ = NULL;
		UserInfo* _tmp21_ = NULL;
		gint64 _tmp22_ = 0LL;
		UserInfo* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		UserInfo* _tmp26_ = NULL;
		const gchar* _tmp27_ = NULL;
		gchar* _tmp28_ = NULL;
		UserInfo* _tmp29_ = NULL;
		UserInfo* _tmp30_ = NULL;
		GeeArrayList* _tmp31_ = NULL;
		UserInfo* _tmp32_ = NULL;
#line 59 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp20_ = user_info_new ();
#line 59 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		ui = _tmp20_;
#line 60 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp21_ = ui;
#line 60 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp22_ = id;
#line 60 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp21_->id = _tmp22_;
#line 61 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp23_ = ui;
#line 61 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp24_ = screen_name;
#line 61 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp25_ = g_strdup (_tmp24_);
#line 61 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_g_free0 (_tmp23_->screen_name);
#line 61 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp23_->screen_name = _tmp25_;
#line 62 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp26_ = ui;
#line 62 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp27_ = name;
#line 62 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp28_ = g_strdup (_tmp27_);
#line 62 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_g_free0 (_tmp26_->name);
#line 62 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp26_->name = _tmp28_;
#line 63 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp29_ = ui;
#line 63 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp29_->changed = TRUE;
#line 64 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp30_ = ui;
#line 64 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp30_->score = 1;
#line 65 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp31_ = self->priv->names;
#line 65 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp32_ = ui;
#line 65 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _tmp32_);
#line 58 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_user_info_unref0 (ui);
#line 670 "UserCounter.c"
	}
}


static gpointer _user_info_ref0 (gpointer self) {
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return self ? user_info_ref (self) : NULL;
#line 678 "UserCounter.c"
}


UserInfo** user_counter_query_by_prefix (UserCounter* self, const gchar* prefix, gint max_results, gint* num_results, int* result_length1) {
	gint _vala_num_results = 0;
	UserInfo** result = NULL;
	gint n_results = 0;
	gchar* p = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	UserInfo** results = NULL;
	gint _tmp2_ = 0;
	UserInfo** _tmp3_ = NULL;
	gint results_length1 = 0;
	gint _results_size_ = 0;
	gint _tmp36_ = 0;
	UserInfo** _tmp37_ = NULL;
	gint _tmp37__length1 = 0;
#line 69 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_val_if_fail (IS_USER_COUNTER (self), NULL);
#line 69 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_val_if_fail (prefix != NULL, NULL);
#line 70 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	n_results = 0;
#line 71 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp0_ = prefix;
#line 71 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp1_ = g_utf8_strdown (_tmp0_, (gssize) (-1));
#line 71 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	p = _tmp1_;
#line 72 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp2_ = max_results;
#line 72 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp3_ = g_new0 (UserInfo*, _tmp2_ + 1);
#line 72 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	results = _tmp3_;
#line 72 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	results_length1 = _tmp2_;
#line 72 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_results_size_ = results_length1;
#line 719 "UserCounter.c"
	{
		GeeArrayList* _ui_list = NULL;
		GeeArrayList* _tmp4_ = NULL;
		GeeArrayList* _tmp5_ = NULL;
		gint _ui_size = 0;
		GeeArrayList* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		gint _ui_index = 0;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp4_ = self->priv->names;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_list = _tmp5_;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp6_ = _ui_list;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp7_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp8_ = _tmp7_;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_size = _tmp8_;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_index = -1;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		while (TRUE) {
#line 747 "UserCounter.c"
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
			UserInfo* ui = NULL;
			GeeArrayList* _tmp12_ = NULL;
			gint _tmp13_ = 0;
			gpointer _tmp14_ = NULL;
			gboolean _tmp15_ = FALSE;
			UserInfo* _tmp16_ = NULL;
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			gchar* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			gboolean _tmp21_ = FALSE;
			gboolean _tmp22_ = FALSE;
			gboolean _tmp29_ = FALSE;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp9_ = _ui_index;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_ui_index = _tmp9_ + 1;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp10_ = _ui_index;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp11_ = _ui_size;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				break;
#line 776 "UserCounter.c"
			}
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp12_ = _ui_list;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp13_ = _ui_index;
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp14_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp13_);
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			ui = (UserInfo*) _tmp14_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp16_ = ui;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp17_ = _tmp16_->name;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp18_ = g_utf8_strdown (_tmp17_, (gssize) (-1));
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp19_ = _tmp18_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp20_ = p;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp21_ = g_str_has_prefix (_tmp19_, _tmp20_);
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp22_ = _tmp21_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_g_free0 (_tmp19_);
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (_tmp22_) {
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp15_ = TRUE;
#line 806 "UserCounter.c"
			} else {
				UserInfo* _tmp23_ = NULL;
				const gchar* _tmp24_ = NULL;
				gchar* _tmp25_ = NULL;
				gchar* _tmp26_ = NULL;
				const gchar* _tmp27_ = NULL;
				gboolean _tmp28_ = FALSE;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp23_ = ui;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp24_ = _tmp23_->screen_name;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp25_ = g_utf8_strdown (_tmp24_, (gssize) (-1));
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp26_ = _tmp25_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp27_ = p;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp28_ = g_str_has_prefix (_tmp26_, _tmp27_);
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp15_ = _tmp28_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_g_free0 (_tmp26_);
#line 830 "UserCounter.c"
			}
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp29_ = _tmp15_;
#line 74 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (_tmp29_) {
#line 836 "UserCounter.c"
				UserInfo** _tmp30_ = NULL;
				gint _tmp30__length1 = 0;
				gint _tmp31_ = 0;
				UserInfo* _tmp32_ = NULL;
				UserInfo* _tmp33_ = NULL;
				UserInfo* _tmp34_ = NULL;
				gint _tmp35_ = 0;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp30_ = results;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp30__length1 = results_length1;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp31_ = n_results;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp32_ = ui;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp33_ = _user_info_ref0 (_tmp32_);
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_user_info_unref0 (_tmp30_[_tmp31_]);
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp30_[_tmp31_] = _tmp33_;
#line 75 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp34_ = _tmp30_[_tmp31_];
#line 76 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_tmp35_ = n_results;
#line 76 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				n_results = _tmp35_ + 1;
#line 864 "UserCounter.c"
			}
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_user_info_unref0 (ui);
#line 868 "UserCounter.c"
		}
#line 73 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_g_object_unref0 (_ui_list);
#line 872 "UserCounter.c"
	}
#line 79 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp36_ = n_results;
#line 79 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_vala_num_results = _tmp36_;
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp37_ = results;
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp37__length1 = results_length1;
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (result_length1) {
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		*result_length1 = _tmp37__length1;
#line 886 "UserCounter.c"
	}
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	result = _tmp37_;
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_free0 (p);
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (num_results) {
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		*num_results = _vala_num_results;
#line 896 "UserCounter.c"
	}
#line 80 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return result;
#line 900 "UserCounter.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
#line 603 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 918 "UserCounter.c"
}


static gboolean __lambda4_ (UserCounter* self, gchar** vals, int vals_length1) {
	gboolean result = FALSE;
	UserInfo* ui = NULL;
	UserInfo* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gint _tmp1__length1 = 0;
	const gchar* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
	gchar** _tmp4_ = NULL;
	gint _tmp4__length1 = 0;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar** _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar** _tmp10_ = NULL;
	gint _tmp10__length1 = 0;
	const gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	GeeArrayList* _tmp13_ = NULL;
#line 85 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp0_ = user_info_new ();
#line 85 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui = _tmp0_;
#line 86 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp1_ = vals;
#line 86 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp1__length1 = vals_length1;
#line 86 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp2_ = _tmp1_[0];
#line 86 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp3_ = int64_parse (_tmp2_);
#line 86 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui->id = _tmp3_;
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp4_ = vals;
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp4__length1 = vals_length1;
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp5_ = _tmp4_[1];
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_free0 (ui->screen_name);
#line 87 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui->screen_name = _tmp6_;
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp7_ = vals;
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp7__length1 = vals_length1;
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp8_ = _tmp7_[2];
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_free0 (ui->name);
#line 88 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui->name = _tmp9_;
#line 89 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui->changed = FALSE;
#line 90 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp10_ = vals;
#line 90 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp10__length1 = vals_length1;
#line 90 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp11_ = _tmp10_[3];
#line 90 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp12_ = atoi (_tmp11_);
#line 90 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	ui->score = _tmp12_;
#line 91 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp13_ = self->priv->names;
#line 91 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), ui);
#line 92 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	result = TRUE;
#line 92 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_user_info_unref0 (ui);
#line 92 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return result;
#line 1003 "UserCounter.c"
}


static gboolean ___lambda4__sql_select_callback (gchar** vals, int vals_length1, gpointer self) {
	gboolean result;
	result = __lambda4_ (self, vals, vals_length1);
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	return result;
#line 1012 "UserCounter.c"
}


void user_counter_load (UserCounter* self, SqlDatabase* db) {
	SqlDatabase* _tmp0_ = NULL;
	SqlSelectStatement* _tmp1_ = NULL;
	SqlSelectStatement* _tmp2_ = NULL;
	SqlSelectStatement* _tmp3_ = NULL;
	SqlSelectStatement* _tmp4_ = NULL;
	SqlSelectStatement* _tmp5_ = NULL;
	SqlSelectStatement* _tmp6_ = NULL;
#line 83 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (IS_USER_COUNTER (self));
#line 83 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (SQL_IS_DATABASE (db));
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp0_ = db;
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp1_ = sql_database_select (_tmp0_, "user_cache");
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp2_ = _tmp1_;
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp3_ = sql_select_statement_cols (_tmp2_, "id", "screen_name", "user_name", "score", NULL);
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp4_ = _tmp3_;
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp5_ = sql_select_statement_order (_tmp4_, "score");
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp6_ = _tmp5_;
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	sql_select_statement_run (_tmp6_, ___lambda4__sql_select_callback, self);
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_sql_select_statement_unref0 (_tmp6_);
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_sql_select_statement_unref0 (_tmp4_);
#line 84 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_sql_select_statement_unref0 (_tmp2_);
#line 1050 "UserCounter.c"
}


void user_counter_save (UserCounter* self, SqlDatabase* db) {
	gboolean _tmp0_ = FALSE;
#line 96 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (IS_USER_COUNTER (self));
#line 96 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_return_if_fail (SQL_IS_DATABASE (db));
#line 97 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp0_ = self->priv->changed;
#line 97 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	if (!_tmp0_) {
#line 98 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		return;
#line 1066 "UserCounter.c"
	}
	{
		GeeArrayList* _ui_list = NULL;
		GeeArrayList* _tmp1_ = NULL;
		GeeArrayList* _tmp2_ = NULL;
		gint _ui_size = 0;
		GeeArrayList* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _ui_index = 0;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp1_ = self->priv->names;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_list = _tmp2_;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp3_ = _ui_list;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp4_ = gee_abstract_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_COLLECTION, GeeCollection));
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_tmp5_ = _tmp4_;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_size = _tmp5_;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_ui_index = -1;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		while (TRUE) {
#line 1095 "UserCounter.c"
			gint _tmp6_ = 0;
			gint _tmp7_ = 0;
			gint _tmp8_ = 0;
			UserInfo* ui = NULL;
			GeeArrayList* _tmp9_ = NULL;
			gint _tmp10_ = 0;
			gpointer _tmp11_ = NULL;
			UserInfo* _tmp12_ = NULL;
			gboolean _tmp13_ = FALSE;
			UserInfo* _tmp14_ = NULL;
			SqlDatabase* _tmp15_ = NULL;
			SqlInsertStatement* _tmp16_ = NULL;
			SqlInsertStatement* _tmp17_ = NULL;
			UserInfo* _tmp18_ = NULL;
			gint64 _tmp19_ = 0LL;
			SqlInsertStatement* _tmp20_ = NULL;
			SqlInsertStatement* _tmp21_ = NULL;
			UserInfo* _tmp22_ = NULL;
			gint _tmp23_ = 0;
			SqlInsertStatement* _tmp24_ = NULL;
			SqlInsertStatement* _tmp25_ = NULL;
			UserInfo* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			SqlInsertStatement* _tmp28_ = NULL;
			SqlInsertStatement* _tmp29_ = NULL;
			UserInfo* _tmp30_ = NULL;
			const gchar* _tmp31_ = NULL;
			SqlInsertStatement* _tmp32_ = NULL;
			SqlInsertStatement* _tmp33_ = NULL;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp6_ = _ui_index;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_ui_index = _tmp6_ + 1;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp7_ = _ui_index;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp8_ = _ui_size;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				break;
#line 1137 "UserCounter.c"
			}
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp9_ = _ui_list;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp10_ = _ui_index;
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp11_ = gee_abstract_list_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), _tmp10_);
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			ui = (UserInfo*) _tmp11_;
#line 101 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp12_ = ui;
#line 101 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp13_ = _tmp12_->changed;
#line 101 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			if (!_tmp13_) {
#line 102 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				_user_info_unref0 (ui);
#line 102 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
				continue;
#line 1157 "UserCounter.c"
			}
#line 103 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp14_ = ui;
#line 103 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp14_->changed = TRUE;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp15_ = db;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp16_ = sql_database_replace (_tmp15_, "user_cache");
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp17_ = _tmp16_;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp18_ = ui;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp19_ = _tmp18_->id;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp20_ = sql_insert_statement_vali64 (_tmp17_, "id", _tmp19_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp21_ = _tmp20_;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp22_ = ui;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp23_ = _tmp22_->score;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp24_ = sql_insert_statement_vali (_tmp21_, "score", _tmp23_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp25_ = _tmp24_;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp26_ = ui;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp27_ = _tmp26_->screen_name;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp28_ = sql_insert_statement_val (_tmp25_, "screen_name", _tmp27_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp29_ = _tmp28_;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp30_ = ui;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp31_ = _tmp30_->name;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp32_ = sql_insert_statement_val (_tmp29_, "user_name", _tmp31_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_tmp33_ = _tmp32_;
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			sql_insert_statement_run (_tmp33_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_sql_insert_statement_unref0 (_tmp33_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_sql_insert_statement_unref0 (_tmp29_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_sql_insert_statement_unref0 (_tmp25_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_sql_insert_statement_unref0 (_tmp21_);
#line 104 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_sql_insert_statement_unref0 (_tmp17_);
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
			_user_info_unref0 (ui);
#line 1215 "UserCounter.c"
		}
#line 100 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
		_g_object_unref0 (_ui_list);
#line 1219 "UserCounter.c"
	}
#line 110 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->priv->changed = FALSE;
#line 1223 "UserCounter.c"
}


static void user_counter_class_init (UserCounterClass * klass) {
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	user_counter_parent_class = g_type_class_peek_parent (klass);
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	g_type_class_add_private (klass, sizeof (UserCounterPrivate));
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	G_OBJECT_CLASS (klass)->finalize = user_counter_finalize;
#line 1234 "UserCounter.c"
}


static void user_counter_instance_init (UserCounter * self) {
	GeeArrayList* _tmp0_ = NULL;
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->priv = USER_COUNTER_GET_PRIVATE (self);
#line 39 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->priv->changed = FALSE;
#line 40 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_tmp0_ = gee_array_list_new (TYPE_USER_INFO, (GBoxedCopyFunc) user_info_ref, user_info_unref, NULL, NULL, NULL);
#line 40 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self->priv->names = _tmp0_;
#line 1248 "UserCounter.c"
}


static void user_counter_finalize (GObject* obj) {
	UserCounter * self;
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_COUNTER, UserCounter);
#line 40 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	_g_object_unref0 (self->priv->names);
#line 38 "/builddir/build/BUILD/corebird/src/UserCounter.vala"
	G_OBJECT_CLASS (user_counter_parent_class)->finalize (obj);
#line 1260 "UserCounter.c"
}


GType user_counter_get_type (void) {
	static volatile gsize user_counter_type_id__volatile = 0;
	if (g_once_init_enter (&user_counter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserCounterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_counter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserCounter), 0, (GInstanceInitFunc) user_counter_instance_init, NULL };
		GType user_counter_type_id;
		user_counter_type_id = g_type_register_static (G_TYPE_OBJECT, "UserCounter", &g_define_type_info, 0);
		g_once_init_leave (&user_counter_type_id__volatile, user_counter_type_id);
	}
	return user_counter_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



