/* UserStream.c generated by valac 0.22.0, the Vala compiler
 * generated from UserStream.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */
/* See https://dev.twitter.com/docs/streaming-apis/messages*/

#include <glib.h>
#include <glib-object.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy-call.h>
#include <json-glib/json-glib.h>
#include <stdlib.h>
#include <string.h>
#include <rest/rest-proxy.h>


#define TYPE_STREAM_MESSAGE_TYPE (stream_message_type_get_type ())

#define TYPE_USER_STREAM (user_stream_get_type ())
#define USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_USER_STREAM, UserStream))
#define USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_USER_STREAM, UserStreamClass))
#define IS_USER_STREAM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_USER_STREAM))
#define IS_USER_STREAM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_USER_STREAM))
#define USER_STREAM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_USER_STREAM, UserStreamClass))

typedef struct _UserStream UserStream;
typedef struct _UserStreamClass UserStreamClass;
typedef struct _UserStreamPrivate UserStreamPrivate;

#define TYPE_IMESSAGE_RECEIVER (imessage_receiver_get_type ())
#define IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiver))
#define IS_IMESSAGE_RECEIVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMESSAGE_RECEIVER))
#define IMESSAGE_RECEIVER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_IMESSAGE_RECEIVER, IMessageReceiverIface))

typedef struct _IMessageReceiver IMessageReceiver;
typedef struct _IMessageReceiverIface IMessageReceiverIface;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_slist_free0(var) ((var == NULL) ? NULL : (var = (g_slist_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

typedef enum  {
	STREAM_MESSAGE_TYPE_DELETE,
	STREAM_MESSAGE_TYPE_SCRUB_GEO,
	STREAM_MESSAGE_TYPE_LIMIT,
	STREAM_MESSAGE_TYPE_DISCONNECT,
	STREAM_MESSAGE_TYPE_FRIENDS,
	STREAM_MESSAGE_TYPE_EVENT,
	STREAM_MESSAGE_TYPE_WARNING,
	STREAM_MESSAGE_TYPE_FOLLOW,
	STREAM_MESSAGE_TYPE_DIRECT_MESSAGE,
	STREAM_MESSAGE_TYPE_TWEET
} StreamMessageType;

struct _UserStream {
	GObject parent_instance;
	UserStreamPrivate * priv;
};

struct _UserStreamClass {
	GObjectClass parent_class;
};

struct _IMessageReceiverIface {
	GTypeInterface parent_iface;
	void (*stream_message_received) (IMessageReceiver* self, StreamMessageType type, JsonNode* root_node);
};

struct _UserStreamPrivate {
	OAuthProxy* proxy;
	RestProxyCall* proxy_call;
	GString* data;
	GSList* receivers;
	guint timeout_id;
	gchar* account_name;
};


static gpointer user_stream_parent_class = NULL;

GType stream_message_type_get_type (void) G_GNUC_CONST;
GType user_stream_get_type (void) G_GNUC_CONST;
GType imessage_receiver_get_type (void) G_GNUC_CONST;
#define USER_STREAM_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_USER_STREAM, UserStreamPrivate))
enum  {
	USER_STREAM_DUMMY_PROPERTY,
	USER_STREAM_TOKEN,
	USER_STREAM_TOKEN_SECRET
};
#define USER_STREAM_TIMEOUT_INTERVAL (45 * 1000)
UserStream* user_stream_new (const gchar* account_name);
UserStream* user_stream_construct (GType object_type, const gchar* account_name);
gchar* utils_decode (const gchar* source);
#define UTILS_CONSUMER_KEY "MHJ2SExkYnpSVUxaZDVkejZYMVRVQQ=="
#define UTILS_CONSUMER_SECRET "b0dydmQ2NjU0bldMaHpMY0p5d1NXM3BsdFVma2hQNEJucmFQUFZOaEh0WQ=="
void user_stream_register (UserStream* self, IMessageReceiver* receiver);
void user_stream_start (UserStream* self);
static void user_stream_parse_data_cb (UserStream* self, RestProxyCall* call, const gchar* buf, gsize length, GError* _error_);
static void _user_stream_parse_data_cb_rest_proxy_call_continuous_callback (RestProxyCall* call, const gchar* buf, gsize len, GError* _error_, GObject* weak_object, gpointer self);
void user_stream_stop (UserStream* self);
static gboolean user_stream_timeout_cb (UserStream* self);
static gboolean _user_stream_timeout_cb_gsource_func (gpointer self);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
void imessage_receiver_stream_message_received (IMessageReceiver* self, StreamMessageType type, JsonNode* root_node);
static void _vala_JsonNode_free (JsonNode* self);
void user_stream_set_token (UserStream* self, const gchar* value);
void user_stream_set_token_secret (UserStream* self, const gchar* value);
static void user_stream_finalize (GObject* obj);
static void _vala_user_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


GType stream_message_type_get_type (void) {
	static volatile gsize stream_message_type_type_id__volatile = 0;
	if (g_once_init_enter (&stream_message_type_type_id__volatile)) {
		static const GEnumValue values[] = {{STREAM_MESSAGE_TYPE_DELETE, "STREAM_MESSAGE_TYPE_DELETE", "delete"}, {STREAM_MESSAGE_TYPE_SCRUB_GEO, "STREAM_MESSAGE_TYPE_SCRUB_GEO", "scrub-geo"}, {STREAM_MESSAGE_TYPE_LIMIT, "STREAM_MESSAGE_TYPE_LIMIT", "limit"}, {STREAM_MESSAGE_TYPE_DISCONNECT, "STREAM_MESSAGE_TYPE_DISCONNECT", "disconnect"}, {STREAM_MESSAGE_TYPE_FRIENDS, "STREAM_MESSAGE_TYPE_FRIENDS", "friends"}, {STREAM_MESSAGE_TYPE_EVENT, "STREAM_MESSAGE_TYPE_EVENT", "event"}, {STREAM_MESSAGE_TYPE_WARNING, "STREAM_MESSAGE_TYPE_WARNING", "warning"}, {STREAM_MESSAGE_TYPE_FOLLOW, "STREAM_MESSAGE_TYPE_FOLLOW", "follow"}, {STREAM_MESSAGE_TYPE_DIRECT_MESSAGE, "STREAM_MESSAGE_TYPE_DIRECT_MESSAGE", "direct-message"}, {STREAM_MESSAGE_TYPE_TWEET, "STREAM_MESSAGE_TYPE_TWEET", "tweet"}, {0, NULL, NULL}};
		GType stream_message_type_type_id;
		stream_message_type_type_id = g_enum_register_static ("StreamMessageType", values);
		g_once_init_leave (&stream_message_type_type_id__volatile, stream_message_type_type_id);
	}
	return stream_message_type_type_id__volatile;
}


UserStream* user_stream_construct (GType object_type, const gchar* account_name) {
	UserStream * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
	OAuthProxy* _tmp9_ = NULL;
#line 52 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_val_if_fail (account_name != NULL, NULL);
#line 52 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self = (UserStream*) g_object_new (object_type, NULL);
#line 53 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = account_name;
#line 53 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 53 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (self->priv->account_name);
#line 53 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->account_name = _tmp1_;
#line 54 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp2_ = account_name;
#line 54 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp3_ = g_strconcat ("CREATING USER STREAM FOR ", _tmp2_, NULL);
#line 54 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp4_ = _tmp3_;
#line 54 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_message ("UserStream.vala:54: %s", _tmp4_);
#line 54 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (_tmp4_);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp5_ = utils_decode (UTILS_CONSUMER_KEY);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp6_ = _tmp5_;
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp7_ = utils_decode (UTILS_CONSUMER_SECRET);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp8_ = _tmp7_;
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp9_ = (OAuthProxy*) oauth_proxy_new (_tmp6_, _tmp8_, "https://userstream.twitter.com/", FALSE);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->proxy = _tmp9_;
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (_tmp8_);
#line 55 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (_tmp6_);
#line 52 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return self;
#line 197 "UserStream.c"
}


UserStream* user_stream_new (const gchar* account_name) {
#line 52 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return user_stream_construct (TYPE_USER_STREAM, account_name);
#line 204 "UserStream.c"
}


void user_stream_register (UserStream* self, IMessageReceiver* receiver) {
	IMessageReceiver* _tmp0_ = NULL;
#line 64 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 64 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_IMESSAGE_RECEIVER (receiver));
#line 65 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = receiver;
#line 65 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->receivers = g_slist_append (self->priv->receivers, _tmp0_);
#line 218 "UserStream.c"
}


/**
   * Starts the UserStream
   */
static void _user_stream_parse_data_cb_rest_proxy_call_continuous_callback (RestProxyCall* call, const gchar* buf, gsize len, GError* _error_, GObject* weak_object, gpointer self) {
#line 78 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	user_stream_parse_data_cb (self, call, buf, len, _error_);
#line 228 "UserStream.c"
}


void user_stream_start (UserStream* self) {
	OAuthProxy* _tmp0_ = NULL;
	RestProxyCall* _tmp1_ = NULL;
	RestProxyCall* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 73 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 74 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 74 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, rest_proxy_get_type (), RestProxy));
#line 74 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy_call);
#line 74 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->proxy_call = _tmp1_;
#line 75 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp2_ = self->priv->proxy_call;
#line 75 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	rest_proxy_call_set_function (_tmp2_, "1.1/user.json");
#line 76 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp3_ = self->priv->proxy_call;
#line 76 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	rest_proxy_call_set_method (_tmp3_, "GET");
#line 256 "UserStream.c"
	{
		RestProxyCall* _tmp4_ = NULL;
		RestProxyCall* _tmp5_ = NULL;
#line 78 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp4_ = self->priv->proxy_call;
#line 78 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp5_ = self->priv->proxy_call;
#line 78 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		rest_proxy_call_continuous (_tmp4_, _user_stream_parse_data_cb_rest_proxy_call_continuous_callback, G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, G_TYPE_OBJECT, GObject), self, &_inner_error_);
#line 78 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		if (_inner_error_ != NULL) {
#line 268 "UserStream.c"
			goto __catch40_g_error;
		}
	}
	goto __finally40;
	__catch40_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp6_ = NULL;
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		e = _inner_error_;
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_inner_error_ = NULL;
#line 80 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp6_ = e->message;
#line 80 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_error ("UserStream.vala:80: %s", _tmp6_);
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_g_error_free0 (e);
#line 287 "UserStream.c"
	}
	__finally40:
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	if (_inner_error_ != NULL) {
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_clear_error (&_inner_error_);
#line 77 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		return;
#line 298 "UserStream.c"
	}
}


/**
   * Stops the UserStream
   */
void user_stream_stop (UserStream* self) {
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	RestProxyCall* _tmp3_ = NULL;
	guint _tmp4_ = 0U;
#line 91 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 92 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = self->priv->account_name;
#line 92 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = g_strconcat ("STOPPING STREAM FOR ", _tmp0_, NULL);
#line 92 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp2_ = _tmp1_;
#line 92 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_message ("UserStream.vala:92: %s", _tmp2_);
#line 92 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (_tmp2_);
#line 93 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp3_ = self->priv->proxy_call;
#line 93 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	rest_proxy_call_cancel (_tmp3_);
#line 94 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp4_ = self->priv->timeout_id;
#line 94 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	if (_tmp4_ != ((guint) (-1))) {
#line 332 "UserStream.c"
		guint _tmp5_ = 0U;
#line 95 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp5_ = self->priv->timeout_id;
#line 95 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_source_remove (_tmp5_);
#line 338 "UserStream.c"
	}
}


/**
   * The timeout cb is called whenever we didn't get a heartbeat
   * from Twitter for over TIMEOUT_INTERVAL seconds.
   *
   */
static gboolean user_stream_timeout_cb (UserStream* self) {
	gboolean result = FALSE;
#line 103 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_val_if_fail (IS_USER_STREAM (self), FALSE);
#line 104 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_message ("UserStream.vala:104: Restarting...");
#line 106 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	result = FALSE;
#line 106 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return result;
#line 358 "UserStream.c"
}


/**
   * Callback called by the Rest.ProxyCall whenever it receives data.
   *
   * @param call The Rest.ProxyCall created when the UserStream was started.
   * @param buf The string received
   * @param length The buffer's length
   * @param error
   */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 389 "UserStream.c"
		glong _tmp4_ = 0L;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 397 "UserStream.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 409 "UserStream.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
#line 1167 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 434 "UserStream.c"
		glong _tmp2_ = 0L;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 440 "UserStream.c"
	} else {
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 444 "UserStream.c"
	}
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 450 "UserStream.c"
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 462 "UserStream.c"
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 472 "UserStream.c"
	}
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 478 "UserStream.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 492 "UserStream.c"
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 502 "UserStream.c"
	}
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 508 "UserStream.c"
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 517 "UserStream.c"
	}
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 537 "UserStream.c"
}


static gboolean _user_stream_timeout_cb_gsource_func (gpointer self) {
	gboolean result;
	result = user_stream_timeout_cb (self);
#line 133 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return result;
#line 546 "UserStream.c"
}


static JsonNode* _vala_JsonNode_copy (JsonNode* self) {
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 553 "UserStream.c"
}


static gpointer __vala_JsonNode_copy0 (gpointer self) {
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 560 "UserStream.c"
}


static gpointer _json_object_ref0 (gpointer self) {
#line 149 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return self ? json_object_ref (self) : NULL;
#line 567 "UserStream.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	return self ? g_object_ref (self) : NULL;
#line 574 "UserStream.c"
}


static void _vala_JsonNode_free (JsonNode* self) {
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_boxed_free (json_node_get_type (), self);
#line 581 "UserStream.c"
}


static void user_stream_parse_data_cb (UserStream* self, RestProxyCall* call, const gchar* buf, gsize length, GError* _error_) {
	const gchar* _tmp0_ = NULL;
	gchar* real = NULL;
	const gchar* _tmp1_ = NULL;
	gsize _tmp2_ = 0UL;
	gchar* _tmp3_ = NULL;
	GString* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp11_ = FALSE;
	GError * _inner_error_ = NULL;
#line 118 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 118 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (REST_IS_PROXY_CALL (call));
#line 120 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = buf;
#line 120 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	if (_tmp0_ == NULL) {
#line 121 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_warning ("UserStream.vala:121: buf == NULL");
#line 122 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		return;
#line 610 "UserStream.c"
	}
#line 125 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = buf;
#line 125 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp2_ = length;
#line 125 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp3_ = string_substring (_tmp1_, (glong) 0, (glong) ((gint) _tmp2_));
#line 125 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	real = _tmp3_;
#line 127 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp4_ = self->priv->data;
#line 127 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp5_ = real;
#line 127 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_string_append (_tmp4_, _tmp5_);
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp7_ = real;
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp8_ = g_str_has_suffix (_tmp7_, "\r\n");
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	if (_tmp8_) {
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp6_ = TRUE;
#line 634 "UserStream.c"
	} else {
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp9_ = real;
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp10_ = g_str_has_suffix (_tmp9_, "\r");
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp6_ = _tmp10_;
#line 644 "UserStream.c"
	}
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp11_ = _tmp6_;
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	if (_tmp11_) {
#line 650 "UserStream.c"
		guint _tmp12_ = 0U;
		guint _tmp14_ = 0U;
		const gchar* _tmp15_ = NULL;
		JsonParser* parser = NULL;
		JsonParser* _tmp17_ = NULL;
		JsonNode* root_node = NULL;
		JsonParser* _tmp23_ = NULL;
		JsonNode* _tmp24_ = NULL;
		JsonNode* _tmp25_ = NULL;
		JsonObject* root = NULL;
		JsonNode* _tmp26_ = NULL;
		JsonObject* _tmp27_ = NULL;
		JsonObject* _tmp28_ = NULL;
		StreamMessageType type = 0;
		JsonObject* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		GSList* _tmp51_ = NULL;
		GString* _tmp56_ = NULL;
#line 131 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp12_ = self->priv->timeout_id;
#line 131 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		if (_tmp12_ != ((guint) (-1))) {
#line 673 "UserStream.c"
			guint _tmp13_ = 0U;
#line 132 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp13_ = self->priv->timeout_id;
#line 132 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_source_remove (_tmp13_);
#line 679 "UserStream.c"
		}
#line 133 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp14_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) USER_STREAM_TIMEOUT_INTERVAL, _user_stream_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 133 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		self->priv->timeout_id = _tmp14_;
#line 135 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp15_ = real;
#line 135 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		if (g_strcmp0 (_tmp15_, "\r\n") == 0) {
#line 689 "UserStream.c"
			GString* _tmp16_ = NULL;
#line 136 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_message ("UserStream.vala:136: HEARTBEAT");
#line 137 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp16_ = self->priv->data;
#line 137 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_string_erase (_tmp16_, (gssize) 0, (gssize) (-1));
#line 138 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_g_free0 (real);
#line 138 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			return;
#line 701 "UserStream.c"
		}
#line 141 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp17_ = json_parser_new ();
#line 141 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		parser = _tmp17_;
#line 707 "UserStream.c"
		{
			JsonParser* _tmp18_ = NULL;
			GString* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
#line 143 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp18_ = parser;
#line 143 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp19_ = self->priv->data;
#line 143 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp20_ = _tmp19_->str;
#line 143 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			json_parser_load_from_data (_tmp18_, _tmp20_, (gssize) (-1), &_inner_error_);
#line 143 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			if (_inner_error_ != NULL) {
#line 722 "UserStream.c"
				goto __catch41_g_error;
			}
		}
		goto __finally41;
		__catch41_g_error:
		{
			GError* e = NULL;
			GError* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			e = _inner_error_;
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_inner_error_ = NULL;
#line 145 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp21_ = e;
#line 145 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp22_ = _tmp21_->message;
#line 145 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_critical ("UserStream.vala:145: %s", _tmp22_);
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_g_error_free0 (e);
#line 744 "UserStream.c"
		}
		__finally41:
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		if (_inner_error_ != NULL) {
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_g_object_unref0 (parser);
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_g_free0 (real);
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			g_clear_error (&_inner_error_);
#line 142 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			return;
#line 759 "UserStream.c"
		}
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp23_ = parser;
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp24_ = json_parser_get_root (_tmp23_);
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp25_ = __vala_JsonNode_copy0 (_tmp24_);
#line 148 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		root_node = _tmp25_;
#line 149 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp26_ = root_node;
#line 149 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp27_ = json_node_get_object (_tmp26_);
#line 149 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp28_ = _json_object_ref0 (_tmp27_);
#line 149 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		root = _tmp28_;
#line 151 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		type = 0;
#line 153 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp29_ = root;
#line 153 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp30_ = json_object_has_member (_tmp29_, "delete");
#line 153 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		if (_tmp30_) {
#line 154 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			type = STREAM_MESSAGE_TYPE_DELETE;
#line 787 "UserStream.c"
		} else {
			JsonObject* _tmp31_ = NULL;
			gboolean _tmp32_ = FALSE;
#line 155 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp31_ = root;
#line 155 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			_tmp32_ = json_object_has_member (_tmp31_, "scrub_geo");
#line 155 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			if (_tmp32_) {
#line 156 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				type = STREAM_MESSAGE_TYPE_SCRUB_GEO;
#line 799 "UserStream.c"
			} else {
				JsonObject* _tmp33_ = NULL;
				gboolean _tmp34_ = FALSE;
#line 157 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				_tmp33_ = root;
#line 157 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				_tmp34_ = json_object_has_member (_tmp33_, "limit");
#line 157 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				if (_tmp34_) {
#line 158 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					type = STREAM_MESSAGE_TYPE_LIMIT;
#line 811 "UserStream.c"
				} else {
					JsonObject* _tmp35_ = NULL;
					gboolean _tmp36_ = FALSE;
#line 159 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_tmp35_ = root;
#line 159 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_tmp36_ = json_object_has_member (_tmp35_, "disconnect");
#line 159 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					if (_tmp36_) {
#line 160 "/builddir/build/BUILD/corebird/src/UserStream.vala"
						type = STREAM_MESSAGE_TYPE_DISCONNECT;
#line 823 "UserStream.c"
					} else {
						JsonObject* _tmp37_ = NULL;
						gboolean _tmp38_ = FALSE;
#line 161 "/builddir/build/BUILD/corebird/src/UserStream.vala"
						_tmp37_ = root;
#line 161 "/builddir/build/BUILD/corebird/src/UserStream.vala"
						_tmp38_ = json_object_has_member (_tmp37_, "friends");
#line 161 "/builddir/build/BUILD/corebird/src/UserStream.vala"
						if (_tmp38_) {
#line 162 "/builddir/build/BUILD/corebird/src/UserStream.vala"
							type = STREAM_MESSAGE_TYPE_FRIENDS;
#line 835 "UserStream.c"
						} else {
							JsonObject* _tmp39_ = NULL;
							gboolean _tmp40_ = FALSE;
#line 163 "/builddir/build/BUILD/corebird/src/UserStream.vala"
							_tmp39_ = root;
#line 163 "/builddir/build/BUILD/corebird/src/UserStream.vala"
							_tmp40_ = json_object_has_member (_tmp39_, "text");
#line 163 "/builddir/build/BUILD/corebird/src/UserStream.vala"
							if (_tmp40_) {
#line 164 "/builddir/build/BUILD/corebird/src/UserStream.vala"
								type = STREAM_MESSAGE_TYPE_TWEET;
#line 847 "UserStream.c"
							} else {
								JsonObject* _tmp41_ = NULL;
								gboolean _tmp42_ = FALSE;
#line 165 "/builddir/build/BUILD/corebird/src/UserStream.vala"
								_tmp41_ = root;
#line 165 "/builddir/build/BUILD/corebird/src/UserStream.vala"
								_tmp42_ = json_object_has_member (_tmp41_, "event");
#line 165 "/builddir/build/BUILD/corebird/src/UserStream.vala"
								if (_tmp42_) {
#line 857 "UserStream.c"
									gchar* evt_str = NULL;
									JsonObject* _tmp43_ = NULL;
									const gchar* _tmp44_ = NULL;
									gchar* _tmp45_ = NULL;
									const gchar* _tmp46_ = NULL;
#line 166 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp43_ = root;
#line 166 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp44_ = json_object_get_string_member (_tmp43_, "event");
#line 166 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp45_ = g_strdup (_tmp44_);
#line 166 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									evt_str = _tmp45_;
#line 167 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp46_ = evt_str;
#line 167 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									if (g_strcmp0 (_tmp46_, "follow") == 0) {
#line 168 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										type = STREAM_MESSAGE_TYPE_FOLLOW;
#line 877 "UserStream.c"
									} else {
#line 170 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										type = STREAM_MESSAGE_TYPE_EVENT;
#line 881 "UserStream.c"
									}
#line 165 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_g_free0 (evt_str);
#line 885 "UserStream.c"
								} else {
									JsonObject* _tmp47_ = NULL;
									gboolean _tmp48_ = FALSE;
#line 172 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp47_ = root;
#line 172 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									_tmp48_ = json_object_has_member (_tmp47_, "warning");
#line 172 "/builddir/build/BUILD/corebird/src/UserStream.vala"
									if (_tmp48_) {
#line 173 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										type = STREAM_MESSAGE_TYPE_WARNING;
#line 897 "UserStream.c"
									} else {
										JsonObject* _tmp49_ = NULL;
										gboolean _tmp50_ = FALSE;
#line 174 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										_tmp49_ = root;
#line 174 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										_tmp50_ = json_object_has_member (_tmp49_, "direct_message");
#line 174 "/builddir/build/BUILD/corebird/src/UserStream.vala"
										if (_tmp50_) {
#line 175 "/builddir/build/BUILD/corebird/src/UserStream.vala"
											type = STREAM_MESSAGE_TYPE_DIRECT_MESSAGE;
#line 909 "UserStream.c"
										}
									}
								}
							}
						}
					}
				}
			}
		}
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp51_ = self->priv->receivers;
#line 921 "UserStream.c"
		{
			GSList* it_collection = NULL;
			GSList* it_it = NULL;
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			it_collection = _tmp51_;
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
			for (it_it = it_collection; it_it != NULL; it_it = it_it->next) {
#line 929 "UserStream.c"
				IMessageReceiver* _tmp52_ = NULL;
				IMessageReceiver* it = NULL;
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				_tmp52_ = _g_object_ref0 ((IMessageReceiver*) it_it->data);
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
				it = _tmp52_;
#line 936 "UserStream.c"
				{
					IMessageReceiver* _tmp53_ = NULL;
					StreamMessageType _tmp54_ = 0;
					JsonNode* _tmp55_ = NULL;
#line 183 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_tmp53_ = it;
#line 183 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_tmp54_ = type;
#line 183 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_tmp55_ = root_node;
#line 183 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					imessage_receiver_stream_message_received (_tmp53_, _tmp54_, _tmp55_);
#line 182 "/builddir/build/BUILD/corebird/src/UserStream.vala"
					_g_object_unref0 (it);
#line 951 "UserStream.c"
				}
			}
		}
#line 186 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_tmp56_ = self->priv->data;
#line 186 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		g_string_erase (_tmp56_, (gssize) 0, (gssize) (-1));
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_json_object_unref0 (root);
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		__vala_JsonNode_free0 (root_node);
#line 129 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		_g_object_unref0 (parser);
#line 965 "UserStream.c"
	}
#line 118 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (real);
#line 969 "UserStream.c"
}


void user_stream_set_token (UserStream* self, const gchar* value) {
	OAuthProxy* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 44 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 44 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 44 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = value;
#line 44 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	oauth_proxy_set_token (_tmp0_, _tmp1_);
#line 44 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_object_notify ((GObject *) self, "token");
#line 986 "UserStream.c"
}


void user_stream_set_token_secret (UserStream* self, const gchar* value) {
	OAuthProxy* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 47 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_return_if_fail (IS_USER_STREAM (self));
#line 47 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = self->priv->proxy;
#line 47 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp1_ = value;
#line 47 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	oauth_proxy_set_token_secret (_tmp0_, _tmp1_);
#line 47 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_object_notify ((GObject *) self, "token-secret");
#line 1003 "UserStream.c"
}


static void user_stream_class_init (UserStreamClass * klass) {
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	user_stream_parent_class = g_type_class_peek_parent (klass);
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_type_class_add_private (klass, sizeof (UserStreamPrivate));
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_user_stream_set_property;
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	G_OBJECT_CLASS (klass)->finalize = user_stream_finalize;
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_STREAM_TOKEN, g_param_spec_string ("token", "token", "token", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USER_STREAM_TOKEN_SECRET, g_param_spec_string ("token-secret", "token-secret", "token-secret", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE));
#line 1020 "UserStream.c"
}


static void user_stream_instance_init (UserStream * self) {
	GString* _tmp0_ = NULL;
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv = USER_STREAM_GET_PRIVATE (self);
#line 39 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_tmp0_ = g_string_new ("");
#line 39 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->data = _tmp0_;
#line 40 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->receivers = NULL;
#line 41 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self->priv->timeout_id = (guint) (-1);
#line 1036 "UserStream.c"
}


static void user_stream_finalize (GObject* obj) {
	UserStream * self;
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_USER_STREAM, UserStream);
#line 85 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	g_critical ("UserStream.vala:85: USERSTREAM DESTROYED");
#line 37 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy);
#line 38 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_object_unref0 (self->priv->proxy_call);
#line 39 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_string_free0 (self->priv->data);
#line 40 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_slist_free0 (self->priv->receivers);
#line 42 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	_g_free0 (self->priv->account_name);
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	G_OBJECT_CLASS (user_stream_parent_class)->finalize (obj);
#line 1058 "UserStream.c"
}


GType user_stream_get_type (void) {
	static volatile gsize user_stream_type_id__volatile = 0;
	if (g_once_init_enter (&user_stream_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UserStreamClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) user_stream_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UserStream), 0, (GInstanceInitFunc) user_stream_instance_init, NULL };
		GType user_stream_type_id;
		user_stream_type_id = g_type_register_static (G_TYPE_OBJECT, "UserStream", &g_define_type_info, 0);
		g_once_init_leave (&user_stream_type_id__volatile, user_stream_type_id);
	}
	return user_stream_type_id__volatile;
}


static void _vala_user_stream_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	UserStream * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_USER_STREAM, UserStream);
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
	switch (property_id) {
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		case USER_STREAM_TOKEN:
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		user_stream_set_token (self, g_value_get_string (value));
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		break;
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		case USER_STREAM_TOKEN_SECRET:
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		user_stream_set_token_secret (self, g_value_get_string (value));
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		break;
#line 1091 "UserStream.c"
		default:
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 35 "/builddir/build/BUILD/corebird/src/UserStream.vala"
		break;
#line 1097 "UserStream.c"
	}
}



