/* DMThreadEntry.c generated by valac 0.22.0, the Vala compiler
 * generated from DMThreadEntry.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gdk-pixbuf/gdk-pixbuf.h>


#define TYPE_DM_THREAD_ENTRY (dm_thread_entry_get_type ())
#define DM_THREAD_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DM_THREAD_ENTRY, DMThreadEntry))
#define DM_THREAD_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DM_THREAD_ENTRY, DMThreadEntryClass))
#define IS_DM_THREAD_ENTRY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DM_THREAD_ENTRY))
#define IS_DM_THREAD_ENTRY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DM_THREAD_ENTRY))
#define DM_THREAD_ENTRY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DM_THREAD_ENTRY, DMThreadEntryClass))

typedef struct _DMThreadEntry DMThreadEntry;
typedef struct _DMThreadEntryClass DMThreadEntryClass;
typedef struct _DMThreadEntryPrivate DMThreadEntryPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _DMThreadEntry {
	GtkListBoxRow parent_instance;
	DMThreadEntryPrivate * priv;
	gint unread_count;
};

struct _DMThreadEntryClass {
	GtkListBoxRowClass parent_class;
};

struct _DMThreadEntryPrivate {
	GtkLabel* name_label;
	GtkLabel* screen_name_label;
	GtkLabel* last_message_label;
	GtkImage* avatar_image;
	GtkLabel* unread_count_label;
	gint64 _user_id;
	gint64 _last_message_id;
};


static gpointer dm_thread_entry_parent_class = NULL;

GType dm_thread_entry_get_type (void) G_GNUC_CONST;
#define DM_THREAD_ENTRY_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_DM_THREAD_ENTRY, DMThreadEntryPrivate))
enum  {
	DM_THREAD_ENTRY_DUMMY_PROPERTY,
	DM_THREAD_ENTRY_USER_ID,
	DM_THREAD_ENTRY_NAME,
	DM_THREAD_ENTRY_SCREEN_NAME,
	DM_THREAD_ENTRY_LAST_MESSAGE,
	DM_THREAD_ENTRY_LAST_MESSAGE_ID,
	DM_THREAD_ENTRY_AVATAR
};
gboolean dm_thread_entry_equal_func (DMThreadEntry* a, DMThreadEntry* b);
gint64 dm_thread_entry_get_user_id (DMThreadEntry* self);
DMThreadEntry* dm_thread_entry_new (gint64 user_id);
DMThreadEntry* dm_thread_entry_construct (GType object_type, gint64 user_id);
static void dm_thread_entry_set_user_id (DMThreadEntry* self, gint64 value);
void dm_thread_entry_update_unread_count (DMThreadEntry* self);
const gchar* dm_thread_entry_get_name (DMThreadEntry* self);
void dm_thread_entry_set_name (DMThreadEntry* self, const gchar* value);
const gchar* dm_thread_entry_get_screen_name (DMThreadEntry* self);
void dm_thread_entry_set_screen_name (DMThreadEntry* self, const gchar* value);
const gchar* dm_thread_entry_get_last_message (DMThreadEntry* self);
void dm_thread_entry_set_last_message (DMThreadEntry* self, const gchar* value);
gint64 dm_thread_entry_get_last_message_id (DMThreadEntry* self);
void dm_thread_entry_set_last_message_id (DMThreadEntry* self, gint64 value);
GdkPixbuf* dm_thread_entry_get_avatar (DMThreadEntry* self);
void dm_thread_entry_set_avatar (DMThreadEntry* self, GdkPixbuf* value);
static void dm_thread_entry_finalize (GObject* obj);
static void _vala_dm_thread_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_dm_thread_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


gboolean dm_thread_entry_equal_func (DMThreadEntry* a, DMThreadEntry* b) {
	gboolean result = FALSE;
	DMThreadEntry* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
	DMThreadEntry* _tmp2_ = NULL;
	gint64 _tmp3_ = 0LL;
#line 24 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (a), FALSE);
#line 24 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (b), FALSE);
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = a;
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = _tmp0_->priv->_user_id;
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = b;
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp3_ = _tmp2_->priv->_user_id;
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp1_ == _tmp3_;
#line 25 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 121 "DMThreadEntry.c"
}


DMThreadEntry* dm_thread_entry_construct (GType object_type, gint64 user_id) {
	DMThreadEntry * self = NULL;
	gint64 _tmp0_ = 0LL;
#line 71 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self = (DMThreadEntry*) g_object_new (object_type, NULL);
#line 72 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = user_id;
#line 72 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	dm_thread_entry_set_user_id (self, _tmp0_);
#line 73 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	dm_thread_entry_update_unread_count (self);
#line 71 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return self;
#line 138 "DMThreadEntry.c"
}


DMThreadEntry* dm_thread_entry_new (gint64 user_id) {
#line 71 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return dm_thread_entry_construct (TYPE_DM_THREAD_ENTRY, user_id);
#line 145 "DMThreadEntry.c"
}


void dm_thread_entry_update_unread_count (DMThreadEntry* self) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 76 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 77 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->unread_count;
#line 77 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_message ("DMThreadEntry.vala:77: unread count: %d", _tmp0_);
#line 78 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = self->unread_count;
#line 78 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	if (_tmp1_ == 0) {
#line 162 "DMThreadEntry.c"
		GtkLabel* _tmp2_ = NULL;
#line 79 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp2_ = self->priv->unread_count_label;
#line 79 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GTK_TYPE_WIDGET, GtkWidget));
#line 168 "DMThreadEntry.c"
	} else {
		GtkLabel* _tmp3_ = NULL;
		GtkLabel* _tmp4_ = NULL;
		const gchar* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 81 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp3_ = self->priv->unread_count_label;
#line 81 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GTK_TYPE_WIDGET, GtkWidget));
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp4_ = self->priv->unread_count_label;
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp5_ = _ ("(%d unread)");
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp6_ = self->unread_count;
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp7_ = g_strdup_printf (_tmp5_, _tmp6_);
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_tmp8_ = _tmp7_;
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		gtk_label_set_label (_tmp4_, _tmp8_);
#line 82 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		_g_free0 (_tmp8_);
#line 194 "DMThreadEntry.c"
	}
}


gint64 dm_thread_entry_get_user_id (DMThreadEntry* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), 0LL);
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->_user_id;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp0_;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 210 "DMThreadEntry.c"
}


static void dm_thread_entry_set_user_id (DMThreadEntry* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = value;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self->priv->_user_id = _tmp0_;
#line 37 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "user-id");
#line 224 "DMThreadEntry.c"
}


const gchar* dm_thread_entry_get_name (DMThreadEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 39 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), NULL);
#line 40 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 40 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 40 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = _tmp1_;
#line 40 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp2_;
#line 40 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 245 "DMThreadEntry.c"
}


void dm_thread_entry_set_name (DMThreadEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 42 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 43 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->name_label;
#line 43 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = value;
#line 43 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 42 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "name");
#line 262 "DMThreadEntry.c"
}


const gchar* dm_thread_entry_get_screen_name (DMThreadEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 47 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), NULL);
#line 48 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 48 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 48 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = _tmp1_;
#line 48 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp2_;
#line 48 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 283 "DMThreadEntry.c"
}


void dm_thread_entry_set_screen_name (DMThreadEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 50 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->screen_name_label;
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = value;
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = g_strconcat ("@", _tmp1_, NULL);
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp3_ = _tmp2_;
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 51 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_free0 (_tmp3_);
#line 50 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "screen-name");
#line 308 "DMThreadEntry.c"
}


const gchar* dm_thread_entry_get_last_message (DMThreadEntry* self) {
	const gchar* result;
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
#line 55 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), NULL);
#line 56 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->last_message_label;
#line 56 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 56 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = _tmp1_;
#line 56 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp2_;
#line 56 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 329 "DMThreadEntry.c"
}


void dm_thread_entry_set_last_message (DMThreadEntry* self, const gchar* value) {
	GtkLabel* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
#line 58 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 59 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->last_message_label;
#line 59 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = value;
#line 59 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_label_set_label (_tmp0_, _tmp1_);
#line 58 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "last-message");
#line 346 "DMThreadEntry.c"
}


gint64 dm_thread_entry_get_last_message_id (DMThreadEntry* self) {
	gint64 result;
	gint64 _tmp0_ = 0LL;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), 0LL);
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->_last_message_id;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp0_;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 361 "DMThreadEntry.c"
}


void dm_thread_entry_set_last_message_id (DMThreadEntry* self, gint64 value) {
	gint64 _tmp0_ = 0LL;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = value;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self->priv->_last_message_id = _tmp0_;
#line 62 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "last-message-id");
#line 375 "DMThreadEntry.c"
}


GdkPixbuf* dm_thread_entry_get_avatar (DMThreadEntry* self) {
	GdkPixbuf* result;
	GtkImage* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
	GdkPixbuf* _tmp2_ = NULL;
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_val_if_fail (IS_DM_THREAD_ENTRY (self), NULL);
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_get (_tmp0_, "pixbuf", &_tmp1_, NULL);
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp2_ = _tmp1_;
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	result = _tmp2_;
#line 65 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	return result;
#line 396 "DMThreadEntry.c"
}


void dm_thread_entry_set_avatar (DMThreadEntry* self, GdkPixbuf* value) {
	GtkImage* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 64 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_return_if_fail (IS_DM_THREAD_ENTRY (self));
#line 64 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp0_ = self->priv->avatar_image;
#line 64 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_tmp1_ = value;
#line 64 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_set (_tmp0_, "pixbuf", _tmp1_, NULL);
#line 64 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_notify ((GObject *) self, "avatar");
#line 413 "DMThreadEntry.c"
}


static void dm_thread_entry_class_init (DMThreadEntryClass * klass) {
	gint DMThreadEntry_private_offset;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	dm_thread_entry_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_type_class_add_private (klass, sizeof (DMThreadEntryPrivate));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dm_thread_entry_get_property;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dm_thread_entry_set_property;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	G_OBJECT_CLASS (klass)->finalize = dm_thread_entry_finalize;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_USER_ID, g_param_spec_int64 ("user-id", "user-id", "user-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_NAME, g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_SCREEN_NAME, g_param_spec_string ("screen-name", "screen-name", "screen-name", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_LAST_MESSAGE, g_param_spec_string ("last-message", "last-message", "last-message", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_LAST_MESSAGE_ID, g_param_spec_int64 ("last-message-id", "last-message-id", "last-message-id", G_MININT64, G_MAXINT64, 0, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DM_THREAD_ENTRY_AVATAR, g_param_spec_object ("avatar", "avatar", "avatar", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	DMThreadEntry_private_offset = g_type_class_get_instance_private_offset (klass);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/dm-thread-entry.ui");
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "name_label", FALSE, DMThreadEntry_private_offset + G_STRUCT_OFFSET (DMThreadEntryPrivate, name_label));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "screen_name_label", FALSE, DMThreadEntry_private_offset + G_STRUCT_OFFSET (DMThreadEntryPrivate, screen_name_label));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "last_message_label", FALSE, DMThreadEntry_private_offset + G_STRUCT_OFFSET (DMThreadEntryPrivate, last_message_label));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "avatar_image", FALSE, DMThreadEntry_private_offset + G_STRUCT_OFFSET (DMThreadEntryPrivate, avatar_image));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "unread_count_label", FALSE, DMThreadEntry_private_offset + G_STRUCT_OFFSET (DMThreadEntryPrivate, unread_count_label));
#line 455 "DMThreadEntry.c"
}


static void dm_thread_entry_instance_init (DMThreadEntry * self) {
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self->priv = DM_THREAD_ENTRY_GET_PRIVATE (self);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 68 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self->unread_count = 0;
#line 466 "DMThreadEntry.c"
}


static void dm_thread_entry_finalize (GObject* obj) {
	DMThreadEntry * self;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DM_THREAD_ENTRY, DMThreadEntry);
#line 28 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_object_unref0 (self->priv->name_label);
#line 30 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_object_unref0 (self->priv->screen_name_label);
#line 32 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_object_unref0 (self->priv->last_message_label);
#line 34 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_object_unref0 (self->priv->avatar_image);
#line 36 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	_g_object_unref0 (self->priv->unread_count_label);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	G_OBJECT_CLASS (dm_thread_entry_parent_class)->finalize (obj);
#line 486 "DMThreadEntry.c"
}


GType dm_thread_entry_get_type (void) {
	static volatile gsize dm_thread_entry_type_id__volatile = 0;
	if (g_once_init_enter (&dm_thread_entry_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DMThreadEntryClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dm_thread_entry_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DMThreadEntry), 0, (GInstanceInitFunc) dm_thread_entry_instance_init, NULL };
		GType dm_thread_entry_type_id;
		dm_thread_entry_type_id = g_type_register_static (GTK_TYPE_LIST_BOX_ROW, "DMThreadEntry", &g_define_type_info, 0);
		g_once_init_leave (&dm_thread_entry_type_id__volatile, dm_thread_entry_type_id);
	}
	return dm_thread_entry_type_id__volatile;
}


static void _vala_dm_thread_entry_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	DMThreadEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_THREAD_ENTRY, DMThreadEntry);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_USER_ID:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_set_int64 (value, dm_thread_entry_get_user_id (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_NAME:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_set_string (value, dm_thread_entry_get_name (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_SCREEN_NAME:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_set_string (value, dm_thread_entry_get_screen_name (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_LAST_MESSAGE:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_set_string (value, dm_thread_entry_get_last_message (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_LAST_MESSAGE_ID:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_set_int64 (value, dm_thread_entry_get_last_message_id (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_AVATAR:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		g_value_take_object (value, dm_thread_entry_get_avatar (self));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 543 "DMThreadEntry.c"
		default:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 549 "DMThreadEntry.c"
	}
}


static void _vala_dm_thread_entry_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	DMThreadEntry * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DM_THREAD_ENTRY, DMThreadEntry);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_USER_ID:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_user_id (self, g_value_get_int64 (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_NAME:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_SCREEN_NAME:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_screen_name (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_LAST_MESSAGE:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_last_message (self, g_value_get_string (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_LAST_MESSAGE_ID:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_last_message_id (self, g_value_get_int64 (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		case DM_THREAD_ENTRY_AVATAR:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		dm_thread_entry_set_avatar (self, g_value_get_object (value));
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 595 "DMThreadEntry.c"
		default:
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/corebird/src/list/DMThreadEntry.vala"
		break;
#line 601 "DMThreadEntry.c"
	}
}



