/* TweetUtils.c generated by valac 0.22.0, the Vala compiler
 * generated from TweetUtils.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <rest/rest-proxy-call.h>
#include <rest/oauth-proxy.h>
#include <rest/rest-proxy.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <json-glib/json-glib.h>
#include <libsoup/soup.h>
#include <gtk/gtk.h>


#define TWEET_UTILS_TYPE_SEQUENCE (tweet_utils_sequence_get_type ())
typedef struct _TweetUtilsSequence TweetUtilsSequence;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_ACCOUNT (account_get_type ())
#define ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ACCOUNT, Account))
#define ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ACCOUNT, AccountClass))
#define IS_ACCOUNT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ACCOUNT))
#define IS_ACCOUNT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ACCOUNT))
#define ACCOUNT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ACCOUNT, AccountClass))

typedef struct _Account Account;
typedef struct _AccountClass AccountClass;

#define TYPE_TWEET (tweet_get_type ())
#define TWEET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TWEET, Tweet))
#define TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TWEET, TweetClass))
#define IS_TWEET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TWEET))
#define IS_TWEET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TWEET))
#define TWEET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TWEET, TweetClass))

typedef struct _Tweet Tweet;
typedef struct _TweetClass TweetClass;
typedef struct _Block47Data Block47Data;
typedef struct _TweetPrivate TweetPrivate;
typedef struct _TweetUtilsDeleteTweetData TweetUtilsDeleteTweetData;
typedef struct _Block48Data Block48Data;
typedef struct _TweetUtilsReplyToTweetData TweetUtilsReplyToTweetData;
typedef struct _Block49Data Block49Data;
typedef struct _TweetUtilsToggleFavoriteTweetData TweetUtilsToggleFavoriteTweetData;
typedef struct _Block50Data Block50Data;
typedef struct _TweetUtilsToggleRetweetTweetData TweetUtilsToggleRetweetTweetData;
typedef struct _Block51Data Block51Data;
typedef struct _TweetUtilsDownloadAvatarData TweetUtilsDownloadAvatarData;

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;

struct _TweetUtilsSequence {
	gint start;
	gint end;
	gchar* url;
	gchar* display_url;
	gboolean visual_display_url;
};

struct _Block47Data {
	int _ref_count_;
	RestProxyCall* call;
	gpointer _async_data_;
};

struct _Tweet {
	GObject parent_instance;
	TweetPrivate * priv;
	gint64 id;
	gint64 rt_id;
	gboolean retweeted;
	gboolean favorited;
	gchar* text;
	gint64 user_id;
	gchar* user_name;
	gchar* retweeted_by;
	gchar* rt_by_screen_name;
	gint64 rt_by_id;
	gboolean is_retweet;
	GdkPixbuf* inline_media;
	gchar* time_delta;
	gchar* avatar_url;
	gchar* avatar_name;
	gchar* screen_name;
	gint64 created_at;
	gint64 rt_created_at;
	gboolean verified;
	gint64 my_retweet;
	gint64 reply_id;
	gchar* media;
	gchar* media_thumb;
	gboolean has_inline_media;
	gint type;
	gint retweet_count;
	gint favorite_count;
};

struct _TweetClass {
	GObjectClass parent_class;
};

struct _TweetUtilsDeleteTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Account* account;
	Tweet* tweet;
	Block47Data* _data47_;
	Account* _tmp0_;
	OAuthProxy* _tmp1_;
	OAuthProxy* _tmp2_;
	RestProxyCall* _tmp3_;
	Tweet* _tmp4_;
	gint64 _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	Tweet* _tmp12_;
	gint64 _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
};

struct _Block48Data {
	int _ref_count_;
	gpointer _async_data_;
};

struct _TweetUtilsReplyToTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Account* account;
	Tweet* tweet;
	gchar* text;
	Block48Data* _data48_;
	RestProxyCall* call;
	Account* _tmp0_;
	OAuthProxy* _tmp1_;
	OAuthProxy* _tmp2_;
	RestProxyCall* _tmp3_;
	Tweet* _tmp4_;
	gint64 _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
};

struct _Block49Data {
	int _ref_count_;
	RestProxyCall* call;
	Tweet* tweet;
	gboolean unfavorite;
	gpointer _async_data_;
};

struct _TweetUtilsToggleFavoriteTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Account* account;
	Tweet* tweet;
	gboolean unfavorite;
	Block49Data* _data49_;
	Tweet* _tmp0_;
	gboolean _tmp1_;
	Account* _tmp2_;
	OAuthProxy* _tmp3_;
	OAuthProxy* _tmp4_;
	RestProxyCall* _tmp5_;
	gboolean _tmp6_;
	RestProxyCall* _tmp7_;
	RestProxyCall* _tmp8_;
	RestProxyCall* _tmp9_;
	RestProxyCall* _tmp10_;
	Tweet* _tmp11_;
	gint64 _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RestProxyCall* _tmp15_;
};

struct _Block50Data {
	int _ref_count_;
	RestProxyCall* call;
	Tweet* tweet;
	gboolean unretweet;
	gpointer _async_data_;
};

struct _TweetUtilsToggleRetweetTweetData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	Account* account;
	Tweet* tweet;
	gboolean unretweet;
	Block50Data* _data50_;
	Tweet* _tmp0_;
	gboolean _tmp1_;
	Account* _tmp2_;
	OAuthProxy* _tmp3_;
	OAuthProxy* _tmp4_;
	RestProxyCall* _tmp5_;
	RestProxyCall* _tmp6_;
	gboolean _tmp7_;
	RestProxyCall* _tmp8_;
	Tweet* _tmp9_;
	gint64 _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	RestProxyCall* _tmp15_;
	Tweet* _tmp16_;
	gint64 _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	RestProxyCall* _tmp22_;
};

struct _Block51Data {
	int _ref_count_;
	gchar* avatar_name;
	GdkPixbuf* avatar;
	gchar* avatar_url;
	gpointer _async_data_;
};

struct _TweetUtilsDownloadAvatarData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	gchar* avatar_url;
	GdkPixbuf* result;
	Block51Data* _data51_;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	SoupSessionAsync* session;
	SoupSessionAsync* _tmp3_;
	SoupMessage* msg;
	const gchar* _tmp4_;
	SoupMessage* _tmp5_;
	SoupMessage* _tmp6_;
	GdkPixbuf* _tmp7_;
};



GType tweet_utils_sequence_get_type (void) G_GNUC_CONST;
TweetUtilsSequence* tweet_utils_sequence_dup (const TweetUtilsSequence* self);
void tweet_utils_sequence_free (TweetUtilsSequence* self);
void tweet_utils_sequence_copy (const TweetUtilsSequence* self, TweetUtilsSequence* dest);
void tweet_utils_sequence_destroy (TweetUtilsSequence* self);
gchar* tweet_utils_get_formatted_text (const gchar* tweet_text, GSList* urls);
static gint __lambda30_ (TweetUtilsSequence* a, TweetUtilsSequence* b);
static gint ___lambda30__gcompare_func (gconstpointer a, gconstpointer b);
gchar* tweet_utils_get_real_text (const gchar* tweet_text, GSList* urls);
static gint __lambda31_ (TweetUtilsSequence* a, TweetUtilsSequence* b);
static gint ___lambda31__gcompare_func (gconstpointer a, gconstpointer b);
static void tweet_utils_delete_tweet_data_free (gpointer _data);
GType account_get_type (void) G_GNUC_CONST;
GType tweet_get_type (void) G_GNUC_CONST;
void tweet_utils_delete_tweet (Account* account, Tweet* tweet, GAsyncReadyCallback _callback_, gpointer _user_data_);
void tweet_utils_delete_tweet_finish (GAsyncResult* _res_);
static gboolean tweet_utils_delete_tweet_co (TweetUtilsDeleteTweetData* _data_);
static Block47Data* block47_data_ref (Block47Data* _data47_);
static void block47_data_unref (void * _userdata_);
OAuthProxy* account_get_proxy (Account* self);
static void __lambda37_ (Block47Data* _data47_, GObject* obj, GAsyncResult* res);
static void ___lambda37__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void tweet_utils_reply_to_tweet_data_free (gpointer _data);
void tweet_utils_reply_to_tweet (Account* account, Tweet* tweet, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_);
void tweet_utils_reply_to_tweet_finish (GAsyncResult* _res_);
static gboolean tweet_utils_reply_to_tweet_co (TweetUtilsReplyToTweetData* _data_);
static Block48Data* block48_data_ref (Block48Data* _data48_);
static void block48_data_unref (void * _userdata_);
static void __lambda35_ (Block48Data* _data48_);
static void ___lambda35__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void tweet_utils_toggle_favorite_tweet_data_free (gpointer _data);
void tweet_utils_toggle_favorite_tweet (Account* account, Tweet* tweet, gboolean unfavorite, GAsyncReadyCallback _callback_, gpointer _user_data_);
void tweet_utils_toggle_favorite_tweet_finish (GAsyncResult* _res_);
static gboolean tweet_utils_toggle_favorite_tweet_co (TweetUtilsToggleFavoriteTweetData* _data_);
static Block49Data* block49_data_ref (Block49Data* _data49_);
static void block49_data_unref (void * _userdata_);
static void __lambda43_ (Block49Data* _data49_, GObject* obj, GAsyncResult* res);
static void ___lambda43__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void tweet_utils_toggle_retweet_tweet_data_free (gpointer _data);
void tweet_utils_toggle_retweet_tweet (Account* account, Tweet* tweet, gboolean unretweet, GAsyncReadyCallback _callback_, gpointer _user_data_);
void tweet_utils_toggle_retweet_tweet_finish (GAsyncResult* _res_);
static gboolean tweet_utils_toggle_retweet_tweet_co (TweetUtilsToggleRetweetTweetData* _data_);
static Block50Data* block50_data_ref (Block50Data* _data50_);
static void block50_data_unref (void * _userdata_);
static void __lambda41_ (Block50Data* _data50_, GObject* obj, GAsyncResult* res);
void utils_show_error_dialog (const gchar* message);
static void ___lambda41__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self);
static void tweet_utils_download_avatar_data_free (gpointer _data);
void tweet_utils_download_avatar (const gchar* avatar_url, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbuf* tweet_utils_download_avatar_finish (GAsyncResult* _res_);
static gboolean tweet_utils_download_avatar_co (TweetUtilsDownloadAvatarData* _data_);
static Block51Data* block51_data_ref (Block51Data* _data51_);
static void block51_data_unref (void * _userdata_);
gchar* utils_get_avatar_name (const gchar* path);
static void __lambda17_ (Block51Data* _data51_, SoupSession* s, SoupMessage* _msg);
gchar* utils_user_file (const gchar* file_name);
static guint8* _vala_array_dup2 (guint8* self, int length);
static void ___lambda17__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
gint tweet_utils_calc_tweet_length (const gchar* text);
gint twitter_get_short_url_length (void);
gint twitter_get_short_url_length_https (void);
GType main_window_get_type (void) G_GNUC_CONST;
gboolean tweet_utils_activate_link (const gchar* uri, MainWindow* window);
void main_window_switch_page (MainWindow* self, gint page_id, ...);
#define MAIN_WINDOW_PAGE_PROFILE 4
#define MAIN_WINDOW_PAGE_SEARCH 3
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


void tweet_utils_sequence_copy (const TweetUtilsSequence* self, TweetUtilsSequence* dest) {
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = (*self).start;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	(*dest).start = _tmp0_;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = (*self).end;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	(*dest).end = _tmp1_;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = (*self).url;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 ((*dest).url);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	(*dest).url = _tmp3_;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_ = (*self).display_url;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 ((*dest).display_url);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	(*dest).display_url = _tmp5_;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp6_ = (*self).visual_display_url;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	(*dest).visual_display_url = _tmp6_;
#line 400 "TweetUtils.c"
}


void tweet_utils_sequence_destroy (TweetUtilsSequence* self) {
#line 27 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 ((*self).url);
#line 28 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 ((*self).display_url);
#line 409 "TweetUtils.c"
}


TweetUtilsSequence* tweet_utils_sequence_dup (const TweetUtilsSequence* self) {
	TweetUtilsSequence* dup;
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	dup = g_new0 (TweetUtilsSequence, 1);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_sequence_copy (self, dup);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return dup;
#line 421 "TweetUtils.c"
}


void tweet_utils_sequence_free (TweetUtilsSequence* self) {
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_sequence_destroy (self);
#line 24 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_free (self);
#line 430 "TweetUtils.c"
}


GType tweet_utils_sequence_get_type (void) {
	static volatile gsize tweet_utils_sequence_type_id__volatile = 0;
	if (g_once_init_enter (&tweet_utils_sequence_type_id__volatile)) {
		GType tweet_utils_sequence_type_id;
		tweet_utils_sequence_type_id = g_boxed_type_register_static ("TweetUtilsSequence", (GBoxedCopyFunc) tweet_utils_sequence_dup, (GBoxedFreeFunc) tweet_utils_sequence_free);
		g_once_init_leave (&tweet_utils_sequence_type_id__volatile, tweet_utils_sequence_type_id);
	}
	return tweet_utils_sequence_type_id__volatile;
}


/**
   * Formats the given Tweet, using the given url list to insert
   * links(i.e. <a> tags).
   *
   * @param tweet_text The text to format
   * @param urls The urls to insert
   *
   * @return The formatted text
   */
static gint __lambda30_ (TweetUtilsSequence* a, TweetUtilsSequence* b) {
	gint result = 0;
	TweetUtilsSequence* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	TweetUtilsSequence* _tmp2_ = NULL;
	gint _tmp3_ = 0;
#line 45 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = a;
#line 45 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = (*_tmp0_).start;
#line 45 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = b;
#line 45 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = (*_tmp2_).start;
#line 45 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_tmp1_ < _tmp3_) {
#line 46 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		result = -1;
#line 46 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return result;
#line 474 "TweetUtils.c"
	}
#line 47 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = 1;
#line 47 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 480 "TweetUtils.c"
}


static gint ___lambda30__gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = __lambda30_ (a, b);
#line 44 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 489 "TweetUtils.c"
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_ = 0L;
	gchar* _tmp1_ = NULL;
#line 1015 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1016 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = c;
#line 1016 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
#line 1016 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = (gint) (_tmp1_ - ((gchar*) self));
#line 1016 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 507 "TweetUtils.c"
}


static gchar* string_splice (const gchar* self, glong start, glong end, const gchar* str) {
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	glong _tmp2_ = 0L;
	glong _tmp5_ = 0L;
	gboolean _tmp8_ = FALSE;
	glong _tmp9_ = 0L;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	glong _tmp14_ = 0L;
	gboolean _tmp17_ = FALSE;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	gsize str_size = 0UL;
	const gchar* _tmp20_ = NULL;
	const gchar* _result_ = NULL;
	gint _tmp24_ = 0;
	gint _tmp25_ = 0;
	glong _tmp26_ = 0L;
	glong _tmp27_ = 0L;
	gsize _tmp28_ = 0UL;
	void* _tmp29_ = NULL;
	gchar* dest = NULL;
	const gchar* _tmp30_ = NULL;
	gchar* _tmp31_ = NULL;
	glong _tmp32_ = 0L;
	gchar* _tmp33_ = NULL;
	glong _tmp34_ = 0L;
	gchar* _tmp35_ = NULL;
	const gchar* _tmp36_ = NULL;
	gsize _tmp37_ = 0UL;
	gchar* _tmp38_ = NULL;
	gsize _tmp39_ = 0UL;
	gchar* _tmp40_ = NULL;
	glong _tmp41_ = 0L;
	glong _tmp42_ = 0L;
	glong _tmp43_ = 0L;
	const gchar* _tmp44_ = NULL;
#line 1203 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1204 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1204 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1204 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1205 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = start;
#line 1205 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp2_ < ((glong) 0)) {
#line 563 "TweetUtils.c"
		glong _tmp3_ = 0L;
		glong _tmp4_ = 0L;
#line 1206 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1206 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = start;
#line 1206 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		start = _tmp3_ + _tmp4_;
#line 572 "TweetUtils.c"
	}
#line 1208 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp5_ = end;
#line 1208 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp5_ < ((glong) 0)) {
#line 578 "TweetUtils.c"
		glong _tmp6_ = 0L;
		glong _tmp7_ = 0L;
#line 1209 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_length;
#line 1209 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = end;
#line 1209 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		end = _tmp6_ + _tmp7_;
#line 587 "TweetUtils.c"
	}
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = start;
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ >= ((glong) 0)) {
#line 593 "TweetUtils.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = start;
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = string_length;
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp10_ <= _tmp11_;
#line 602 "TweetUtils.c"
	} else {
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = FALSE;
#line 606 "TweetUtils.c"
	}
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp12_ = _tmp8_;
#line 1211 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp12_, NULL);
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp14_ = end;
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp14_ >= ((glong) 0)) {
#line 616 "TweetUtils.c"
		glong _tmp15_ = 0L;
		glong _tmp16_ = 0L;
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp15_ = end;
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = _tmp15_ <= _tmp16_;
#line 625 "TweetUtils.c"
	} else {
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = FALSE;
#line 629 "TweetUtils.c"
	}
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp17_ = _tmp13_;
#line 1212 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp17_, NULL);
#line 1213 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = start;
#line 1213 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = end;
#line 1213 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (_tmp18_ <= _tmp19_, NULL);
#line 1216 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = str;
#line 1216 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp20_ == NULL) {
#line 1217 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		str_size = (gsize) 0;
#line 647 "TweetUtils.c"
	} else {
		const gchar* _tmp21_ = NULL;
		gint _tmp22_ = 0;
		gint _tmp23_ = 0;
#line 1219 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp21_ = str;
#line 1219 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp22_ = strlen ((const gchar*) _tmp21_);
#line 1219 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp23_ = _tmp22_;
#line 1219 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		str_size = (gsize) _tmp23_;
#line 660 "TweetUtils.c"
	}
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp24_ = strlen (self);
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp25_ = _tmp24_;
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp26_ = end;
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp27_ = start;
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp28_ = str_size;
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp29_ = g_malloc0 (((_tmp25_ - (_tmp26_ - _tmp27_)) + _tmp28_) + 1);
#line 1222 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = _tmp29_;
#line 1224 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp30_ = _result_;
#line 1224 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	dest = (gchar*) _tmp30_;
#line 1226 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp31_ = dest;
#line 1226 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp32_ = start;
#line 1226 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	memcpy (_tmp31_, self, (gsize) _tmp32_);
#line 1227 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp33_ = dest;
#line 1227 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp34_ = start;
#line 1227 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	dest = _tmp33_ + _tmp34_;
#line 1229 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp35_ = dest;
#line 1229 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp36_ = str;
#line 1229 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp37_ = str_size;
#line 1229 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	memcpy (_tmp35_, _tmp36_, _tmp37_);
#line 1230 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp38_ = dest;
#line 1230 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp39_ = str_size;
#line 1230 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	dest = _tmp38_ + _tmp39_;
#line 1232 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp40_ = dest;
#line 1232 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp41_ = end;
#line 1232 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp42_ = string_length;
#line 1232 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp43_ = end;
#line 1232 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	memcpy (_tmp40_, ((gchar*) self) + _tmp41_, (gsize) (_tmp42_ - _tmp43_));
#line 1234 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp44_ = _result_;
#line 1234 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = NULL;
#line 1234 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = (gchar*) _tmp44_;
#line 1234 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 724 "TweetUtils.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 737 "TweetUtils.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 767 "TweetUtils.c"
				goto __catch61_g_regex_error;
			}
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 776 "TweetUtils.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 792 "TweetUtils.c"
				goto __catch61_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 803 "TweetUtils.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 811 "TweetUtils.c"
	}
	goto __finally61;
	__catch61_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 825 "TweetUtils.c"
	}
	__finally61:
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return NULL;
#line 836 "TweetUtils.c"
	}
}


gchar* tweet_utils_get_formatted_text (const gchar* tweet_text, GSList* urls) {
	gchar* result = NULL;
	gchar* formatted_text = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint char_diff = 0;
	GSList* _tmp2_ = NULL;
#line 41 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_val_if_fail (tweet_text != NULL, NULL);
#line 42 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = tweet_text;
#line 42 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 42 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	formatted_text = _tmp1_;
#line 43 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	char_diff = 0;
#line 44 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	urls = g_slist_sort (urls, ___lambda30__gcompare_func);
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = urls;
#line 862 "TweetUtils.c"
	{
		GSList* s_collection = NULL;
		GSList* s_it = NULL;
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		s_collection = _tmp2_;
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 870 "TweetUtils.c"
			TweetUtilsSequence _tmp3_ = {0};
			TweetUtilsSequence s = {0};
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			tweet_utils_sequence_copy ((TweetUtilsSequence*) s_it->data, &_tmp3_);
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			s = _tmp3_;
#line 877 "TweetUtils.c"
			{
				gint length_before = 0;
				const gchar* _tmp4_ = NULL;
				gint _tmp5_ = 0;
				gint from = 0;
				const gchar* _tmp6_ = NULL;
				TweetUtilsSequence _tmp7_ = {0};
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint to = 0;
				const gchar* _tmp11_ = NULL;
				TweetUtilsSequence _tmp12_ = {0};
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				const gchar* _tmp16_ = NULL;
				gint _tmp17_ = 0;
				gint _tmp18_ = 0;
				TweetUtilsSequence _tmp19_ = {0};
				const gchar* _tmp20_ = NULL;
				gchar* _tmp21_ = NULL;
				gchar* _tmp22_ = NULL;
				TweetUtilsSequence _tmp23_ = {0};
				const gchar* _tmp24_ = NULL;
				gchar* _tmp25_ = NULL;
				gchar* _tmp26_ = NULL;
				gchar* _tmp27_ = NULL;
				gchar* _tmp28_ = NULL;
				gchar* _tmp29_ = NULL;
				gint _tmp30_ = 0;
				const gchar* _tmp31_ = NULL;
				gint _tmp32_ = 0;
				gint _tmp33_ = 0;
#line 50 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp4_ = formatted_text;
#line 50 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp5_ = g_utf8_strlen (_tmp4_, (gssize) (-1));
#line 50 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				length_before = _tmp5_;
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp6_ = formatted_text;
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp7_ = s;
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp8_ = _tmp7_.start;
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp9_ = char_diff;
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp10_ = string_index_of_nth_char (_tmp6_, (glong) (_tmp8_ + _tmp9_));
#line 51 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				from = _tmp10_;
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp11_ = formatted_text;
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp12_ = s;
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp13_ = _tmp12_.end;
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp14_ = char_diff;
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp15_ = string_index_of_nth_char (_tmp11_, (glong) (_tmp13_ + _tmp14_));
#line 52 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				to = _tmp15_;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp16_ = formatted_text;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp17_ = from;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp18_ = to;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp19_ = s;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp20_ = _tmp19_.url;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp21_ = string_replace (_tmp20_, "&", "&amp;");
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp22_ = _tmp21_;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp23_ = s;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp24_ = _tmp23_.display_url;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp25_ = string_replace (_tmp24_, "&", "&amp;");
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp26_ = _tmp25_;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp27_ = g_strdup_printf ("<a href=\"%s\">%s</a>", _tmp22_, _tmp26_);
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp28_ = _tmp27_;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp29_ = string_splice (_tmp16_, (glong) _tmp17_, (glong) _tmp18_, _tmp28_);
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (formatted_text);
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				formatted_text = _tmp29_;
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (_tmp28_);
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (_tmp26_);
#line 53 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (_tmp22_);
#line 56 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp30_ = char_diff;
#line 56 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp31_ = formatted_text;
#line 56 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp32_ = g_utf8_strlen (_tmp31_, (gssize) (-1));
#line 56 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp33_ = length_before;
#line 56 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				char_diff = _tmp30_ + (_tmp32_ - _tmp33_);
#line 49 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				tweet_utils_sequence_destroy (&s);
#line 992 "TweetUtils.c"
			}
		}
	}
#line 59 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = formatted_text;
#line 59 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 1000 "TweetUtils.c"
}


/**
   * Formats the given Tweet, using the given url list to insert
   * links(the real urls, protocol etc. included).
   *
   * @param tweet_text The text to format
   * @param urls The urls to insert
   *
   * @return The formatted text
   */
static gint __lambda31_ (TweetUtilsSequence* a, TweetUtilsSequence* b) {
	gint result = 0;
	TweetUtilsSequence* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	TweetUtilsSequence* _tmp2_ = NULL;
	gint _tmp3_ = 0;
#line 76 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = a;
#line 76 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = (*_tmp0_).start;
#line 76 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = b;
#line 76 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = (*_tmp2_).start;
#line 76 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_tmp1_ < _tmp3_) {
#line 77 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		result = -1;
#line 77 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return result;
#line 1033 "TweetUtils.c"
	}
#line 78 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = 1;
#line 78 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 1039 "TweetUtils.c"
}


static gint ___lambda31__gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = __lambda31_ (a, b);
#line 75 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 1048 "TweetUtils.c"
}


gchar* tweet_utils_get_real_text (const gchar* tweet_text, GSList* urls) {
	gchar* result = NULL;
	gchar* formatted_text = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint char_diff = 0;
	GSList* _tmp2_ = NULL;
#line 72 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_val_if_fail (tweet_text != NULL, NULL);
#line 73 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = tweet_text;
#line 73 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 73 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	formatted_text = _tmp1_;
#line 74 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	char_diff = 0;
#line 75 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	urls = g_slist_sort (urls, ___lambda31__gcompare_func);
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = urls;
#line 1073 "TweetUtils.c"
	{
		GSList* s_collection = NULL;
		GSList* s_it = NULL;
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		s_collection = _tmp2_;
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 1081 "TweetUtils.c"
			TweetUtilsSequence _tmp3_ = {0};
			TweetUtilsSequence s = {0};
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			tweet_utils_sequence_copy ((TweetUtilsSequence*) s_it->data, &_tmp3_);
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			s = _tmp3_;
#line 1088 "TweetUtils.c"
			{
				TweetUtilsSequence _tmp4_ = {0};
				gboolean _tmp5_ = FALSE;
				gint length_before = 0;
				const gchar* _tmp6_ = NULL;
				gint _tmp7_ = 0;
				gint from = 0;
				const gchar* _tmp8_ = NULL;
				TweetUtilsSequence _tmp9_ = {0};
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint to = 0;
				const gchar* _tmp13_ = NULL;
				TweetUtilsSequence _tmp14_ = {0};
				gint _tmp15_ = 0;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				const gchar* _tmp18_ = NULL;
				gint _tmp19_ = 0;
				gint _tmp20_ = 0;
				TweetUtilsSequence _tmp21_ = {0};
				const gchar* _tmp22_ = NULL;
				gchar* _tmp23_ = NULL;
				gint _tmp24_ = 0;
				const gchar* _tmp25_ = NULL;
				gint _tmp26_ = 0;
				gint _tmp27_ = 0;
#line 81 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp4_ = s;
#line 81 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp5_ = _tmp4_.visual_display_url;
#line 81 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				if (_tmp5_) {
#line 82 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					tweet_utils_sequence_destroy (&s);
#line 82 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					continue;
#line 1127 "TweetUtils.c"
				}
#line 83 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp6_ = formatted_text;
#line 83 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp7_ = g_utf8_strlen (_tmp6_, (gssize) (-1));
#line 83 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				length_before = _tmp7_;
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp8_ = formatted_text;
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp9_ = s;
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp10_ = _tmp9_.start;
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp11_ = char_diff;
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp12_ = string_index_of_nth_char (_tmp8_, (glong) (_tmp10_ + _tmp11_));
#line 84 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				from = _tmp12_;
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp13_ = formatted_text;
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp14_ = s;
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp15_ = _tmp14_.end;
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp16_ = char_diff;
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp17_ = string_index_of_nth_char (_tmp13_, (glong) (_tmp15_ + _tmp16_));
#line 85 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				to = _tmp17_;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp18_ = formatted_text;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp19_ = from;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp20_ = to;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp21_ = s;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp22_ = _tmp21_.url;
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp23_ = string_splice (_tmp18_, (glong) _tmp19_, (glong) _tmp20_, _tmp22_);
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (formatted_text);
#line 86 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				formatted_text = _tmp23_;
#line 87 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp24_ = char_diff;
#line 87 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp25_ = formatted_text;
#line 87 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp26_ = g_utf8_strlen (_tmp25_, (gssize) (-1));
#line 87 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp27_ = length_before;
#line 87 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				char_diff = _tmp24_ + (_tmp26_ - _tmp27_);
#line 80 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				tweet_utils_sequence_destroy (&s);
#line 1187 "TweetUtils.c"
			}
		}
	}
#line 90 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = formatted_text;
#line 90 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 1195 "TweetUtils.c"
}


static void tweet_utils_delete_tweet_data_free (gpointer _data) {
	TweetUtilsDeleteTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_object_unref0 (_data_->tweet);
	g_slice_free (TweetUtilsDeleteTweetData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void tweet_utils_delete_tweet (Account* account, Tweet* tweet, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TweetUtilsDeleteTweetData* _data_;
	Account* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	Tweet* _tmp2_ = NULL;
	Tweet* _tmp3_ = NULL;
	_data_ = g_slice_new0 (TweetUtilsDeleteTweetData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, tweet_utils_delete_tweet);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, tweet_utils_delete_tweet_data_free);
	_tmp0_ = account;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	_tmp2_ = tweet;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp3_;
	tweet_utils_delete_tweet_co (_data_);
}


void tweet_utils_delete_tweet_finish (GAsyncResult* _res_) {
	TweetUtilsDeleteTweetData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
   * Deletes the given tweet.
   *
   * @param account The account to delete the tweet from
   * @param tweet the tweet to delete
   */
static Block47Data* block47_data_ref (Block47Data* _data47_) {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data47_->_ref_count_);
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return _data47_;
#line 1251 "TweetUtils.c"
}


static void block47_data_unref (void * _userdata_) {
	Block47Data* _data47_;
	_data47_ = (Block47Data*) _userdata_;
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data47_->_ref_count_)) {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data47_->call);
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_slice_free (Block47Data, _data47_);
#line 1264 "TweetUtils.c"
	}
}


static void __lambda37_ (Block47Data* _data47_, GObject* obj, GAsyncResult* res) {
	GError * _inner_error_ = NULL;
#line 104 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 104 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 1275 "TweetUtils.c"
	{
		GAsyncResult* _tmp0_ = NULL;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp0_ = res;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_data47_->call, _tmp0_, &_inner_error_);
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 1284 "TweetUtils.c"
			goto __catch62_g_error;
		}
	}
	goto __finally62;
	__catch62_g_error:
	{
		GError* e = NULL;
		GError* _tmp1_ = NULL;
		const gchar* _tmp2_ = NULL;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		e = _inner_error_;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_inner_error_ = NULL;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp1_ = e;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp2_ = _tmp1_->message;
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("TweetUtils.vala:105: %s", _tmp2_);
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 1306 "TweetUtils.c"
	}
	__finally62:
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_inner_error_ != NULL) {
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_clear_error (&_inner_error_);
#line 105 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return;
#line 1317 "TweetUtils.c"
	}
#line 106 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_delete_tweet_co (_data47_->_async_data_);
#line 1321 "TweetUtils.c"
}


static void ___lambda37__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 104 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	__lambda37_ (self, source_object, res);
#line 104 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block47_data_unref (self);
#line 1330 "TweetUtils.c"
}


static gboolean tweet_utils_delete_tweet_co (TweetUtilsDeleteTweetData* _data_) {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 0:
#line 1339 "TweetUtils.c"
		goto _state_0;
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 1:
#line 1343 "TweetUtils.c"
		goto _state_1;
		default:
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 1348 "TweetUtils.c"
	}
	_state_0:
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data47_ = g_slice_new0 (Block47Data);
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data47_->_ref_count_ = 1;
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data47_->_async_data_ = _data_;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = NULL;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->account;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = NULL;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = account_get_proxy (_data_->_tmp0_);
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = NULL;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = NULL;
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, rest_proxy_get_type (), RestProxy));
#line 100 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data47_->call = _data_->_tmp3_;
#line 101 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_data47_->call, "POST");
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->tweet;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = 0LL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->_tmp4_->id;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp5_);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp8_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp8_ = g_strconcat ("1.1/statuses/destroy/", _data_->_tmp7_, NULL);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp9_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_tmp8_;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp10_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp10_ = g_strconcat (_data_->_tmp9_, ".json", NULL);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp11_ = NULL;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp11_ = _data_->_tmp10_;
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->_data47_->call, _data_->_tmp11_);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp11_);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp9_);
#line 102 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp7_);
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp12_ = NULL;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp12_ = _data_->tweet;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp13_ = 0LL;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp13_ = _data_->_tmp12_->id;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp14_ = NULL;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp14_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp13_);
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp15_ = NULL;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_data47_->call, "id", _data_->_tmp15_);
#line 103 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp15_);
#line 104 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_data47_->call, NULL, ___lambda37__gasync_ready_callback, block47_data_ref (_data_->_data47_));
#line 108 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 108 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1443 "TweetUtils.c"
	_state_1:
	;
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block47_data_unref (_data_->_data47_);
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data47_ = NULL;
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1454 "TweetUtils.c"
	} else {
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1458 "TweetUtils.c"
	}
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 99 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1464 "TweetUtils.c"
}


static void tweet_utils_reply_to_tweet_data_free (gpointer _data) {
	TweetUtilsReplyToTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	_g_object_unref0 (_data_->tweet);
	_g_free0 (_data_->text);
	g_slice_free (TweetUtilsReplyToTweetData, _data_);
}


void tweet_utils_reply_to_tweet (Account* account, Tweet* tweet, const gchar* text, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TweetUtilsReplyToTweetData* _data_;
	Account* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	Tweet* _tmp2_ = NULL;
	Tweet* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	_data_ = g_slice_new0 (TweetUtilsReplyToTweetData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, tweet_utils_reply_to_tweet);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, tweet_utils_reply_to_tweet_data_free);
	_tmp0_ = account;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	_tmp2_ = tweet;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp3_;
	_tmp4_ = text;
	_tmp5_ = g_strdup (_tmp4_);
	_g_free0 (_data_->text);
	_data_->text = _tmp5_;
	tweet_utils_reply_to_tweet_co (_data_);
}


void tweet_utils_reply_to_tweet_finish (GAsyncResult* _res_) {
	TweetUtilsReplyToTweetData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
   * Replies to the given tweet. This intended for quick/easy replies, without any
   * additional data such as media.
   *
   * @param account The account to reply from
   * @param tweet The tweet to reply to
   * @param text The text to reply
   */
static Block48Data* block48_data_ref (Block48Data* _data48_) {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data48_->_ref_count_);
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return _data48_;
#line 1524 "TweetUtils.c"
}


static void block48_data_unref (void * _userdata_) {
	Block48Data* _data48_;
	_data48_ = (Block48Data*) _userdata_;
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data48_->_ref_count_)) {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_slice_free (Block48Data, _data48_);
#line 1535 "TweetUtils.c"
	}
}


static void __lambda35_ (Block48Data* _data48_) {
#line 127 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_reply_to_tweet_co (_data48_->_async_data_);
#line 1543 "TweetUtils.c"
}


static void ___lambda35__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 126 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	__lambda35_ (self);
#line 126 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block48_data_unref (self);
#line 1552 "TweetUtils.c"
}


static gboolean tweet_utils_reply_to_tweet_co (TweetUtilsReplyToTweetData* _data_) {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 0:
#line 1561 "TweetUtils.c"
		goto _state_0;
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 1:
#line 1565 "TweetUtils.c"
		goto _state_1;
		default:
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 1570 "TweetUtils.c"
	}
	_state_0:
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data48_ = g_slice_new0 (Block48Data);
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data48_->_ref_count_ = 1;
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data48_->_async_data_ = _data_;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = NULL;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->account;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = NULL;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = account_get_proxy (_data_->_tmp0_);
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = NULL;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = NULL;
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, rest_proxy_get_type (), RestProxy));
#line 121 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->call = _data_->_tmp3_;
#line 122 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_function (_data_->call, "1.1/statuses/update.json");
#line 123 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->call, "POST");
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = NULL;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->tweet;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = 0LL;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = _data_->_tmp4_->id;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = NULL;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp5_);
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = NULL;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_tmp6_;
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->call, "in_reply_to_status_id", _data_->_tmp7_);
#line 124 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp7_);
#line 125 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp8_ = NULL;
#line 125 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp8_ = _data_->text;
#line 125 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->call, "status", _data_->_tmp8_);
#line 126 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->call, NULL, ___lambda35__gasync_ready_callback, block48_data_ref (_data_->_data48_));
#line 129 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 129 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1633 "TweetUtils.c"
	_state_1:
	;
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->call);
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block48_data_unref (_data_->_data48_);
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data48_ = NULL;
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1646 "TweetUtils.c"
	} else {
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1650 "TweetUtils.c"
	}
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 120 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1656 "TweetUtils.c"
}


static void tweet_utils_toggle_favorite_tweet_data_free (gpointer _data) {
	TweetUtilsToggleFavoriteTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (TweetUtilsToggleFavoriteTweetData, _data_);
}


void tweet_utils_toggle_favorite_tweet (Account* account, Tweet* tweet, gboolean unfavorite, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TweetUtilsToggleFavoriteTweetData* _data_;
	Account* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	Tweet* _tmp2_ = NULL;
	Tweet* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	_data_ = g_slice_new0 (TweetUtilsToggleFavoriteTweetData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, tweet_utils_toggle_favorite_tweet);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, tweet_utils_toggle_favorite_tweet_data_free);
	_tmp0_ = account;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	_tmp2_ = tweet;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp3_;
	_tmp4_ = unfavorite;
	_data_->unfavorite = _tmp4_;
	tweet_utils_toggle_favorite_tweet_co (_data_);
}


void tweet_utils_toggle_favorite_tweet_finish (GAsyncResult* _res_) {
	TweetUtilsToggleFavoriteTweetData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
   * (Un)favorites the given tweet.
   *
   * @param account The account to (un)favorite from
   * @param tweet The tweet to (un)favorite
   * @param unfavorite If set to true, this function will unfavorite the tiven tweet,
   *                   else it will favorite it.
   */
static Block49Data* block49_data_ref (Block49Data* _data49_) {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data49_->_ref_count_);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return _data49_;
#line 1711 "TweetUtils.c"
}


static void block49_data_unref (void * _userdata_) {
	Block49Data* _data49_;
	_data49_ = (Block49Data*) _userdata_;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data49_->_ref_count_)) {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data49_->call);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data49_->tweet);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_slice_free (Block49Data, _data49_);
#line 1726 "TweetUtils.c"
	}
}


static void __lambda43_ (Block49Data* _data49_, GObject* obj, GAsyncResult* res) {
	Tweet* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	GError * _inner_error_ = NULL;
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 1739 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
#line 152 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp0_ = _data49_->call;
#line 152 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp1_ = res;
#line 152 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, _tmp1_, &_inner_error_);
#line 152 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 1751 "TweetUtils.c"
			goto __catch63_g_error;
		}
	}
	goto __finally63;
	__catch63_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		e = _inner_error_;
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_inner_error_ = NULL;
#line 154 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp2_ = e;
#line 154 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp3_ = _tmp2_->message;
#line 154 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("TweetUtils.vala:154: %s", _tmp3_);
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 1773 "TweetUtils.c"
	}
	__finally63:
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_inner_error_ != NULL) {
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_clear_error (&_inner_error_);
#line 151 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return;
#line 1784 "TweetUtils.c"
	}
#line 156 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_ = _data49_->tweet;
#line 156 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp5_ = _data49_->unfavorite;
#line 156 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_->favorited = !_tmp5_;
#line 157 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_toggle_favorite_tweet_co (_data49_->_async_data_);
#line 1794 "TweetUtils.c"
}


static void ___lambda43__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	__lambda43_ (self, source_object, res);
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block49_data_unref (self);
#line 1803 "TweetUtils.c"
}


static gboolean tweet_utils_toggle_favorite_tweet_co (TweetUtilsToggleFavoriteTweetData* _data_) {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 0:
#line 1812 "TweetUtils.c"
		goto _state_0;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 1:
#line 1816 "TweetUtils.c"
		goto _state_1;
		default:
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 1821 "TweetUtils.c"
	}
	_state_0:
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_ = g_slice_new0 (Block49Data);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_->_ref_count_ = 1;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = NULL;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->tweet;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data49_->tweet);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_->tweet = _data_->_tmp0_;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = FALSE;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = _data_->unfavorite;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_->unfavorite = _data_->_tmp1_;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_->_async_data_ = _data_;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = NULL;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->account;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = NULL;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = account_get_proxy (_data_->_tmp2_);
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = NULL;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = NULL;
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, rest_proxy_get_type (), RestProxy));
#line 142 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_->call = _data_->_tmp5_;
#line 143 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = FALSE;
#line 143 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = _data_->_data49_->unfavorite;
#line 143 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (!_data_->_tmp6_) {
#line 144 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp7_ = NULL;
#line 144 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp7_ = _data_->_data49_->call;
#line 144 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp7_, "1.1/favorites/create.json");
#line 1874 "TweetUtils.c"
	} else {
#line 146 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp8_ = NULL;
#line 146 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp8_ = _data_->_data49_->call;
#line 146 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp8_, "1.1/favorites/destroy.json");
#line 1882 "TweetUtils.c"
	}
#line 148 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp9_ = NULL;
#line 148 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp9_ = _data_->_data49_->call;
#line 148 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp9_, "POST");
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp10_ = NULL;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp10_ = _data_->_data49_->call;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp11_ = NULL;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp11_ = _data_->_data49_->tweet;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp12_ = 0LL;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp12_ = _data_->_tmp11_->id;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp13_ = NULL;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp13_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp12_);
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp14_ = NULL;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_add_param (_data_->_tmp10_, "id", _data_->_tmp14_);
#line 149 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_tmp14_);
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp15_ = NULL;
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp15_ = _data_->_data49_->call;
#line 150 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp15_, NULL, ___lambda43__gasync_ready_callback, block49_data_ref (_data_->_data49_));
#line 159 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 159 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1924 "TweetUtils.c"
	_state_1:
	;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block49_data_unref (_data_->_data49_);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data49_ = NULL;
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1935 "TweetUtils.c"
	} else {
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1939 "TweetUtils.c"
	}
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 141 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 1945 "TweetUtils.c"
}


static void tweet_utils_toggle_retweet_tweet_data_free (gpointer _data) {
	TweetUtilsToggleRetweetTweetData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->account);
	g_slice_free (TweetUtilsToggleRetweetTweetData, _data_);
}


void tweet_utils_toggle_retweet_tweet (Account* account, Tweet* tweet, gboolean unretweet, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TweetUtilsToggleRetweetTweetData* _data_;
	Account* _tmp0_ = NULL;
	Account* _tmp1_ = NULL;
	Tweet* _tmp2_ = NULL;
	Tweet* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	_data_ = g_slice_new0 (TweetUtilsToggleRetweetTweetData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, tweet_utils_toggle_retweet_tweet);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, tweet_utils_toggle_retweet_tweet_data_free);
	_tmp0_ = account;
	_tmp1_ = _g_object_ref0 (_tmp0_);
	_g_object_unref0 (_data_->account);
	_data_->account = _tmp1_;
	_tmp2_ = tweet;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	_g_object_unref0 (_data_->tweet);
	_data_->tweet = _tmp3_;
	_tmp4_ = unretweet;
	_data_->unretweet = _tmp4_;
	tweet_utils_toggle_retweet_tweet_co (_data_);
}


void tweet_utils_toggle_retweet_tweet_finish (GAsyncResult* _res_) {
	TweetUtilsToggleRetweetTweetData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
   * (Un)retweets the given tweet.
   *
   * @param account The account to (un)retweet from
   * @param tweet The tweet to (un)retweet
   * @param unretweet If set to true, this function will delete te retweet of #tweet,
   *                  else it will retweet it.
   */
static Block50Data* block50_data_ref (Block50Data* _data50_) {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data50_->_ref_count_);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return _data50_;
#line 2000 "TweetUtils.c"
}


static void block50_data_unref (void * _userdata_) {
	Block50Data* _data50_;
	_data50_ = (Block50Data*) _userdata_;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data50_->_ref_count_)) {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data50_->call);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data50_->tweet);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_slice_free (Block50Data, _data50_);
#line 2015 "TweetUtils.c"
	}
}


static void __lambda41_ (Block50Data* _data50_, GObject* obj, GAsyncResult* res) {
	gchar* back = NULL;
	RestProxyCall* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	JsonParser* parser = NULL;
	JsonParser* _tmp7_ = NULL;
	GError * _inner_error_ = NULL;
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 2032 "TweetUtils.c"
	{
		RestProxyCall* _tmp0_ = NULL;
		GAsyncResult* _tmp1_ = NULL;
#line 180 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp0_ = _data50_->call;
#line 180 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp1_ = res;
#line 180 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_invoke_finish (_tmp0_, _tmp1_, &_inner_error_);
#line 180 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 2044 "TweetUtils.c"
			goto __catch64_g_error;
		}
	}
	goto __finally64;
	__catch64_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		e = _inner_error_;
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_inner_error_ = NULL;
#line 182 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp2_ = e;
#line 182 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp3_ = _tmp2_->message;
#line 182 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		utils_show_error_dialog (_tmp3_);
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 2066 "TweetUtils.c"
	}
	__finally64:
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_inner_error_ != NULL) {
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_clear_error (&_inner_error_);
#line 179 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return;
#line 2077 "TweetUtils.c"
	}
#line 184 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_ = _data50_->call;
#line 184 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp5_ = rest_proxy_call_get_payload (_tmp4_);
#line 184 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 184 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	back = _tmp6_;
#line 185 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp7_ = json_parser_new ();
#line 185 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	parser = _tmp7_;
#line 2091 "TweetUtils.c"
	{
		gboolean _tmp8_ = FALSE;
		Tweet* _tmp15_ = NULL;
		gboolean _tmp16_ = FALSE;
#line 187 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		json_parser_load_from_data (parser, back, (gssize) (-1), &_inner_error_);
#line 187 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 2100 "TweetUtils.c"
			goto __catch65_g_error;
		}
#line 188 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp8_ = _data50_->unretweet;
#line 188 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (!_tmp8_) {
#line 2107 "TweetUtils.c"
			gint64 new_id = 0LL;
			JsonNode* _tmp9_ = NULL;
			JsonObject* _tmp10_ = NULL;
			gint64 _tmp11_ = 0LL;
			Tweet* _tmp12_ = NULL;
			gint64 _tmp13_ = 0LL;
#line 189 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp9_ = json_parser_get_root (parser);
#line 189 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp10_ = json_node_get_object (_tmp9_);
#line 189 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp11_ = json_object_get_int_member (_tmp10_, "id");
#line 189 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			new_id = _tmp11_;
#line 190 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp12_ = _data50_->tweet;
#line 190 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp13_ = new_id;
#line 190 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp12_->my_retweet = _tmp13_;
#line 2128 "TweetUtils.c"
		} else {
			Tweet* _tmp14_ = NULL;
#line 192 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp14_ = _data50_->tweet;
#line 192 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp14_->my_retweet = (gint64) 0;
#line 2135 "TweetUtils.c"
		}
#line 194 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp15_ = _data50_->tweet;
#line 194 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp16_ = _data50_->unretweet;
#line 194 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp15_->retweeted = !_tmp16_;
#line 2143 "TweetUtils.c"
	}
	goto __finally65;
	__catch65_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		e = _inner_error_;
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_inner_error_ = NULL;
#line 196 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp17_ = e;
#line 196 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp18_ = _tmp17_->message;
#line 196 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("TweetUtils.vala:196: %s", _tmp18_);
#line 197 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("TweetUtils.vala:197: %s", back);
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 2165 "TweetUtils.c"
	}
	__finally65:
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_inner_error_ != NULL) {
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (parser);
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (back);
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_clear_error (&_inner_error_);
#line 186 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return;
#line 2180 "TweetUtils.c"
	}
#line 199 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	tweet_utils_toggle_retweet_tweet_co (_data50_->_async_data_);
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (parser);
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (back);
#line 2188 "TweetUtils.c"
}


static void ___lambda41__gasync_ready_callback (GObject* source_object, GAsyncResult* res, gpointer self) {
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	__lambda41_ (self, source_object, res);
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block50_data_unref (self);
#line 2197 "TweetUtils.c"
}


static gboolean tweet_utils_toggle_retweet_tweet_co (TweetUtilsToggleRetweetTweetData* _data_) {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 0:
#line 2206 "TweetUtils.c"
		goto _state_0;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 1:
#line 2210 "TweetUtils.c"
		goto _state_1;
		default:
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 2215 "TweetUtils.c"
	}
	_state_0:
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_ = g_slice_new0 (Block50Data);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_->_ref_count_ = 1;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = NULL;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->tweet;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->_data50_->tweet);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_->tweet = _data_->_tmp0_;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = FALSE;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = _data_->unretweet;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_->unretweet = _data_->_tmp1_;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_->_async_data_ = _data_;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = NULL;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = _data_->account;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = NULL;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = account_get_proxy (_data_->_tmp2_);
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = NULL;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = NULL;
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = rest_proxy_new_call (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, rest_proxy_get_type (), RestProxy));
#line 171 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_->call = _data_->_tmp5_;
#line 172 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = NULL;
#line 172 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = _data_->_data50_->call;
#line 172 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_set_method (_data_->_tmp6_, "POST");
#line 173 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = FALSE;
#line 173 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = _data_->_data50_->unretweet;
#line 173 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (!_data_->_tmp7_) {
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp8_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp8_ = _data_->_data50_->call;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp9_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp9_ = _data_->_data50_->tweet;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp10_ = 0LL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp10_ = _data_->_tmp9_->id;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp11_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp11_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp10_);
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp12_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp12_ = _data_->_tmp11_;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp13_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp13_ = g_strconcat ("1.1/statuses/retweet/", _data_->_tmp12_, ".json", NULL);
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp14_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp8_, _data_->_tmp14_);
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp14_);
#line 174 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp12_);
#line 2302 "TweetUtils.c"
	} else {
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp15_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp15_ = _data_->_data50_->call;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp16_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp16_ = _data_->_data50_->tweet;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp17_ = 0LL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp17_ = _data_->_tmp16_->my_retweet;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp18_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp18_ = g_strdup_printf ("%" G_GINT64_FORMAT, _data_->_tmp17_);
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp19_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp20_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp20_ = g_strconcat ("1.1/statuses/destroy/", _data_->_tmp19_, ".json", NULL);
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp21_ = NULL;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		rest_proxy_call_set_function (_data_->_tmp15_, _data_->_tmp21_);
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp21_);
#line 176 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data_->_tmp19_);
#line 2338 "TweetUtils.c"
	}
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp22_ = NULL;
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp22_ = _data_->_data50_->call;
#line 178 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	rest_proxy_call_invoke_async (_data_->_tmp22_, NULL, ___lambda41__gasync_ready_callback, block50_data_ref (_data_->_data50_));
#line 201 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 201 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 2350 "TweetUtils.c"
	_state_1:
	;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block50_data_unref (_data_->_data50_);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data50_ = NULL;
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2361 "TweetUtils.c"
	} else {
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2365 "TweetUtils.c"
	}
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 170 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 2371 "TweetUtils.c"
}


static void tweet_utils_download_avatar_data_free (gpointer _data) {
	TweetUtilsDownloadAvatarData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->result);
	g_slice_free (TweetUtilsDownloadAvatarData, _data_);
}


void tweet_utils_download_avatar (const gchar* avatar_url, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	TweetUtilsDownloadAvatarData* _data_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	_data_ = g_slice_new0 (TweetUtilsDownloadAvatarData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, tweet_utils_download_avatar);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, tweet_utils_download_avatar_data_free);
	_tmp0_ = avatar_url;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data_->avatar_url);
	_data_->avatar_url = _tmp1_;
	tweet_utils_download_avatar_co (_data_);
}


GdkPixbuf* tweet_utils_download_avatar_finish (GAsyncResult* _res_) {
	GdkPixbuf* result;
	TweetUtilsDownloadAvatarData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
	result = _data_->result;
	_data_->result = NULL;
	return result;
}


/**
   * Downloads the avatar from the given url.
   *
   * @param avatar_url The avatar url to download
   *
   * @return The loaded avatar.
   */
static Block51Data* block51_data_ref (Block51Data* _data51_) {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_atomic_int_inc (&_data51_->_ref_count_);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return _data51_;
#line 2420 "TweetUtils.c"
}


static void block51_data_unref (void * _userdata_) {
	Block51Data* _data51_;
	_data51_ = (Block51Data*) _userdata_;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (g_atomic_int_dec_and_test (&_data51_->_ref_count_)) {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data51_->avatar);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data51_->avatar_name);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_data51_->avatar_url);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_slice_free (Block51Data, _data51_);
#line 2437 "TweetUtils.c"
	}
}


static guint8* _vala_array_dup2 (guint8* self, int length) {
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 2445 "TweetUtils.c"
}


static void __lambda17_ (Block51Data* _data51_, SoupSession* s, SoupMessage* _msg) {
	gchar* dest = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GMemoryInputStream* memory_stream = NULL;
	SoupMessage* _tmp4_ = NULL;
	SoupMessageBody* _tmp5_ = NULL;
	guint8* _tmp6_ = NULL;
	gint _tmp6__length1 = 0;
	guint8* _tmp7_ = NULL;
	gint _tmp7__length1 = 0;
	GMemoryInputStream* _tmp8_ = NULL;
	const gchar* _tmp20_ = NULL;
	const gchar* _tmp21_ = NULL;
	GError * _inner_error_ = NULL;
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail (SOUP_IS_SESSION (s));
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_if_fail (SOUP_IS_MESSAGE (_msg));
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = g_strconcat ("assets/avatars/", _data51_->avatar_name, NULL);
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = _tmp0_;
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = utils_user_file (_tmp1_);
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = _tmp2_;
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_tmp1_);
#line 217 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	dest = _tmp3_;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_ = _msg;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp5_ = _tmp4_->response_body;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp6_ = _tmp5_->data;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp6__length1 = (gint) _tmp5_->length;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp7_ = (_tmp6_ != NULL) ? _vala_array_dup2 (_tmp6_, _tmp6__length1) : ((gpointer) _tmp6_);
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp7__length1 = _tmp6__length1;
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp8_ = (GMemoryInputStream*) g_memory_input_stream_new_from_data (_tmp7_, _tmp7__length1, NULL);
#line 218 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	memory_stream = _tmp8_;
#line 2498 "TweetUtils.c"
	{
		GdkPixbuf* _tmp9_ = NULL;
		GMemoryInputStream* _tmp10_ = NULL;
		GdkPixbuf* _tmp11_ = NULL;
		const gchar* _tmp12_ = NULL;
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp10_ = memory_stream;
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp11_ = gdk_pixbuf_new_from_stream_at_scale (G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, G_TYPE_INPUT_STREAM, GInputStream), 48, 48, FALSE, NULL, &_inner_error_);
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp9_ = _tmp11_;
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 2512 "TweetUtils.c"
			goto __catch66_g_error;
		}
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (_data51_->avatar);
#line 222 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_data51_->avatar = _tmp9_;
#line 225 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp12_ = dest;
#line 225 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		gdk_pixbuf_save (_data51_->avatar, _tmp12_, "png", &_inner_error_, NULL);
#line 225 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_inner_error_ != NULL) {
#line 2525 "TweetUtils.c"
			goto __catch66_g_error;
		}
#line 226 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		tweet_utils_download_avatar_co (_data51_->_async_data_);
#line 2530 "TweetUtils.c"
	}
	goto __finally66;
	__catch66_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		gchar* _tmp15_ = NULL;
		gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		e = _inner_error_;
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_inner_error_ = NULL;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp13_ = e;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp14_ = _tmp13_->message;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp15_ = g_strconcat (_tmp14_, " for ", NULL);
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp16_ = _tmp15_;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp17_ = _data51_->avatar_url;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp19_ = _tmp18_;
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("TweetUtils.vala:228: %s", _tmp19_);
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_tmp19_);
#line 228 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (_tmp16_);
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_error_free0 (e);
#line 2569 "TweetUtils.c"
	}
	__finally66:
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_inner_error_ != NULL) {
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_object_unref0 (memory_stream);
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (dest);
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_clear_error (&_inner_error_);
#line 221 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return;
#line 2584 "TweetUtils.c"
	}
#line 230 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp20_ = _data51_->avatar_url;
#line 230 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_debug ("TweetUtils.vala:230: Loaded avatar %s", _tmp20_);
#line 231 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp21_ = dest;
#line 231 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_debug ("TweetUtils.vala:231: Dest: %s", _tmp21_);
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (memory_stream);
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (dest);
#line 2598 "TweetUtils.c"
}


static void ___lambda17__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	__lambda17_ (self, session, msg);
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block51_data_unref (self);
#line 2607 "TweetUtils.c"
}


static gboolean tweet_utils_download_avatar_co (TweetUtilsDownloadAvatarData* _data_) {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	switch (_data_->_state_) {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 0:
#line 2616 "TweetUtils.c"
		goto _state_0;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		case 1:
#line 2620 "TweetUtils.c"
		goto _state_1;
		default:
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_assert_not_reached ();
#line 2625 "TweetUtils.c"
	}
	_state_0:
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_ = g_slice_new0 (Block51Data);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_->_ref_count_ = 1;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = NULL;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp0_ = _data_->avatar_url;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (_data_->_data51_->avatar_url);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_->avatar_url = _data_->_tmp0_;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_->_async_data_ = _data_;
#line 212 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = NULL;
#line 212 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp1_ = _data_->_data51_->avatar_url;
#line 212 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = NULL;
#line 212 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp2_ = utils_get_avatar_name (_data_->_tmp1_);
#line 212 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_->avatar_name = _data_->_tmp2_;
#line 213 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_->avatar = NULL;
#line 214 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = NULL;
#line 214 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp3_ = (SoupSessionAsync*) soup_session_async_new ();
#line 214 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->session = _data_->_tmp3_;
#line 215 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = NULL;
#line 215 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp4_ = _data_->_data51_->avatar_url;
#line 215 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = NULL;
#line 215 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp5_ = soup_message_new ("GET", _data_->_tmp4_);
#line 215 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->msg = _data_->_tmp5_;
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = NULL;
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp6_ = _g_object_ref0 (_data_->msg);
#line 216 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	soup_session_queue_message (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, soup_session_get_type (), SoupSession), _data_->_tmp6_, ___lambda17__soup_session_callback, block51_data_ref (_data_->_data51_));
#line 233 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_state_ = 1;
#line 233 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 2680 "TweetUtils.c"
	_state_1:
	;
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = NULL;
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_tmp7_ = _g_object_ref0 (_data_->_data51_->avatar);
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->result = _data_->_tmp7_;
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->msg);
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->session);
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block51_data_unref (_data_->_data51_);
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_ = NULL;
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2701 "TweetUtils.c"
	} else {
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2705 "TweetUtils.c"
	}
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 234 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->msg);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_object_unref0 (_data_->session);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	block51_data_unref (_data_->_data51_);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_data_->_data51_ = NULL;
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_data_->_state_ == 0) {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 2723 "TweetUtils.c"
	} else {
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 2727 "TweetUtils.c"
	}
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_object_unref (_data_->_async_result);
#line 211 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return FALSE;
#line 2733 "TweetUtils.c"
}


/**
   * Calculates the length of a tweet.
   * See https://dev.twitter.com/docs/faq#5810 for details
   *
   * @param text The text to calculate the length for
   *
   * @return The length of the tweet, taking Twitter's rules for
   *         tweet length into account.
   */
gint tweet_utils_calc_tweet_length (const gchar* text) {
	gint result = 0;
	gchar** words = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint words_length1 = 0;
	gint _words_size_ = 0;
	gint length = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	gint _tmp22_ = 0;
	gchar** _tmp23_ = NULL;
	gint _tmp23__length1 = 0;
#line 246 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_val_if_fail (text != NULL, 0);
#line 247 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = text;
#line 247 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, " ", 0);
#line 247 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	words = _tmp2_;
#line 247 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	words_length1 = _vala_array_length (_tmp1_);
#line 247 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_words_size_ = words_length1;
#line 248 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	length = 0;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = words;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3__length1 = words_length1;
#line 2778 "TweetUtils.c"
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		s_collection = _tmp3_;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		s_collection_length1 = _tmp3__length1;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		for (s_it = 0; s_it < _tmp3__length1; s_it = s_it + 1) {
#line 2790 "TweetUtils.c"
			gchar* _tmp4_ = NULL;
			gchar* s = NULL;
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp4_ = g_strdup (s_collection[s_it]);
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			s = _tmp4_;
#line 2797 "TweetUtils.c"
			{
				gboolean _tmp5_ = FALSE;
				const gchar* _tmp6_ = NULL;
				gboolean _tmp7_ = FALSE;
				gboolean _tmp10_ = FALSE;
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp6_ = s;
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp7_ = g_str_has_prefix (_tmp6_, "http://");
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				if (_tmp7_) {
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp5_ = TRUE;
#line 2811 "TweetUtils.c"
				} else {
					const gchar* _tmp8_ = NULL;
					gboolean _tmp9_ = FALSE;
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp8_ = s;
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp9_ = g_str_has_prefix (_tmp8_, "www.");
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp5_ = _tmp9_;
#line 2821 "TweetUtils.c"
				}
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_tmp10_ = _tmp5_;
#line 251 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				if (_tmp10_) {
#line 2827 "TweetUtils.c"
					gint _tmp11_ = 0;
					gint _tmp12_ = 0;
					gint _tmp13_ = 0;
#line 252 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp11_ = length;
#line 252 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp12_ = twitter_get_short_url_length ();
#line 252 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp13_ = _tmp12_;
#line 252 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					length = _tmp11_ + _tmp13_;
#line 2839 "TweetUtils.c"
				} else {
					const gchar* _tmp14_ = NULL;
					gboolean _tmp15_ = FALSE;
#line 253 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp14_ = s;
#line 253 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					_tmp15_ = g_str_has_prefix (_tmp14_, "https://");
#line 253 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
					if (_tmp15_) {
#line 2849 "TweetUtils.c"
						gint _tmp16_ = 0;
						gint _tmp17_ = 0;
						gint _tmp18_ = 0;
#line 254 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp16_ = length;
#line 254 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp17_ = twitter_get_short_url_length_https ();
#line 254 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp18_ = _tmp17_;
#line 254 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						length = _tmp16_ + _tmp18_;
#line 2861 "TweetUtils.c"
					} else {
						gint _tmp19_ = 0;
						const gchar* _tmp20_ = NULL;
						gint _tmp21_ = 0;
#line 256 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp19_ = length;
#line 256 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp20_ = s;
#line 256 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						_tmp21_ = g_utf8_strlen (_tmp20_, (gssize) (-1));
#line 256 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
						length = _tmp19_ + _tmp21_;
#line 2874 "TweetUtils.c"
					}
				}
#line 250 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
				_g_free0 (s);
#line 2879 "TweetUtils.c"
			}
		}
	}
#line 260 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp22_ = length;
#line 260 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp23_ = words;
#line 260 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp23__length1 = words_length1;
#line 260 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	length = _tmp22_ + (_tmp23__length1 - 1);
#line 262 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = length;
#line 262 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	words = (_vala_array_free (words, words_length1, (GDestroyNotify) g_free), NULL);
#line 262 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 2897 "TweetUtils.c"
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 2920 "TweetUtils.c"
		glong _tmp4_ = 0L;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 2928 "TweetUtils.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 2940 "TweetUtils.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
#line 1167 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 2965 "TweetUtils.c"
		glong _tmp2_ = 0L;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 2971 "TweetUtils.c"
	} else {
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2975 "TweetUtils.c"
	}
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 2981 "TweetUtils.c"
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 2993 "TweetUtils.c"
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 3003 "TweetUtils.c"
	}
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 3009 "TweetUtils.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 3023 "TweetUtils.c"
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 3033 "TweetUtils.c"
	}
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 3039 "TweetUtils.c"
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 3048 "TweetUtils.c"
	}
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 3068 "TweetUtils.c"
}


static gint64 int64_parse (const gchar* str) {
	gint64 result = 0LL;
	const gchar* _tmp0_ = NULL;
	gint64 _tmp1_ = 0LL;
#line 603 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0LL);
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (_tmp0_, NULL, (guint) 0);
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp1_;
#line 604 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 3086 "TweetUtils.c"
}


gboolean tweet_utils_activate_link (const gchar* uri, MainWindow* window) {
	gboolean result = FALSE;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* term = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
#line 265 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_val_if_fail (uri != NULL, FALSE);
#line 265 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	g_return_val_if_fail (IS_MAIN_WINDOW (window), FALSE);
#line 266 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp0_ = uri;
#line 266 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp1_ = g_strstrip (_tmp0_);
#line 266 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	uri = _tmp1_;
#line 267 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp2_ = uri;
#line 267 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp3_ = string_substring (_tmp2_, (glong) 1, (glong) (-1));
#line 267 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	term = _tmp3_;
#line 269 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp4_ = uri;
#line 269 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_tmp5_ = g_str_has_prefix (_tmp4_, "@");
#line 269 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	if (_tmp5_) {
#line 3121 "TweetUtils.c"
		MainWindow* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gint64 _tmp8_ = 0LL;
#line 270 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp6_ = window;
#line 270 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp7_ = term;
#line 270 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp8_ = int64_parse (_tmp7_);
#line 270 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		main_window_switch_page (_tmp6_, MAIN_WINDOW_PAGE_PROFILE, _tmp8_, NULL);
#line 272 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		result = TRUE;
#line 272 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_g_free0 (term);
#line 272 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		return result;
#line 3139 "TweetUtils.c"
	} else {
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
#line 273 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp9_ = uri;
#line 273 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		_tmp10_ = g_str_has_prefix (_tmp9_, "#");
#line 273 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
		if (_tmp10_) {
#line 3149 "TweetUtils.c"
			MainWindow* _tmp11_ = NULL;
			const gchar* _tmp12_ = NULL;
#line 274 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp11_ = window;
#line 274 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_tmp12_ = uri;
#line 274 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			main_window_switch_page (_tmp11_, MAIN_WINDOW_PAGE_SEARCH, _tmp12_, NULL);
#line 275 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			result = TRUE;
#line 275 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			_g_free0 (term);
#line 275 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
			return result;
#line 3164 "TweetUtils.c"
		}
	}
#line 277 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	result = FALSE;
#line 277 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	_g_free0 (term);
#line 277 "/builddir/build/BUILD/corebird/src/util/TweetUtils.vala"
	return result;
#line 3173 "TweetUtils.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



