/* Utils.c generated by valac 0.22.0, the Vala compiler
 * generated from Utils.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <libsoup/soup.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block45Data Block45Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block46Data Block46Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _UtilsDownloadFileAsyncData UtilsDownloadFileAsyncData;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _Block45Data {
	int _ref_count_;
	GtkMessageDialog* dialog;
};

struct _Block46Data {
	int _ref_count_;
	GSourceFunc cb;
	gpointer cb_target;
	GDestroyNotify cb_target_destroy_notify;
	gchar* path;
	GCancellable* cancellable;
	gpointer _async_data_;
};

struct _UtilsDownloadFileAsyncData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	gchar* url;
	gchar* path;
	GCancellable* cancellable;
	Block46Data* _data46_;
	const gchar* _tmp0_;
	GCancellable* _tmp1_;
	SoupSessionAsync* session;
	SoupSessionAsync* _tmp2_;
	SoupMessage* msg;
	const gchar* _tmp3_;
	SoupMessage* _tmp4_;
	SoupMessage* _tmp5_;
};



void gdk_pixbuf_new_from_stream_async (GInputStream* in_stream, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbuf* gdk_pixbuf_new_from_stream_finish (GAsyncResult* _res_, GError** error);
void gdk_pixbuf_animation_new_from_stream_async (GInputStream* in_stream, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
GdkPixbufAnimation* gdk_pixbuf_animation_new_from_stream_finish (GAsyncResult* _res_, GError** error);
#define UTILS_CONSUMER_KEY "MHJ2SExkYnpSVUxaZDVkejZYMVRVQQ=="
#define UTILS_CONSUMER_SECRET "b0dydmQ2NjU0bldMaHpMY0p5d1NXM3BsdFVma2hQNEJucmFQUFZOaEh0WQ=="
GDateTime* utils_parse_date (const gchar* input);
gchar* utils_get_time_delta (GDateTime* time, GDateTime* now);
gchar* utils_get_file_name (const gchar* path);
gchar* utils_get_file_type (const gchar* path);
gchar* utils_get_avatar_name (const gchar* path);
void utils_show_error_dialog (const gchar* message);
static Block45Data* block45_data_ref (Block45Data* _data45_);
static void block45_data_unref (void * _userdata_);
static void __lambda7_ (Block45Data* _data45_, gint id);
static void ___lambda7__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self);
gchar* utils_user_file (const gchar* file_name);
static void utils_download_file_async_data_free (gpointer _data);
void utils_download_file_async (const gchar* url, const gchar* path, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_);
void utils_download_file_finish (GAsyncResult* _res_);
static gboolean utils_download_file_async_co (UtilsDownloadFileAsyncData* _data_);
static Block46Data* block46_data_ref (Block46Data* _data46_);
static void block46_data_unref (void * _userdata_);
static gboolean _utils_download_file_async_co_gsource_func (gpointer self);
static void __lambda95_ (Block46Data* _data46_, SoupSession* _s, SoupMessage* _msg);
static void ___lambda95__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self);
gchar* utils_decode (const gchar* source);
gchar* utils_unescape_html (const gchar* input);
void utils_load_custom_icons (void);
#define DATADIR "/usr/share/corebird/"
guint utils_int64_hash_func (gint64* k);
gboolean utils_int64_equal_func (gint64* a, gint64* b);
static gboolean _int64_equal (const gint64* s1, const gint64* s2);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

const gchar* UTILS_MONTHS[12] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};

/**
  * Parses a date given by Twitter in the form 'Wed Jun 20 19:01:28 +0000 2012'
  * and creates a GLib.DateTime in the local time zone to work with.
  *
  * @return The given date as GLib.DateTime in the current time zone.
  */
static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = str;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = maxlen;
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
#line 1156 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	end = _tmp2_;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = end;
#line 1157 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ == NULL) {
#line 143 "Utils.c"
		glong _tmp4_ = 0L;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = maxlen;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp4_;
#line 1158 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 151 "Utils.c"
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = end;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = str;
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (glong) (_tmp5_ - _tmp6_);
#line 1160 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 163 "Utils.c"
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
#line 1167 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = offset;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp1_ >= ((glong) 0)) {
#line 188 "Utils.c"
		glong _tmp2_ = 0L;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = len;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = _tmp2_ >= ((glong) 0);
#line 194 "Utils.c"
	} else {
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 198 "Utils.c"
	}
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _tmp0_;
#line 1169 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_) {
#line 204 "Utils.c"
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = offset;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = len;
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
#line 1171 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = _tmp6_;
#line 216 "Utils.c"
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = strlen (self);
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = _tmp7_;
#line 1173 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		string_length = (glong) _tmp8_;
#line 226 "Utils.c"
	}
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp9_ = offset;
#line 1176 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp9_ < ((glong) 0)) {
#line 232 "Utils.c"
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp10_ = string_length;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp11_ = offset;
#line 1177 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		offset = _tmp10_ + _tmp11_;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp12_ = offset;
#line 1178 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
#line 246 "Utils.c"
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp13_ = offset;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp14_ = string_length;
#line 1180 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
#line 256 "Utils.c"
	}
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp15_ = len;
#line 1182 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp15_ < ((glong) 0)) {
#line 262 "Utils.c"
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp16_ = string_length;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp17_ = offset;
#line 1183 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		len = _tmp16_ - _tmp17_;
#line 271 "Utils.c"
	}
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp18_ = offset;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp19_ = len;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp20_ = string_length;
#line 1185 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp21_ = offset;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp22_ = len;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	result = _tmp23_;
#line 1186 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	return result;
#line 291 "Utils.c"
}


GDateTime* utils_parse_date (const gchar* input) {
	GDateTime* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* month_str = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gint day = 0;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint year = 0;
	const gchar* _tmp9_ = NULL;
	const gchar* _tmp10_ = NULL;
	gint _tmp11_ = 0;
	gint _tmp12_ = 0;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gint _tmp15_ = 0;
	gint _tmp16_ = 0;
	gchar* timezone = NULL;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gint month = 0;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	GQuark _tmp22_ = 0U;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label0 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label1 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label2 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label3 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label4 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label5 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label6 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label7 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label8 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label9 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label10 = 0;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	static GQuark _tmp21_label11 = 0;
#line 347 "Utils.c"
	gint hour = 0;
	const gchar* _tmp23_ = NULL;
	gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gint _tmp27_ = 0;
	gint minute = 0;
	const gchar* _tmp28_ = NULL;
	gchar* _tmp29_ = NULL;
	gchar* _tmp30_ = NULL;
	gint _tmp31_ = 0;
	gint _tmp32_ = 0;
	gint second = 0;
	const gchar* _tmp33_ = NULL;
	gchar* _tmp34_ = NULL;
	gchar* _tmp35_ = NULL;
	gint _tmp36_ = 0;
	gint _tmp37_ = 0;
	GDateTime* dt = NULL;
	const gchar* _tmp38_ = NULL;
	GTimeZone* _tmp39_ = NULL;
	GTimeZone* _tmp40_ = NULL;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	gint _tmp43_ = 0;
	gint _tmp44_ = 0;
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	GDateTime* _tmp47_ = NULL;
	GDateTime* _tmp48_ = NULL;
	GDateTime* _tmp49_ = NULL;
	GTimeZone* _tmp50_ = NULL;
	GTimeZone* _tmp51_ = NULL;
	GDateTime* _tmp52_ = NULL;
	GDateTime* _tmp53_ = NULL;
#line 45 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 46 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = input;
#line 46 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (g_strcmp0 (_tmp0_, "") == 0) {
#line 389 "Utils.c"
		GDateTime* _tmp1_ = NULL;
#line 47 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp1_ = g_date_time_new_now_local ();
#line 47 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		result = _tmp1_;
#line 47 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return result;
#line 397 "Utils.c"
	}
#line 49 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = input;
#line 49 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = string_substring (_tmp2_, (glong) 4, (glong) 3);
#line 49 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	month_str = _tmp3_;
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp4_ = input;
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp5_ = string_substring (_tmp4_, (glong) 8, (glong) 2);
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp6_ = _tmp5_;
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp7_ = atoi (_tmp6_);
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp8_ = _tmp7_;
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp6_);
#line 50 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	day = _tmp8_;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp9_ = input;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp10_ = input;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp11_ = strlen (_tmp10_);
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp12_ = _tmp11_;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp13_ = string_substring (_tmp9_, (glong) (_tmp12_ - 4), (glong) (-1));
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp14_ = _tmp13_;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp15_ = atoi (_tmp14_);
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp16_ = _tmp15_;
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp14_);
#line 51 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	year = _tmp16_;
#line 52 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp17_ = input;
#line 52 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp18_ = string_substring (_tmp17_, (glong) 20, (glong) 5);
#line 52 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	timezone = _tmp18_;
#line 54 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	month = -1;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp19_ = month_str;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp20_ = _tmp19_;
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp22_ = (NULL == _tmp20_) ? 0 : g_quark_from_string (_tmp20_);
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp22_ == ((0 != _tmp21_label0) ? _tmp21_label0 : (_tmp21_label0 = g_quark_from_static_string ("Jan")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 457 "Utils.c"
			default:
			{
#line 56 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 1;
#line 56 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 464 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label1) ? _tmp21_label1 : (_tmp21_label1 = g_quark_from_static_string ("Feb")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 470 "Utils.c"
			default:
			{
#line 57 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 2;
#line 57 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 477 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label2) ? _tmp21_label2 : (_tmp21_label2 = g_quark_from_static_string ("Mar")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 483 "Utils.c"
			default:
			{
#line 58 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 3;
#line 58 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 490 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label3) ? _tmp21_label3 : (_tmp21_label3 = g_quark_from_static_string ("Apr")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 496 "Utils.c"
			default:
			{
#line 59 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 4;
#line 59 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 503 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label4) ? _tmp21_label4 : (_tmp21_label4 = g_quark_from_static_string ("May")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 509 "Utils.c"
			default:
			{
#line 60 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 5;
#line 60 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 516 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label5) ? _tmp21_label5 : (_tmp21_label5 = g_quark_from_static_string ("Jun")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 522 "Utils.c"
			default:
			{
#line 61 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 6;
#line 61 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 529 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label6) ? _tmp21_label6 : (_tmp21_label6 = g_quark_from_static_string ("Jul")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 535 "Utils.c"
			default:
			{
#line 62 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 7;
#line 62 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 542 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label7) ? _tmp21_label7 : (_tmp21_label7 = g_quark_from_static_string ("Aug")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 548 "Utils.c"
			default:
			{
#line 63 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 8;
#line 63 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 555 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label8) ? _tmp21_label8 : (_tmp21_label8 = g_quark_from_static_string ("Sep")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 561 "Utils.c"
			default:
			{
#line 64 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 9;
#line 64 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 568 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label9) ? _tmp21_label9 : (_tmp21_label9 = g_quark_from_static_string ("Oct")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 574 "Utils.c"
			default:
			{
#line 65 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 10;
#line 65 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 581 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label10) ? _tmp21_label10 : (_tmp21_label10 = g_quark_from_static_string ("Nov")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 587 "Utils.c"
			default:
			{
#line 66 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 11;
#line 66 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 594 "Utils.c"
			}
		}
	} else if (_tmp22_ == ((0 != _tmp21_label11) ? _tmp21_label11 : (_tmp21_label11 = g_quark_from_static_string ("Dec")))) {
#line 55 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		switch (0) {
#line 600 "Utils.c"
			default:
			{
#line 67 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				month = 12;
#line 67 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
				break;
#line 607 "Utils.c"
			}
		}
	}
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp23_ = input;
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp24_ = string_substring (_tmp23_, (glong) 11, (glong) 2);
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp25_ = _tmp24_;
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp26_ = atoi (_tmp25_);
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp27_ = _tmp26_;
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp25_);
#line 70 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	hour = _tmp27_;
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp28_ = input;
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp29_ = string_substring (_tmp28_, (glong) 14, (glong) 2);
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp30_ = _tmp29_;
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp31_ = atoi (_tmp30_);
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp32_ = _tmp31_;
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp30_);
#line 71 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	minute = _tmp32_;
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp33_ = input;
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp34_ = string_substring (_tmp33_, (glong) 17, (glong) 2);
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp35_ = _tmp34_;
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp36_ = atoi (_tmp35_);
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp37_ = _tmp36_;
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp35_);
#line 72 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	second = _tmp37_;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp38_ = timezone;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp39_ = g_time_zone_new (_tmp38_);
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp40_ = _tmp39_;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp41_ = year;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp42_ = month;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp43_ = day;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp44_ = hour;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp45_ = minute;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp46_ = second;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp47_ = g_date_time_new (_tmp40_, _tmp41_, _tmp42_, _tmp43_, _tmp44_, _tmp45_, (gdouble) _tmp46_);
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp48_ = _tmp47_;
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_time_zone_unref0 (_tmp40_);
#line 73 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	dt = _tmp48_;
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp49_ = dt;
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp50_ = g_time_zone_new_local ();
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp51_ = _tmp50_;
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp52_ = g_date_time_to_timezone (_tmp49_, _tmp51_);
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp53_ = _tmp52_;
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_time_zone_unref0 (_tmp51_);
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _tmp53_;
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_date_time_unref0 (dt);
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (timezone);
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (month_str);
#line 75 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 701 "Utils.c"
}


/**
   * Calculates an easily human-readable version of the time difference between
   * time and now.
   * Example: "5m" or "3h" or "26m" or "16 Nov"
   */
gchar* utils_get_time_delta (GDateTime* time, GDateTime* now) {
	gchar* result = NULL;
	GTimeSpan diff = 0LL;
	GDateTime* _tmp0_ = NULL;
	GDateTime* _tmp1_ = NULL;
	GTimeSpan _tmp2_ = 0LL;
	gint minutes = 0;
	GTimeSpan _tmp3_ = 0LL;
	gint _tmp4_ = 0;
	gint hours = 0;
	gint _tmp9_ = 0;
	gint _tmp10_ = 0;
	GDateTime* _tmp13_ = NULL;
	gint _tmp14_ = 0;
	GDateTime* _tmp15_ = NULL;
	gint _tmp16_ = 0;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
#line 83 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (time != NULL, NULL);
#line 83 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (now != NULL, NULL);
#line 85 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = now;
#line 85 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = time;
#line 85 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = g_date_time_difference (_tmp0_, _tmp1_);
#line 85 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	diff = _tmp2_;
#line 87 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = diff;
#line 87 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	minutes = (gint) (((_tmp3_ / 1000.0) / 1000.0) / 60.0);
#line 88 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp4_ = minutes;
#line 88 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp4_ == 0) {
#line 748 "Utils.c"
		gchar* _tmp5_ = NULL;
#line 89 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp5_ = g_strdup ("Now");
#line 89 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		result = _tmp5_;
#line 89 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return result;
#line 756 "Utils.c"
	} else {
		gint _tmp6_ = 0;
#line 90 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp6_ = minutes;
#line 90 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		if (_tmp6_ < 60) {
#line 763 "Utils.c"
			gint _tmp7_ = 0;
			gchar* _tmp8_ = NULL;
#line 91 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			_tmp7_ = minutes;
#line 91 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			_tmp8_ = g_strdup_printf ("%dm", _tmp7_);
#line 91 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			result = _tmp8_;
#line 91 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			return result;
#line 774 "Utils.c"
		}
	}
#line 93 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp9_ = minutes;
#line 93 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	hours = (gint) (_tmp9_ / 60.0);
#line 94 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp10_ = hours;
#line 94 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp10_ < 24) {
#line 785 "Utils.c"
		gint _tmp11_ = 0;
		gchar* _tmp12_ = NULL;
#line 95 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp11_ = hours;
#line 95 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp12_ = g_strdup_printf ("%dh", _tmp11_);
#line 95 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		result = _tmp12_;
#line 95 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return result;
#line 796 "Utils.c"
	}
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp13_ = time;
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp14_ = g_date_time_get_day_of_month (_tmp13_);
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp15_ = time;
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp16_ = g_date_time_get_month (_tmp15_);
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp17_ = UTILS_MONTHS[_tmp16_ - 1];
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp18_ = g_strdup_printf ("%d %s", _tmp14_, _tmp17_);
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _tmp18_;
#line 98 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 814 "Utils.c"
}


/**
   * Extracts the actual filename out of a given path.
   * E.g. for /home/foo/bar.png, it will return "bar.png"
   *
   * @return The filename of the given path, and nothing else.
   */
static gint string_last_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 928 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 929 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 929 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 929 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strrchr (((gchar*) self) + _tmp0_, (gssize) (-1), _tmp1_);
#line 929 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 931 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 931 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 845 "Utils.c"
		gchar* _tmp4_ = NULL;
#line 932 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 932 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 932 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 853 "Utils.c"
	} else {
#line 934 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = -1;
#line 934 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 859 "Utils.c"
	}
}


gchar* utils_get_file_name (const gchar* path) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gchar* _tmp3_ = NULL;
#line 108 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = path;
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = path;
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = string_last_index_of_char (_tmp1_, (gunichar) '/', 0);
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = string_substring (_tmp0_, (glong) (_tmp2_ + 1), (glong) (-1));
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _tmp3_;
#line 109 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 884 "Utils.c"
}


/**
   * Extracts the file type from the given path.
   * E.g. for http://foo.org/bar/bla.png, this will just return "png"
   */
static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
#line 918 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 919 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp0_ = start_index;
#line 919 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp1_ = c;
#line 919 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp2_ = g_utf8_strchr (((gchar*) self) + _tmp0_, (gssize) (-1), _tmp1_);
#line 919 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_result_ = _tmp2_;
#line 921 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	_tmp3_ = _result_;
#line 921 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_tmp3_ != NULL) {
#line 913 "Utils.c"
		gchar* _tmp4_ = NULL;
#line 922 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _result_;
#line 922 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = (gint) (_tmp4_ - ((gchar*) self));
#line 922 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 921 "Utils.c"
	} else {
#line 924 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = -1;
#line 924 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 927 "Utils.c"
	}
}


gchar* utils_get_file_type (const gchar* path) {
	gchar* result = NULL;
	gchar* filename = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gchar* type = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
#line 116 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 117 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = path;
#line 117 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = utils_get_file_name (_tmp0_);
#line 117 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	filename = _tmp1_;
#line 118 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = filename;
#line 118 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = string_index_of_char (_tmp2_, (gunichar) '.', 0);
#line 118 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp3_ == (-1)) {
#line 961 "Utils.c"
		gchar* _tmp4_ = NULL;
#line 119 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp4_ = g_strdup ("");
#line 119 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		result = _tmp4_;
#line 119 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_free0 (filename);
#line 119 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return result;
#line 971 "Utils.c"
	}
#line 120 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp5_ = filename;
#line 120 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp6_ = filename;
#line 120 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp7_ = string_last_index_of_char (_tmp6_, (gunichar) '.', 0);
#line 120 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp8_ = string_substring (_tmp5_, (glong) (_tmp7_ + 1), (glong) (-1));
#line 120 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	type = _tmp8_;
#line 121 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp9_ = type;
#line 121 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp10_ = g_utf8_strdown (_tmp9_, (gssize) (-1));
#line 121 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (type);
#line 121 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	type = _tmp10_;
#line 122 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp11_ = type;
#line 122 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (g_strcmp0 (_tmp11_, "jpg") == 0) {
#line 995 "Utils.c"
		gchar* _tmp12_ = NULL;
#line 123 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp12_ = g_strdup ("jpeg");
#line 123 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		result = _tmp12_;
#line 123 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_free0 (type);
#line 123 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_free0 (filename);
#line 123 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return result;
#line 1007 "Utils.c"
	}
#line 124 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = type;
#line 124 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (filename);
#line 124 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1015 "Utils.c"
}


/**
   * Returns the avatar name for the given path
   *
   * @return the 'calculated' avatar name
   */
gchar* utils_get_avatar_name (const gchar* path) {
	gchar* result = NULL;
	gchar** parts = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint parts_length1 = 0;
	gint _parts_size_ = 0;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gchar* _tmp8_ = NULL;
#line 132 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 133 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = path;
#line 133 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, "/", 0);
#line 133 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	parts = _tmp2_;
#line 133 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	parts_length1 = _vala_array_length (_tmp1_);
#line 133 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_parts_size_ = parts_length1;
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = parts[parts_length1 - 2];
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp4_ = g_strconcat (_tmp3_, "_", NULL);
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp5_ = _tmp4_;
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp6_ = parts[parts_length1 - 1];
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp8_ = _tmp7_;
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp5_);
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _tmp8_;
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 134 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1070 "Utils.c"
}


/**
   * Shows an error dialog with the given error message
   *
   * @param message The error message to show
   */
static Block45Data* block45_data_ref (Block45Data* _data45_) {
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_atomic_int_inc (&_data45_->_ref_count_);
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return _data45_;
#line 1084 "Utils.c"
}


static void block45_data_unref (void * _userdata_) {
	Block45Data* _data45_;
	_data45_ = (Block45Data*) _userdata_;
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data45_->_ref_count_)) {
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_object_unref0 (_data45_->dialog);
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_slice_free (Block45Data, _data45_);
#line 1097 "Utils.c"
	}
}


static void __lambda7_ (Block45Data* _data45_, gint id) {
	gint _tmp0_ = 0;
#line 149 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = id;
#line 149 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp0_ == ((gint) GTK_RESPONSE_OK)) {
#line 150 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (_data45_->dialog, GTK_TYPE_WIDGET, GtkWidget));
#line 1110 "Utils.c"
	}
}


static void ___lambda7__gtk_dialog_response (GtkDialog* _sender, gint response_id, gpointer self) {
#line 148 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	__lambda7_ (self, response_id);
#line 1118 "Utils.c"
}


void utils_show_error_dialog (const gchar* message) {
	Block45Data* _data45_;
	const gchar* _tmp0_ = NULL;
	GtkMessageDialog* _tmp1_ = NULL;
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_if_fail (message != NULL);
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data45_ = g_slice_new0 (Block45Data);
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data45_->_ref_count_ = 1;
#line 144 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = message;
#line 144 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_DESTROY_WITH_PARENT, GTK_MESSAGE_ERROR, GTK_BUTTONS_OK, _tmp0_);
#line 144 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_object_ref_sink (_tmp1_);
#line 144 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data45_->dialog = _tmp1_;
#line 148 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_data45_->dialog, GTK_TYPE_DIALOG, GtkDialog), "response", (GCallback) ___lambda7__gtk_dialog_response, block45_data_ref (_data45_), (GClosureNotify) block45_data_unref, 0);
#line 153 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	gtk_widget_show (G_TYPE_CHECK_INSTANCE_CAST (_data45_->dialog, GTK_TYPE_WIDGET, GtkWidget));
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	block45_data_unref (_data45_);
#line 143 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data45_ = NULL;
#line 1148 "Utils.c"
}


/**
   * TODO: Maybe use the XDG_CONFIG_DIR here?
   * @return a path to the file or folder ~/.corebird/file_name
   */
gchar* utils_user_file (const gchar* file_name) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 161 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (file_name != NULL, NULL);
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = g_get_home_dir ();
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = g_strconcat (_tmp0_, "/.corebird/", NULL);
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = _tmp1_;
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = file_name;
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp4_ = g_strconcat (_tmp2_, _tmp3_, NULL);
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp5_ = _tmp4_;
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_tmp2_);
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _tmp5_;
#line 162 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1184 "Utils.c"
}


static void utils_download_file_async_data_free (gpointer _data) {
	UtilsDownloadFileAsyncData* _data_;
	_data_ = _data;
	_g_free0 (_data_->url);
	g_slice_free (UtilsDownloadFileAsyncData, _data_);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


void utils_download_file_async (const gchar* url, const gchar* path, GCancellable* cancellable, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	UtilsDownloadFileAsyncData* _data_;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GCancellable* _tmp4_ = NULL;
	GCancellable* _tmp5_ = NULL;
	_data_ = g_slice_new0 (UtilsDownloadFileAsyncData);
	_data_->_async_result = g_simple_async_result_new (NULL, _callback_, _user_data_, utils_download_file_async);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, utils_download_file_async_data_free);
	_tmp0_ = url;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 (_data_->url);
	_data_->url = _tmp1_;
	_tmp2_ = path;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (_data_->path);
	_data_->path = _tmp3_;
	_tmp4_ = cancellable;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp5_;
	utils_download_file_async_co (_data_);
}


void utils_download_file_finish (GAsyncResult* _res_) {
	UtilsDownloadFileAsyncData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


/**
   * download_file_async:
   * Downloads the given file asynchronously to the given location.
   *
   * @param url The URL of the file to download
   * @param path The filesystem path to save the file to
   *
   */
static Block46Data* block46_data_ref (Block46Data* _data46_) {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_atomic_int_inc (&_data46_->_ref_count_);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return _data46_;
#line 1247 "Utils.c"
}


static void block46_data_unref (void * _userdata_) {
	Block46Data* _data46_;
	_data46_ = (Block46Data*) _userdata_;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (g_atomic_int_dec_and_test (&_data46_->_ref_count_)) {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		(_data46_->cb_target_destroy_notify == NULL) ? NULL : (_data46_->cb_target_destroy_notify (_data46_->cb_target), NULL);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_data46_->cb = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_data46_->cb_target = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_data46_->cb_target_destroy_notify = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_free0 (_data46_->path);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_object_unref0 (_data46_->cancellable);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_slice_free (Block46Data, _data46_);
#line 1270 "Utils.c"
	}
}


static gboolean _utils_download_file_async_co_gsource_func (gpointer self) {
	gboolean result;
	result = utils_download_file_async_co (self);
#line 176 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1280 "Utils.c"
}


static void __lambda95_ (Block46Data* _data46_, SoupSession* _s, SoupMessage* _msg) {
	GCancellable* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_if_fail (SOUP_IS_SESSION (_s));
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_if_fail (SOUP_IS_MESSAGE (_msg));
#line 178 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = _data46_->cancellable;
#line 178 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
#line 178 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_tmp1_) {
#line 179 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return;
#line 1300 "Utils.c"
	}
	{
		GFile* out_file = NULL;
		const gchar* _tmp2_ = NULL;
		GFile* _tmp3_ = NULL;
		GFileOutputStream* out_stream = NULL;
		GFile* _tmp4_ = NULL;
		GFileOutputStream* _tmp5_ = NULL;
		GFileOutputStream* _tmp6_ = NULL;
		SoupMessage* _tmp7_ = NULL;
		SoupMessageBody* _tmp8_ = NULL;
		guint8* _tmp9_ = NULL;
		gint _tmp9__length1 = 0;
#line 182 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp2_ = _data46_->path;
#line 182 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp3_ = g_file_new_for_path (_tmp2_);
#line 182 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		out_file = _tmp3_;
#line 183 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp4_ = out_file;
#line 183 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp5_ = g_file_replace (_tmp4_, NULL, FALSE, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error_);
#line 183 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		out_stream = _tmp5_;
#line 183 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		if (_inner_error_ != NULL) {
#line 183 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			_g_object_unref0 (out_file);
#line 1330 "Utils.c"
			goto __catch59_g_error;
		}
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp6_ = out_stream;
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp7_ = _msg;
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp8_ = _tmp7_->response_body;
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp9_ = _tmp8_->data;
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp9__length1 = (gint) _tmp8_->length;
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_output_stream_write_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, G_TYPE_OUTPUT_STREAM, GOutputStream), _tmp9_, (gsize) _tmp9__length1, NULL, NULL, &_inner_error_);
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		if (_inner_error_ != NULL) {
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			_g_object_unref0 (out_stream);
#line 185 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
			_g_object_unref0 (out_file);
#line 1351 "Utils.c"
			goto __catch59_g_error;
		}
#line 186 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_data46_->cb (_data46_->cb_target);
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_object_unref0 (out_stream);
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_object_unref0 (out_file);
#line 1360 "Utils.c"
	}
	goto __finally59;
	__catch59_g_error:
	{
		GError* e = NULL;
		GError* _tmp10_ = NULL;
		const gchar* _tmp11_ = NULL;
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		e = _inner_error_;
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_inner_error_ = NULL;
#line 188 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp10_ = e;
#line 188 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_tmp11_ = _tmp10_->message;
#line 188 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_critical ("Utils.vala:188: %s", _tmp11_);
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		_g_error_free0 (e);
#line 1380 "Utils.c"
	}
	__finally59:
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_inner_error_ != NULL) {
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_clear_error (&_inner_error_);
#line 181 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return;
#line 1391 "Utils.c"
	}
}


static void ___lambda95__soup_session_callback (SoupSession* session, SoupMessage* msg, gpointer self) {
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	__lambda95_ (self, session, msg);
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	block46_data_unref (self);
#line 1401 "Utils.c"
}


static gboolean utils_download_file_async_co (UtilsDownloadFileAsyncData* _data_) {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	switch (_data_->_state_) {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		case 0:
#line 1410 "Utils.c"
		goto _state_0;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		case 1:
#line 1414 "Utils.c"
		goto _state_1;
		default:
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_assert_not_reached ();
#line 1419 "Utils.c"
	}
	_state_0:
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_ = g_slice_new0 (Block46Data);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->_ref_count_ = 1;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp0_ = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp0_ = _data_->path;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (_data_->_data46_->path);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->path = _data_->_tmp0_;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp1_ = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp1_ = _data_->cancellable;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_object_unref0 (_data_->_data46_->cancellable);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->cancellable = _data_->_tmp1_;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->_async_data_ = _data_;
#line 174 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp2_ = NULL;
#line 174 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp2_ = (SoupSessionAsync*) soup_session_async_new ();
#line 174 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->session = _data_->_tmp2_;
#line 175 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp3_ = NULL;
#line 175 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp3_ = _data_->url;
#line 175 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp4_ = NULL;
#line 175 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp4_ = soup_message_new ("GET", _data_->_tmp3_);
#line 175 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->msg = _data_->_tmp4_;
#line 176 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->cb = _utils_download_file_async_co_gsource_func;
#line 176 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->cb_target = _data_;
#line 176 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_->cb_target_destroy_notify = NULL;
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp5_ = NULL;
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_tmp5_ = _g_object_ref0 (_data_->msg);
#line 177 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	soup_session_queue_message (G_TYPE_CHECK_INSTANCE_CAST (_data_->session, soup_session_get_type (), SoupSession), _data_->_tmp5_, ___lambda95__soup_session_callback, block46_data_ref (_data_->_data46_));
#line 191 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_state_ = 1;
#line 191 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return FALSE;
#line 1476 "Utils.c"
	_state_1:
	;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_object_unref0 (_data_->msg);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_object_unref0 (_data_->session);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	block46_data_unref (_data_->_data46_);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_data_->_data46_ = NULL;
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (_data_->_state_ == 0) {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_simple_async_result_complete_in_idle (_data_->_async_result);
#line 1491 "Utils.c"
	} else {
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		g_simple_async_result_complete (_data_->_async_result);
#line 1495 "Utils.c"
	}
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_object_unref (_data_->_async_result);
#line 173 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return FALSE;
#line 1501 "Utils.c"
}


gchar* utils_decode (const gchar* source) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	size_t _tmp1_;
	guchar* _tmp2_ = NULL;
#line 194 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (source != NULL, NULL);
#line 195 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = source;
#line 195 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = g_base64_decode (_tmp0_, &_tmp1_);
#line 195 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = (gchar*) _tmp2_;
#line 195 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1520 "Utils.c"
}


static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	GError * _inner_error_ = NULL;
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1241 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1533 "Utils.c"
	{
		GRegex* regex = NULL;
		const gchar* _tmp0_ = NULL;
		gchar* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		GRegex* _tmp3_ = NULL;
		GRegex* _tmp4_ = NULL;
		gchar* _tmp5_ = NULL;
		GRegex* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp0_ = old;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp1_ = g_regex_escape_string (_tmp0_, -1);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp3_ = g_regex_new (_tmp2_, 0, 0, &_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_free0 (_tmp2_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		regex = _tmp4_;
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 1563 "Utils.c"
				goto __catch60_g_regex_error;
			}
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1243 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 1572 "Utils.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp6_ = regex;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp7_ = replacement;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp8_ = g_regex_replace_literal (_tmp6_, self, (gssize) (-1), 0, _tmp7_, 0, &_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_tmp5_ = _tmp8_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		if (_inner_error_ != NULL) {
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 1588 "Utils.c"
				goto __catch60_g_regex_error;
			}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			g_clear_error (&_inner_error_);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
			return NULL;
#line 1599 "Utils.c"
		}
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		result = _tmp5_;
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1244 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return result;
#line 1607 "Utils.c"
	}
	goto __finally60;
	__catch60_g_regex_error:
	{
		GError* e = NULL;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		e = _inner_error_;
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_inner_error_ = NULL;
#line 1246 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_assert_not_reached ();
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		_g_error_free0 (e);
#line 1621 "Utils.c"
	}
	__finally60:
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
	if (_inner_error_ != NULL) {
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		g_clear_error (&_inner_error_);
#line 1242 "/usr/share/vala-0.22/vapi/glib-2.0.vapi"
		return NULL;
#line 1632 "Utils.c"
	}
}


gchar* utils_unescape_html (const gchar* input) {
	gchar* result = NULL;
	gchar* back = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
#line 198 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 199 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = input;
#line 199 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = string_replace (_tmp0_, "&lt;", "<");
#line 199 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	back = _tmp1_;
#line 200 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp2_ = back;
#line 200 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp3_ = string_replace (_tmp2_, "&gt;", ">");
#line 200 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (back);
#line 200 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	back = _tmp3_;
#line 201 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp4_ = back;
#line 201 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp5_ = string_replace (_tmp4_, "&amp;", "&");
#line 201 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_free0 (back);
#line 201 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	back = _tmp5_;
#line 202 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = back;
#line 202 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1674 "Utils.c"
}


void utils_load_custom_icons (void) {
	GtkIconTheme* icon_theme = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* _tmp1_ = NULL;
#line 207 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 207 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 207 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	icon_theme = _tmp1_;
#line 208 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	gtk_icon_theme_append_search_path (icon_theme, DATADIR "/scalable/");
#line 206 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_g_object_unref0 (icon_theme);
#line 1692 "Utils.c"
}


guint utils_int64_hash_func (gint64* k) {
	guint result = 0U;
	gint64* _tmp0_ = NULL;
#line 212 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = k;
#line 212 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = (guint) (*_tmp0_);
#line 212 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1705 "Utils.c"
}


static gboolean _int64_equal (const gint64* s1, const gint64* s2) {
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (s1 == s2) {
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return TRUE;
#line 1714 "Utils.c"
	}
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (s1 == NULL) {
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return FALSE;
#line 1720 "Utils.c"
	}
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	if (s2 == NULL) {
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
		return FALSE;
#line 1726 "Utils.c"
	}
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return (*s1) == (*s2);
#line 1730 "Utils.c"
}


gboolean utils_int64_equal_func (gint64* a, gint64* b) {
	gboolean result = FALSE;
	gint64* _tmp0_ = NULL;
	gint64* _tmp1_ = NULL;
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp0_ = a;
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	_tmp1_ = b;
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	result = _int64_equal (_tmp0_, _tmp1_) == TRUE;
#line 216 "/builddir/build/BUILD/corebird/src/util/Utils.vala"
	return result;
#line 1746 "Utils.c"
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



