/* ImageBox.c generated by valac 0.22.0, the Vala compiler
 * generated from ImageBox.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <cairo.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_IMAGE_BOX (image_box_get_type ())
#define IMAGE_BOX(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_BOX, ImageBox))
#define IMAGE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_BOX, ImageBoxClass))
#define IS_IMAGE_BOX(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_BOX))
#define IS_IMAGE_BOX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_BOX))
#define IMAGE_BOX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_BOX, ImageBoxClass))

typedef struct _ImageBox ImageBox;
typedef struct _ImageBoxClass ImageBoxClass;
typedef struct _ImageBoxPrivate ImageBoxPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _ImageBox {
	GtkBox parent_instance;
	ImageBoxPrivate * priv;
};

struct _ImageBoxClass {
	GtkBoxClass parent_class;
};

struct _ImageBoxPrivate {
	gboolean _use_ratio;
	GtkCssProvider* css_provider;
};


static gpointer image_box_parent_class = NULL;

GType image_box_get_type (void) G_GNUC_CONST;
#define IMAGE_BOX_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_BOX, ImageBoxPrivate))
enum  {
	IMAGE_BOX_DUMMY_PROPERTY,
	IMAGE_BOX_USE_RATIO
};
#define IMAGE_BOX_RATIO (160.f / 320.f)
ImageBox* image_box_new (GtkOrientation orientation, gint spacing);
ImageBox* image_box_construct (GType object_type, GtkOrientation orientation, gint spacing);
static gboolean image_box_real_draw (GtkWidget* base, cairo_t* c);
static void image_box_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* min_height, gint* natural_height);
gboolean image_box_get_use_ratio (ImageBox* self);
static GtkSizeRequestMode image_box_real_get_request_mode (GtkWidget* base);
void image_box_set_background (ImageBox* self, const gchar* path);
void image_box_set_use_ratio (ImageBox* self, gboolean value);
static void image_box_finalize (GObject* obj);
static void _vala_image_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_image_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ImageBox* image_box_construct (GType object_type, GtkOrientation orientation, gint spacing) {
	ImageBox * self = NULL;
	GtkOrientation _tmp0_ = 0;
	gint _tmp1_ = 0;
#line 29 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp0_ = orientation;
#line 29 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp1_ = spacing;
#line 29 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self = (ImageBox*) g_object_new (object_type, "orientation", _tmp0_, "spacing", _tmp1_, NULL);
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return self;
#line 95 "ImageBox.c"
}


ImageBox* image_box_new (GtkOrientation orientation, gint spacing) {
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return image_box_construct (TYPE_IMAGE_BOX, orientation, spacing);
#line 102 "ImageBox.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return self ? g_object_ref (self) : NULL;
#line 109 "ImageBox.c"
}


static gboolean image_box_real_draw (GtkWidget* base, cairo_t* c) {
	ImageBox * self;
	gboolean result = FALSE;
	GtkAllocation alloc = {0};
	GtkAllocation _tmp0_ = {0};
	GtkStyleContext* sc = NULL;
	GtkStyleContext* _tmp1_ = NULL;
	GtkStyleContext* _tmp2_ = NULL;
	cairo_t* _tmp3_ = NULL;
	GtkAllocation _tmp4_ = {0};
	gint _tmp5_ = 0;
	GtkAllocation _tmp6_ = {0};
	gint _tmp7_ = 0;
	cairo_t* _tmp8_ = NULL;
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_BOX, ImageBox);
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 35 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	gtk_widget_get_allocation (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget), &_tmp0_);
#line 35 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	alloc = _tmp0_;
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp1_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	sc = _tmp2_;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp3_ = c;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp4_ = alloc;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp5_ = _tmp4_.width;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp6_ = alloc;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp7_ = _tmp6_.height;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	gtk_render_background (sc, _tmp3_, (gdouble) 0, (gdouble) 0, (gdouble) _tmp5_, (gdouble) _tmp7_);
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp8_ = c;
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	GTK_WIDGET_CLASS (image_box_parent_class)->draw (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BOX, GtkBox), GTK_TYPE_WIDGET, GtkWidget), _tmp8_);
#line 41 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	result = FALSE;
#line 41 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_g_object_unref0 (sc);
#line 41 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return result;
#line 163 "ImageBox.c"
}


static void image_box_real_get_preferred_height_for_width (GtkWidget* base, gint width, gint* min_height, gint* natural_height) {
	ImageBox * self;
	gint _vala_min_height = 0;
	gint _vala_natural_height = 0;
	gint min = 0;
	gint natural = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gboolean _tmp3_ = FALSE;
	gint ratio_height = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_BOX, ImageBox);
#line 48 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp0_ = width;
#line 48 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	GTK_WIDGET_CLASS (image_box_parent_class)->get_preferred_height_for_width (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_BOX, GtkBox), GTK_TYPE_WIDGET, GtkWidget), _tmp0_, &_tmp1_, &_tmp2_);
#line 48 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	min = _tmp1_;
#line 48 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	natural = _tmp2_;
#line 50 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp3_ = self->priv->_use_ratio;
#line 50 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	if (!_tmp3_) {
#line 195 "ImageBox.c"
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
#line 51 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp4_ = min;
#line 51 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_min_height = _tmp4_;
#line 52 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp5_ = natural;
#line 52 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_natural_height = _tmp5_;
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		if (min_height) {
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
			*min_height = _vala_min_height;
#line 210 "ImageBox.c"
		}
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		if (natural_height) {
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
			*natural_height = _vala_natural_height;
#line 216 "ImageBox.c"
		}
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		return;
#line 220 "ImageBox.c"
	}
#line 57 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp6_ = width;
#line 57 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	ratio_height = (gint) (_tmp6_ * IMAGE_BOX_RATIO);
#line 59 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp7_ = min;
#line 59 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp8_ = ratio_height;
#line 59 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	if (_tmp7_ > _tmp8_) {
#line 232 "ImageBox.c"
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
#line 60 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp9_ = min;
#line 60 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_min_height = _tmp9_;
#line 61 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp10_ = natural;
#line 61 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_natural_height = _tmp10_;
#line 243 "ImageBox.c"
	} else {
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
#line 63 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp11_ = width;
#line 63 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_min_height = (gint) (_tmp11_ * IMAGE_BOX_RATIO);
#line 64 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp12_ = width;
#line 64 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_vala_natural_height = (gint) (_tmp12_ * IMAGE_BOX_RATIO);
#line 255 "ImageBox.c"
	}
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	if (min_height) {
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		*min_height = _vala_min_height;
#line 261 "ImageBox.c"
	}
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	if (natural_height) {
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		*natural_height = _vala_natural_height;
#line 267 "ImageBox.c"
	}
}


static GtkSizeRequestMode image_box_real_get_request_mode (GtkWidget* base) {
	ImageBox * self;
	GtkSizeRequestMode result = 0;
#line 70 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_BOX, ImageBox);
#line 71 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	result = GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH;
#line 71 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return result;
#line 281 "ImageBox.c"
}


void image_box_set_background (ImageBox* self, const gchar* path) {
	gchar* banner_css = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GtkStyleContext* style_context = NULL;
	GtkStyleContext* _tmp2_ = NULL;
	GtkStyleContext* _tmp3_ = NULL;
	GError * _inner_error_ = NULL;
#line 74 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_return_if_fail (IS_IMAGE_BOX (self));
#line 74 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_return_if_fail (path != NULL);
#line 75 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp0_ = path;
#line 75 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp1_ = g_strdup_printf ("*{\n" \
"    background-image: url('%s');\n" \
"    background-size: cover;\n" \
"    background-repeat: no-repeat;\n" \
"    }", _tmp0_);
#line 75 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	banner_css = _tmp1_;
#line 81 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp2_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 81 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 81 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	style_context = _tmp3_;
#line 309 "ImageBox.c"
	{
		GtkCssProvider* _tmp4_ = NULL;
		GtkCssProvider* _tmp7_ = NULL;
		GtkCssProvider* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		GtkStyleContext* _tmp10_ = NULL;
		GtkCssProvider* _tmp11_ = NULL;
#line 84 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp4_ = self->priv->css_provider;
#line 84 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		if (_tmp4_ != NULL) {
#line 321 "ImageBox.c"
			GtkStyleContext* _tmp5_ = NULL;
			GtkCssProvider* _tmp6_ = NULL;
#line 85 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
			_tmp5_ = style_context;
#line 85 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
			_tmp6_ = self->priv->css_provider;
#line 85 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
			gtk_style_context_remove_provider (_tmp5_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GTK_TYPE_STYLE_PROVIDER, GtkStyleProvider));
#line 330 "ImageBox.c"
		}
#line 87 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp7_ = gtk_css_provider_new ();
#line 87 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_g_object_unref0 (self->priv->css_provider);
#line 87 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		self->priv->css_provider = _tmp7_;
#line 88 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp8_ = self->priv->css_provider;
#line 88 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp9_ = banner_css;
#line 88 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		gtk_css_provider_load_from_data (_tmp8_, _tmp9_, (gssize) (-1), &_inner_error_);
#line 88 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		if (_inner_error_ != NULL) {
#line 346 "ImageBox.c"
			goto __catch47_g_error;
		}
#line 89 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp10_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 89 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp11_ = self->priv->css_provider;
#line 89 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		gtk_style_context_add_provider (_tmp10_, G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GTK_TYPE_STYLE_PROVIDER, GtkStyleProvider), (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
#line 355 "ImageBox.c"
	}
	goto __finally47;
	__catch47_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		e = _inner_error_;
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_inner_error_ = NULL;
#line 92 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp12_ = e;
#line 92 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_tmp13_ = _tmp12_->message;
#line 92 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		g_warning ("ImageBox.vala:92: %s", _tmp13_);
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_g_error_free0 (e);
#line 375 "ImageBox.c"
	}
	__finally47:
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	if (_inner_error_ != NULL) {
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_g_object_unref0 (style_context);
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		_g_free0 (banner_css);
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		g_clear_error (&_inner_error_);
#line 82 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		return;
#line 390 "ImageBox.c"
	}
#line 74 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_g_object_unref0 (style_context);
#line 74 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_g_free0 (banner_css);
#line 396 "ImageBox.c"
}


gboolean image_box_get_use_ratio (ImageBox* self) {
	gboolean result;
	gboolean _tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_return_val_if_fail (IS_IMAGE_BOX (self), FALSE);
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp0_ = self->priv->_use_ratio;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	result = _tmp0_;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	return result;
#line 411 "ImageBox.c"
}


void image_box_set_use_ratio (ImageBox* self, gboolean value) {
	gboolean _tmp0_ = FALSE;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_return_if_fail (IS_IMAGE_BOX (self));
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_tmp0_ = value;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self->priv->_use_ratio = _tmp0_;
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_object_notify ((GObject *) self, "use-ratio");
#line 425 "ImageBox.c"
}


static void image_box_class_init (ImageBoxClass * klass) {
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	image_box_parent_class = g_type_class_peek_parent (klass);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_type_class_add_private (klass, sizeof (ImageBoxPrivate));
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	GTK_WIDGET_CLASS (klass)->draw = image_box_real_draw;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	GTK_WIDGET_CLASS (klass)->get_preferred_height_for_width = image_box_real_get_preferred_height_for_width;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	GTK_WIDGET_CLASS (klass)->get_request_mode = image_box_real_get_request_mode;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_image_box_get_property;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_image_box_set_property;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	G_OBJECT_CLASS (klass)->finalize = image_box_finalize;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGE_BOX_USE_RATIO, g_param_spec_boolean ("use-ratio", "use-ratio", "use-ratio", TRUE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 448 "ImageBox.c"
}


static void image_box_instance_init (ImageBox * self) {
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self->priv = IMAGE_BOX_GET_PRIVATE (self);
#line 25 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self->priv->_use_ratio = TRUE;
#line 457 "ImageBox.c"
}


static void image_box_finalize (GObject* obj) {
	ImageBox * self;
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_BOX, ImageBox);
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	_g_object_unref0 (self->priv->css_provider);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	G_OBJECT_CLASS (image_box_parent_class)->finalize (obj);
#line 469 "ImageBox.c"
}


/**
 * A normal box, but with an image as background.
 */
GType image_box_get_type (void) {
	static volatile gsize image_box_type_id__volatile = 0;
	if (g_once_init_enter (&image_box_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageBoxClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_box_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageBox), 0, (GInstanceInitFunc) image_box_instance_init, NULL };
		GType image_box_type_id;
		image_box_type_id = g_type_register_static (GTK_TYPE_BOX, "ImageBox", &g_define_type_info, 0);
		g_once_init_leave (&image_box_type_id__volatile, image_box_type_id);
	}
	return image_box_type_id__volatile;
}


static void _vala_image_box_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ImageBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_BOX, ImageBox);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		case IMAGE_BOX_USE_RATIO:
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		g_value_set_boolean (value, image_box_get_use_ratio (self));
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		break;
#line 499 "ImageBox.c"
		default:
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		break;
#line 505 "ImageBox.c"
	}
}


static void _vala_image_box_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ImageBox * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_BOX, ImageBox);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
	switch (property_id) {
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		case IMAGE_BOX_USE_RATIO:
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		image_box_set_use_ratio (self, g_value_get_boolean (value));
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		break;
#line 521 "ImageBox.c"
		default:
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "/builddir/build/BUILD/corebird/src/widgets/ImageBox.vala"
		break;
#line 527 "ImageBox.c"
	}
}



