/* ImageLabel.c generated by valac 0.22.0, the Vala compiler
 * generated from ImageLabel.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_IMAGE_LABEL (image_label_get_type ())
#define IMAGE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_LABEL, ImageLabel))
#define IMAGE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_LABEL, ImageLabelClass))
#define IS_IMAGE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_LABEL))
#define IS_IMAGE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_LABEL))
#define IMAGE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_LABEL, ImageLabelClass))

typedef struct _ImageLabel ImageLabel;
typedef struct _ImageLabelClass ImageLabelClass;
typedef struct _ImageLabelPrivate ImageLabelPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _ImageLabel {
	GtkLabel parent_instance;
	ImageLabelPrivate * priv;
	GtkPositionType icon_pos;
};

struct _ImageLabelClass {
	GtkLabelClass parent_class;
};

struct _ImageLabelPrivate {
	GdkPixbuf* _icon;
	gint _gap;
};


static gpointer image_label_parent_class = NULL;

GType image_label_get_type (void) G_GNUC_CONST;
#define IMAGE_LABEL_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_LABEL, ImageLabelPrivate))
enum  {
	IMAGE_LABEL_DUMMY_PROPERTY,
	IMAGE_LABEL_ICON,
	IMAGE_LABEL_GAP
};
ImageLabel* image_label_new (const gchar* text);
ImageLabel* image_label_construct (GType object_type, const gchar* text);
static gboolean image_label_real_draw (GtkWidget* base, cairo_t* c);
GdkPixbuf* image_label_get_icon (ImageLabel* self);
gint image_label_get_gap (ImageLabel* self);
static void image_label_real_size_allocate (GtkWidget* base, GtkAllocation* allocation);
void image_label_set_icon (ImageLabel* self, GdkPixbuf* value);
void image_label_set_gap (ImageLabel* self, gint value);
static void image_label_finalize (GObject* obj);
static void _vala_image_label_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_image_label_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


ImageLabel* image_label_construct (GType object_type, const gchar* text) {
	ImageLabel * self = NULL;
	const gchar* _tmp0_ = NULL;
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self = (ImageLabel*) g_object_new (object_type, NULL);
#line 33 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = text;
#line 33 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	gtk_label_set_label (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LABEL, GtkLabel), _tmp0_);
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return self;
#line 96 "ImageLabel.c"
}


ImageLabel* image_label_new (const gchar* text) {
#line 32 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return image_label_construct (TYPE_IMAGE_LABEL, text);
#line 103 "ImageLabel.c"
}


static gpointer _g_object_ref0 (gpointer self) {
#line 37 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return self ? g_object_ref (self) : NULL;
#line 110 "ImageLabel.c"
}


static gboolean image_label_real_draw (GtkWidget* base, cairo_t* c) {
	ImageLabel * self;
	gboolean result = FALSE;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_ = NULL;
	GtkStyleContext* _tmp1_ = NULL;
	GtkPositionType _tmp2_ = 0;
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_LABEL, ImageLabel);
#line 36 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_val_if_fail (c != NULL, FALSE);
#line 37 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 37 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 37 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	context = _tmp1_;
#line 38 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp2_ = self->icon_pos;
#line 38 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	if (_tmp2_ == GTK_POS_LEFT) {
#line 135 "ImageLabel.c"
		GtkStyleContext* _tmp3_ = NULL;
		cairo_t* _tmp4_ = NULL;
		GdkPixbuf* _tmp5_ = NULL;
		cairo_t* _tmp6_ = NULL;
		GdkPixbuf* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		cairo_t* _tmp11_ = NULL;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp3_ = context;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp4_ = c;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp5_ = self->priv->_icon;
#line 39 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		gtk_render_icon (_tmp3_, _tmp4_, _tmp5_, (gdouble) 0, (gdouble) 0);
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp6_ = c;
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp7_ = self->priv->_icon;
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp8_ = gdk_pixbuf_get_width (_tmp7_);
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp9_ = _tmp8_;
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp10_ = self->priv->_gap;
#line 40 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		cairo_translate (_tmp6_, (gdouble) (_tmp9_ + _tmp10_), (gdouble) 0);
#line 41 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp11_ = c;
#line 41 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		GTK_WIDGET_CLASS (image_label_parent_class)->draw (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LABEL, GtkLabel), GTK_TYPE_WIDGET, GtkWidget), _tmp11_);
#line 169 "ImageLabel.c"
	} else {
		cairo_t* _tmp12_ = NULL;
		cairo_t* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		GdkPixbuf* _tmp15_ = NULL;
		gint _tmp16_ = 0;
		gint _tmp17_ = 0;
		GtkStyleContext* _tmp18_ = NULL;
		cairo_t* _tmp19_ = NULL;
		GdkPixbuf* _tmp20_ = NULL;
#line 43 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp12_ = c;
#line 43 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		GTK_WIDGET_CLASS (image_label_parent_class)->draw (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LABEL, GtkLabel), GTK_TYPE_WIDGET, GtkWidget), _tmp12_);
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp13_ = c;
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp14_ = gtk_widget_get_allocated_width (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LABEL, GtkLabel), GTK_TYPE_WIDGET, GtkWidget));
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp15_ = self->priv->_icon;
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp16_ = gdk_pixbuf_get_width (_tmp15_);
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp17_ = _tmp16_;
#line 44 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		cairo_translate (_tmp13_, (gdouble) (_tmp14_ - _tmp17_), (gdouble) 0);
#line 45 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp18_ = context;
#line 45 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp19_ = c;
#line 45 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		_tmp20_ = self->priv->_icon;
#line 45 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		gtk_render_icon (_tmp18_, _tmp19_, _tmp20_, (gdouble) 0, (gdouble) 0);
#line 204 "ImageLabel.c"
	}
#line 49 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	result = FALSE;
#line 49 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_g_object_unref0 (context);
#line 49 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return result;
#line 212 "ImageLabel.c"
}


static void image_label_real_size_allocate (GtkWidget* base, GtkAllocation* allocation) {
	ImageLabel * self;
	gint _tmp0_ = 0;
	GdkPixbuf* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GtkAllocation _tmp5_ = {0};
#line 52 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, TYPE_IMAGE_LABEL, ImageLabel);
#line 52 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_if_fail (allocation != NULL);
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = (*allocation).width;
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp1_ = self->priv->_icon;
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp2_ = gdk_pixbuf_get_width (_tmp1_);
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp3_ = _tmp2_;
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp4_ = self->priv->_gap;
#line 53 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	(*allocation).width = _tmp0_ + (_tmp3_ + _tmp4_);
#line 54 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp5_ = *allocation;
#line 54 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	GTK_WIDGET_CLASS (image_label_parent_class)->size_allocate (G_TYPE_CHECK_INSTANCE_CAST (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_LABEL, GtkLabel), GTK_TYPE_WIDGET, GtkWidget), &_tmp5_);
#line 244 "ImageLabel.c"
}


GdkPixbuf* image_label_get_icon (ImageLabel* self) {
	GdkPixbuf* result;
	GdkPixbuf* _tmp0_ = NULL;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_val_if_fail (IS_IMAGE_LABEL (self), NULL);
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = self->priv->_icon;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	result = _tmp0_;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return result;
#line 259 "ImageLabel.c"
}


void image_label_set_icon (ImageLabel* self, GdkPixbuf* value) {
	GdkPixbuf* _tmp0_ = NULL;
	GdkPixbuf* _tmp1_ = NULL;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_if_fail (IS_IMAGE_LABEL (self));
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = value;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_g_object_unref0 (self->priv->_icon);
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self->priv->_icon = _tmp1_;
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_object_notify ((GObject *) self, "icon");
#line 278 "ImageLabel.c"
}


gint image_label_get_gap (ImageLabel* self) {
	gint result;
	gint _tmp0_ = 0;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_val_if_fail (IS_IMAGE_LABEL (self), 0);
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = self->priv->_gap;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	result = _tmp0_;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	return result;
#line 293 "ImageLabel.c"
}


void image_label_set_gap (ImageLabel* self, gint value) {
	gint _tmp0_ = 0;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_return_if_fail (IS_IMAGE_LABEL (self));
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_tmp0_ = value;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self->priv->_gap = _tmp0_;
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_object_notify ((GObject *) self, "gap");
#line 307 "ImageLabel.c"
}


static void image_label_class_init (ImageLabelClass * klass) {
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	image_label_parent_class = g_type_class_peek_parent (klass);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_type_class_add_private (klass, sizeof (ImageLabelPrivate));
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	GTK_WIDGET_CLASS (klass)->draw = image_label_real_draw;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	GTK_WIDGET_CLASS (klass)->size_allocate = image_label_real_size_allocate;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_image_label_get_property;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_image_label_set_property;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	G_OBJECT_CLASS (klass)->finalize = image_label_finalize;
#line 326 "ImageLabel.c"
	/** The icon to display */
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGE_LABEL_ICON, g_param_spec_object ("icon", "icon", "icon", GDK_TYPE_PIXBUF, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 330 "ImageLabel.c"
	/** The gap between icon and text */
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), IMAGE_LABEL_GAP, g_param_spec_int ("gap", "gap", "gap", G_MININT, G_MAXINT, 2, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 334 "ImageLabel.c"
}


static void image_label_instance_init (ImageLabel * self) {
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self->priv = IMAGE_LABEL_GET_PRIVATE (self);
#line 28 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self->priv->_gap = 2;
#line 29 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self->icon_pos = GTK_POS_LEFT;
#line 345 "ImageLabel.c"
}


static void image_label_finalize (GObject* obj) {
	ImageLabel * self;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_LABEL, ImageLabel);
#line 26 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	_g_object_unref0 (self->priv->_icon);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	G_OBJECT_CLASS (image_label_parent_class)->finalize (obj);
#line 357 "ImageLabel.c"
}


/**
 * Displays an icon on the left/right side of the
 * specified text. Helps to reduce the complexity of layouts.
 */
GType image_label_get_type (void) {
	static volatile gsize image_label_type_id__volatile = 0;
	if (g_once_init_enter (&image_label_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageLabelClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_label_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageLabel), 0, (GInstanceInitFunc) image_label_instance_init, NULL };
		GType image_label_type_id;
		image_label_type_id = g_type_register_static (GTK_TYPE_LABEL, "ImageLabel", &g_define_type_info, 0);
		g_once_init_leave (&image_label_type_id__volatile, image_label_type_id);
	}
	return image_label_type_id__volatile;
}


static void _vala_image_label_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	ImageLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_LABEL, ImageLabel);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		case IMAGE_LABEL_ICON:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		g_value_set_object (value, image_label_get_icon (self));
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		case IMAGE_LABEL_GAP:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		g_value_set_int (value, image_label_get_gap (self));
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 394 "ImageLabel.c"
		default:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 400 "ImageLabel.c"
	}
}


static void _vala_image_label_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	ImageLabel * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_IMAGE_LABEL, ImageLabel);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
	switch (property_id) {
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		case IMAGE_LABEL_ICON:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		image_label_set_icon (self, g_value_get_object (value));
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		case IMAGE_LABEL_GAP:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		image_label_set_gap (self, g_value_get_int (value));
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 422 "ImageLabel.c"
		default:
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "/builddir/build/BUILD/corebird/src/widgets/ImageLabel.vala"
		break;
#line 428 "ImageLabel.c"
	}
}



