/* ImageDialog.c generated by valac 0.22.0, the Vala compiler
 * generated from ImageDialog.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <gdk/gdk.h>
#include <gio/gio.h>


#define TYPE_IMAGE_DIALOG (image_dialog_get_type ())
#define IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_DIALOG, ImageDialog))
#define IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_DIALOG, ImageDialogClass))
#define IS_IMAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_DIALOG))
#define IS_IMAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_DIALOG))
#define IMAGE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_DIALOG, ImageDialogClass))

typedef struct _ImageDialog ImageDialog;
typedef struct _ImageDialogClass ImageDialogClass;
typedef struct _ImageDialogPrivate ImageDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _ImageDialog {
	GtkWindow parent_instance;
	ImageDialogPrivate * priv;
};

struct _ImageDialogClass {
	GtkWindowClass parent_class;
};

struct _ImageDialogPrivate {
	GtkScrolledWindow* scroller;
	GtkImage* image;
	GtkMenu* image_context_menu;
	GtkFileChooserDialog* file_dialog;
	gchar* path;
	gdouble dnd_x;
	gdouble dnd_y;
};


static gpointer image_dialog_parent_class = NULL;

GType image_dialog_get_type (void) G_GNUC_CONST;
#define IMAGE_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_IMAGE_DIALOG, ImageDialogPrivate))
enum  {
	IMAGE_DIALOG_DUMMY_PROPERTY
};
ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path);
ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path);
gchar* utils_get_file_name (const gchar* path);
static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt);
static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self);
static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static void image_dialog_save_item_activated_cb (ImageDialog* self);
static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt);
static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean image_dialog_key_press_event_cb (ImageDialog* self);
static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static void image_dialog_finalize (GObject* obj);


ImageDialog* image_dialog_construct (GType object_type, GtkWindow* parent, const gchar* path) {
	ImageDialog * self = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	GdkPixbuf* pixbuf = NULL;
	gint img_width = 0;
	GdkPixbuf* _tmp21_ = NULL;
	gint _tmp22_ = 0;
	gint img_height = 0;
	GdkPixbuf* _tmp23_ = NULL;
	gint _tmp24_ = 0;
	gint win_width = 0;
	gint win_height = 0;
	gint _tmp25_ = 0;
	gint _tmp26_ = 0;
	gint _tmp29_ = 0;
	gint _tmp30_ = 0;
	gboolean _tmp33_ = FALSE;
	gint _tmp34_ = 0;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gint _tmp43_ = 0;
	gboolean _tmp45_ = FALSE;
	GtkScrolledWindow* _tmp51_ = NULL;
	gint _tmp52_ = 0;
	gint _tmp53_ = 0;
	GtkFileChooserDialog* _tmp54_ = NULL;
	gchar* filename = NULL;
	const gchar* _tmp55_ = NULL;
	gchar* _tmp56_ = NULL;
	GtkFileChooserDialog* _tmp57_ = NULL;
	GtkFileChooserDialog* _tmp58_ = NULL;
	GtkWindow* _tmp59_ = NULL;
	GError * _inner_error_ = NULL;
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (GTK_IS_WINDOW (parent), NULL);
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	self = (ImageDialog*) g_object_new (object_type, NULL);
#line 37 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp0_ = path;
#line 37 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 37 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_free0 (self->priv->path);
#line 37 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	self->priv->path = _tmp1_;
#line 40 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	pixbuf = NULL;
#line 141 "ImageDialog.c"
	{
		GdkPixbuf* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		GdkPixbuf* _tmp4_ = NULL;
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp3_ = path;
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp4_ = gdk_pixbuf_new_from_file (_tmp3_, &_inner_error_);
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp2_ = _tmp4_;
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		if (_inner_error_ != NULL) {
#line 154 "ImageDialog.c"
			goto __catch54_g_error;
		}
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 42 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		pixbuf = _tmp2_;
#line 161 "ImageDialog.c"
	}
	goto __finally54;
	__catch54_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		e = _inner_error_;
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_inner_error_ = NULL;
#line 44 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp5_ = e;
#line 44 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp6_ = _tmp5_->message;
#line 44 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_critical ("ImageDialog.vala:44: %s", _tmp6_);
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_g_error_free0 (e);
#line 181 "ImageDialog.c"
	}
	__finally54:
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_inner_error_ != NULL) {
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_clear_error (&_inner_error_);
#line 41 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		return NULL;
#line 194 "ImageDialog.c"
	}
	{
		const gchar* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
#line 47 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp7_ = path;
#line 47 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp8_ = g_str_has_suffix (_tmp7_, "gif");
#line 47 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		if (_tmp8_) {
#line 205 "ImageDialog.c"
			GdkPixbufAnimation* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			GdkPixbufAnimation* _tmp11_ = NULL;
			GtkImage* _tmp12_ = NULL;
			GdkPixbufAnimation* _tmp13_ = NULL;
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp10_ = path;
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp11_ = gdk_pixbuf_animation_new_from_file (_tmp10_, &_inner_error_);
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp9_ = _tmp11_;
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 219 "ImageDialog.c"
				goto __catch55_g_error;
			}
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp12_ = self->priv->image;
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp13_ = _tmp9_;
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			g_object_set (_tmp12_, "pixbuf-animation", _tmp13_, NULL);
#line 48 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_object_unref0 (_tmp13_);
#line 230 "ImageDialog.c"
		} else {
			GdkPixbuf* _tmp14_ = NULL;
			const gchar* _tmp15_ = NULL;
			GdkPixbuf* _tmp16_ = NULL;
			GtkImage* _tmp17_ = NULL;
			GdkPixbuf* _tmp18_ = NULL;
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp15_ = path;
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp16_ = gdk_pixbuf_new_from_file (_tmp15_, &_inner_error_);
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp14_ = _tmp16_;
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 245 "ImageDialog.c"
				goto __catch55_g_error;
			}
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp17_ = self->priv->image;
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp18_ = _tmp14_;
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			g_object_set (_tmp17_, "pixbuf", _tmp18_, NULL);
#line 50 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_object_unref0 (_tmp18_);
#line 256 "ImageDialog.c"
		}
	}
	goto __finally55;
	__catch55_g_error:
	{
		GError* e = NULL;
		GError* _tmp19_ = NULL;
		const gchar* _tmp20_ = NULL;
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		e = _inner_error_;
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_inner_error_ = NULL;
#line 52 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp19_ = e;
#line 52 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp20_ = _tmp19_->message;
#line 52 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_critical ("ImageDialog.vala:52: %s", _tmp20_);
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_g_error_free0 (e);
#line 277 "ImageDialog.c"
	}
	__finally55:
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_inner_error_ != NULL) {
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_g_object_unref0 (pixbuf);
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_clear_error (&_inner_error_);
#line 46 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		return NULL;
#line 290 "ImageDialog.c"
	}
#line 54 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp21_ = pixbuf;
#line 54 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp22_ = gdk_pixbuf_get_width (_tmp21_);
#line 54 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	img_width = _tmp22_;
#line 55 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp23_ = pixbuf;
#line 55 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp24_ = gdk_pixbuf_get_height (_tmp23_);
#line 55 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	img_height = _tmp24_;
#line 57 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	win_width = 800;
#line 58 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	win_height = 600;
#line 59 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp25_ = img_width;
#line 59 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp26_ = gdk_screen_width ();
#line 59 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (((gdouble) _tmp25_) <= (_tmp26_ * 0.7)) {
#line 314 "ImageDialog.c"
		gint _tmp27_ = 0;
		GtkScrolledWindow* _tmp28_ = NULL;
#line 60 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp27_ = img_width;
#line 60 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		win_width = _tmp27_;
#line 61 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp28_ = self->priv->scroller;
#line 61 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_object_set (_tmp28_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 325 "ImageDialog.c"
	}
#line 64 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp29_ = img_height;
#line 64 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp30_ = gdk_screen_height ();
#line 64 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (((gdouble) _tmp29_) <= (_tmp30_ * 0.7)) {
#line 333 "ImageDialog.c"
		gint _tmp31_ = 0;
		GtkScrolledWindow* _tmp32_ = NULL;
#line 65 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp31_ = img_height;
#line 65 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		win_height = _tmp31_;
#line 66 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp32_ = self->priv->scroller;
#line 66 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_object_set (_tmp32_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 344 "ImageDialog.c"
	}
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp34_ = win_width;
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp34_ < 800) {
#line 350 "ImageDialog.c"
		gint _tmp35_ = 0;
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp35_ = win_height;
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp33_ = _tmp35_ == 600;
#line 356 "ImageDialog.c"
	} else {
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp33_ = FALSE;
#line 360 "ImageDialog.c"
	}
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp36_ = _tmp33_;
#line 69 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp36_) {
#line 366 "ImageDialog.c"
		gint add_width = 0;
		GtkScrolledWindow* _tmp37_ = NULL;
		GtkWidget* _tmp38_ = NULL;
		gint _tmp39_ = 0;
		gint _tmp40_ = 0;
		gint _tmp41_ = 0;
#line 71 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp37_ = self->priv->scroller;
#line 71 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp38_ = gtk_scrolled_window_get_vscrollbar (_tmp37_);
#line 71 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_widget_get_preferred_width (_tmp38_, NULL, &_tmp39_);
#line 71 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		add_width = _tmp39_;
#line 72 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp40_ = win_width;
#line 72 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp41_ = add_width;
#line 72 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		win_width = _tmp40_ + _tmp41_;
#line 387 "ImageDialog.c"
	}
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp43_ = win_width;
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp43_ == 800) {
#line 393 "ImageDialog.c"
		gint _tmp44_ = 0;
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp44_ = win_height;
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp42_ = _tmp44_ < 600;
#line 399 "ImageDialog.c"
	} else {
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp42_ = FALSE;
#line 403 "ImageDialog.c"
	}
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp45_ = _tmp42_;
#line 75 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp45_) {
#line 409 "ImageDialog.c"
		gint add_height = 0;
		GtkScrolledWindow* _tmp46_ = NULL;
		GtkWidget* _tmp47_ = NULL;
		gint _tmp48_ = 0;
		gint _tmp49_ = 0;
		gint _tmp50_ = 0;
#line 77 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp46_ = self->priv->scroller;
#line 77 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp47_ = gtk_scrolled_window_get_hscrollbar (_tmp46_);
#line 77 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_widget_get_preferred_width (_tmp47_, NULL, &_tmp48_);
#line 77 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		add_height = _tmp48_;
#line 78 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp49_ = win_height;
#line 78 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp50_ = add_height;
#line 78 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		win_height = _tmp49_ + _tmp50_;
#line 430 "ImageDialog.c"
	}
#line 81 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp51_ = self->priv->scroller;
#line 81 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp52_ = win_width;
#line 81 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp53_ = win_height;
#line 81 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_set_size_request (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, GTK_TYPE_WIDGET, GtkWidget), _tmp52_, _tmp53_);
#line 82 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp54_ = self->priv->file_dialog;
#line 82 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_file_chooser_set_action (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), GTK_FILE_CHOOSER_ACTION_SAVE);
#line 83 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp55_ = path;
#line 83 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp56_ = utils_get_file_name (_tmp55_);
#line 83 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	filename = _tmp56_;
#line 84 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp57_ = self->priv->file_dialog;
#line 84 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_file_chooser_set_current_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), filename);
#line 85 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp58_ = self->priv->file_dialog;
#line 85 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GTK_TYPE_WINDOW, GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow));
#line 87 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_window_set_modal (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), TRUE);
#line 88 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp59_ = parent;
#line 88 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_window_set_transient_for (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WINDOW, GtkWindow), _tmp59_);
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_free0 (filename);
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_object_unref0 (pixbuf);
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return self;
#line 470 "ImageDialog.c"
}


ImageDialog* image_dialog_new (GtkWindow* parent, const gchar* path) {
#line 36 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return image_dialog_construct (TYPE_IMAGE_DIALOG, parent, path);
#line 477 "ImageDialog.c"
}


static gboolean image_dialog_event_box_motion_notify_cb (ImageDialog* self, GdkEventMotion* evt) {
	gboolean result = FALSE;
	GdkEventMotion _tmp0_ = {0};
	GdkModifierType _tmp1_ = 0;
#line 92 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 92 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 93 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 93 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.state;
#line 93 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if ((_tmp1_ & GDK_MODIFIER_MASK) >= GDK_BUTTON2_MASK) {
#line 495 "ImageDialog.c"
		gdouble diff_x = 0.0;
		gdouble _tmp2_ = 0.0;
		GdkEventMotion _tmp3_ = {0};
		gdouble _tmp4_ = 0.0;
		gdouble diff_y = 0.0;
		gdouble _tmp5_ = 0.0;
		GdkEventMotion _tmp6_ = {0};
		gdouble _tmp7_ = 0.0;
		GtkScrolledWindow* _tmp8_ = NULL;
		GtkAdjustment* _tmp9_ = NULL;
		GtkAdjustment* _tmp10_ = NULL;
		GtkScrolledWindow* _tmp11_ = NULL;
		GtkAdjustment* _tmp12_ = NULL;
		GtkAdjustment* _tmp13_ = NULL;
		gdouble _tmp14_ = 0.0;
		gdouble _tmp15_ = 0.0;
		gdouble _tmp16_ = 0.0;
		GtkScrolledWindow* _tmp17_ = NULL;
		GtkAdjustment* _tmp18_ = NULL;
		GtkAdjustment* _tmp19_ = NULL;
		GtkScrolledWindow* _tmp20_ = NULL;
		GtkAdjustment* _tmp21_ = NULL;
		GtkAdjustment* _tmp22_ = NULL;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_ = 0.0;
		gdouble _tmp25_ = 0.0;
#line 94 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp2_ = self->priv->dnd_x;
#line 94 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp3_ = *evt;
#line 94 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp4_ = _tmp3_.x;
#line 94 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		diff_x = _tmp2_ - _tmp4_;
#line 95 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp5_ = self->priv->dnd_y;
#line 95 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp6_ = *evt;
#line 95 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp7_ = _tmp6_.y;
#line 95 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		diff_y = _tmp5_ - _tmp7_;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp8_ = self->priv->scroller;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp9_ = gtk_scrolled_window_get_vadjustment (_tmp8_);
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp10_ = _tmp9_;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp11_ = self->priv->scroller;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp12_ = gtk_scrolled_window_get_vadjustment (_tmp11_);
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp13_ = _tmp12_;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp14_ = gtk_adjustment_get_value (_tmp13_);
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp15_ = _tmp14_;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp16_ = diff_y;
#line 96 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_adjustment_set_value (_tmp13_, _tmp15_ + _tmp16_);
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp17_ = self->priv->scroller;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp18_ = gtk_scrolled_window_get_hadjustment (_tmp17_);
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp19_ = _tmp18_;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp20_ = self->priv->scroller;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp21_ = gtk_scrolled_window_get_hadjustment (_tmp20_);
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp22_ = _tmp21_;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp23_ = gtk_adjustment_get_value (_tmp22_);
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp24_ = _tmp23_;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp25_ = diff_x;
#line 97 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_adjustment_set_value (_tmp22_, _tmp24_ + _tmp25_);
#line 98 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		result = TRUE;
#line 98 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		return result;
#line 582 "ImageDialog.c"
	}
#line 100 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	result = FALSE;
#line 100 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 588 "ImageDialog.c"
}


static gboolean _image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event (GtkWidget* _sender, GdkEventMotion* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_motion_notify_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 597 "ImageDialog.c"
}


static gboolean image_dialog_event_box_button_press_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_ = {0};
	guint _tmp1_ = 0U;
#line 104 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 104 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 105 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 105 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.button;
#line 105 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp1_ == ((guint) 2)) {
#line 615 "ImageDialog.c"
		GdkEventButton _tmp2_ = {0};
		gdouble _tmp3_ = 0.0;
		GdkEventButton _tmp4_ = {0};
		gdouble _tmp5_ = 0.0;
#line 106 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp2_ = *evt;
#line 106 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp3_ = _tmp2_.x;
#line 106 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		self->priv->dnd_x = _tmp3_;
#line 107 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp4_ = *evt;
#line 107 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp5_ = _tmp4_.y;
#line 107 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		self->priv->dnd_y = _tmp5_;
#line 108 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		result = TRUE;
#line 108 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		return result;
#line 636 "ImageDialog.c"
	}
#line 110 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	result = FALSE;
#line 110 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 642 "ImageDialog.c"
}


static gboolean _image_dialog_event_box_button_press_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_event_box_button_press_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 651 "ImageDialog.c"
}


static void image_dialog_save_item_activated_cb (ImageDialog* self) {
	gint response = 0;
	GtkFileChooserDialog* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GError * _inner_error_ = NULL;
#line 114 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_if_fail (IS_IMAGE_DIALOG (self));
#line 115 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp0_ = self->priv->file_dialog;
#line 115 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp1_ = gtk_dialog_run (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_DIALOG, GtkDialog));
#line 115 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	response = _tmp1_;
#line 116 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp2_ = response;
#line 116 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp2_ == (-1)) {
#line 673 "ImageDialog.c"
		GtkFileChooserDialog* _tmp3_ = NULL;
#line 117 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp3_ = self->priv->file_dialog;
#line 117 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GTK_TYPE_DIALOG, GtkDialog), "close");
#line 679 "ImageDialog.c"
	} else {
		gint _tmp4_ = 0;
#line 118 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp4_ = response;
#line 118 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		if (_tmp4_ == 0) {
#line 686 "ImageDialog.c"
			GFile* dest = NULL;
			GtkFileChooserDialog* _tmp5_ = NULL;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_ = NULL;
			GFile* _tmp8_ = NULL;
			GFile* _tmp9_ = NULL;
			const gchar* _tmp10_ = NULL;
			GtkFileChooserDialog* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			GFile* source = NULL;
			const gchar* _tmp14_ = NULL;
			GFile* _tmp15_ = NULL;
			GtkFileChooserDialog* _tmp20_ = NULL;
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp5_ = self->priv->file_dialog;
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp6_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp7_ = _tmp6_;
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp8_ = g_file_new_for_uri (_tmp7_);
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp9_ = _tmp8_;
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_free0 (_tmp7_);
#line 119 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			dest = _tmp9_;
#line 120 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp10_ = self->priv->path;
#line 120 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			g_message ("ImageDialog.vala:120: Source: %s", _tmp10_);
#line 121 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp11_ = self->priv->file_dialog;
#line 121 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp12_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
#line 121 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp13_ = _tmp12_;
#line 121 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			g_message ("ImageDialog.vala:121: Destin: %s", _tmp13_);
#line 121 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_free0 (_tmp13_);
#line 122 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp14_ = self->priv->path;
#line 122 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp15_ = g_file_new_for_path (_tmp14_);
#line 122 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			source = _tmp15_;
#line 735 "ImageDialog.c"
			{
				GFile* _tmp16_ = NULL;
				GFile* _tmp17_ = NULL;
#line 124 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_tmp16_ = source;
#line 124 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_tmp17_ = dest;
#line 124 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				g_file_copy (_tmp16_, _tmp17_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error_);
#line 124 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				if (_inner_error_ != NULL) {
#line 747 "ImageDialog.c"
					goto __catch56_g_error;
				}
			}
			goto __finally56;
			__catch56_g_error:
			{
				GError* e = NULL;
				GError* _tmp18_ = NULL;
				const gchar* _tmp19_ = NULL;
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				e = _inner_error_;
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_inner_error_ = NULL;
#line 126 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_tmp18_ = e;
#line 126 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_tmp19_ = _tmp18_->message;
#line 126 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				g_critical ("ImageDialog.vala:126: %s", _tmp19_);
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_g_error_free0 (e);
#line 769 "ImageDialog.c"
			}
			__finally56:
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			if (_inner_error_ != NULL) {
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_g_object_unref0 (source);
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				_g_object_unref0 (dest);
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				g_clear_error (&_inner_error_);
#line 123 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
				return;
#line 784 "ImageDialog.c"
			}
#line 128 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_tmp20_ = self->priv->file_dialog;
#line 128 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			g_signal_emit_by_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, GTK_TYPE_DIALOG, GtkDialog), "close");
#line 118 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_object_unref0 (source);
#line 118 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
			_g_object_unref0 (dest);
#line 794 "ImageDialog.c"
		}
	}
}


static void _image_dialog_save_item_activated_cb_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	image_dialog_save_item_activated_cb (self);
#line 803 "ImageDialog.c"
}


static gboolean image_dialog_button_press_event_cb (ImageDialog* self, GdkEventButton* evt) {
	gboolean result = FALSE;
	GdkEventButton _tmp0_ = {0};
	guint _tmp1_ = 0U;
#line 133 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 133 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (evt != NULL, FALSE);
#line 134 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp0_ = *evt;
#line 134 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_tmp1_ = _tmp0_.button;
#line 134 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	if (_tmp1_ == ((guint) 3)) {
#line 821 "ImageDialog.c"
		GtkMenu* _tmp2_ = NULL;
		GdkEventButton _tmp3_ = {0};
		guint _tmp4_ = 0U;
		GdkEventButton _tmp5_ = {0};
		guint32 _tmp6_ = 0U;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp2_ = self->priv->image_context_menu;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp3_ = *evt;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp4_ = _tmp3_.button;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp5_ = *evt;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		_tmp6_ = _tmp5_.time;
#line 135 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_menu_popup (_tmp2_, NULL, NULL, NULL, NULL, _tmp4_, _tmp6_);
#line 839 "ImageDialog.c"
	} else {
#line 137 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
		gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 843 "ImageDialog.c"
	}
#line 139 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	result = TRUE;
#line 139 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 849 "ImageDialog.c"
}


static gboolean _image_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = image_dialog_button_press_event_cb (self, event);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 858 "ImageDialog.c"
}


static gboolean image_dialog_key_press_event_cb (ImageDialog* self) {
	gboolean result = FALSE;
#line 143 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_return_val_if_fail (IS_IMAGE_DIALOG (self), FALSE);
#line 144 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, GTK_TYPE_WIDGET, GtkWidget));
#line 145 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	result = TRUE;
#line 145 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 872 "ImageDialog.c"
}


static gboolean _image_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = image_dialog_key_press_event_cb (self);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	return result;
#line 881 "ImageDialog.c"
}


static void image_dialog_class_init (ImageDialogClass * klass) {
	gint ImageDialog_private_offset;
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	image_dialog_parent_class = g_type_class_peek_parent (klass);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	g_type_class_add_private (klass, sizeof (ImageDialogPrivate));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = image_dialog_finalize;
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	ImageDialog_private_offset = g_type_class_get_instance_private_offset (klass);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/image-dialog.ui");
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "scroller", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, scroller));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "image_context_menu", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, image_context_menu));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "file_dialog", FALSE, ImageDialog_private_offset + G_STRUCT_OFFSET (ImageDialogPrivate, file_dialog));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_motion_notify_cb", G_CALLBACK(_image_dialog_event_box_motion_notify_cb_gtk_widget_motion_notify_event));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "event_box_button_press_cb", G_CALLBACK(_image_dialog_event_box_button_press_cb_gtk_widget_button_press_event));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "save_item_activated_cb", G_CALLBACK(_image_dialog_save_item_activated_cb_gtk_menu_item_activate));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_press_event_cb", G_CALLBACK(_image_dialog_button_press_event_cb_gtk_widget_button_press_event));
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_image_dialog_key_press_event_cb_gtk_widget_key_press_event));
#line 915 "ImageDialog.c"
}


static void image_dialog_instance_init (ImageDialog * self) {
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	self->priv = IMAGE_DIALOG_GET_PRIVATE (self);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 924 "ImageDialog.c"
}


static void image_dialog_finalize (GObject* obj) {
	ImageDialog * self;
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_DIALOG, ImageDialog);
#line 24 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->scroller);
#line 26 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->image);
#line 28 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->image_context_menu);
#line 30 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_object_unref0 (self->priv->file_dialog);
#line 32 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	_g_free0 (self->priv->path);
#line 22 "/builddir/build/BUILD/corebird/src/window/ImageDialog.vala"
	G_OBJECT_CLASS (image_dialog_parent_class)->finalize (obj);
#line 944 "ImageDialog.c"
}


GType image_dialog_get_type (void) {
	static volatile gsize image_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&image_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ImageDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageDialog), 0, (GInstanceInitFunc) image_dialog_instance_init, NULL };
		GType image_dialog_type_id;
		image_dialog_type_id = g_type_register_static (GTK_TYPE_WINDOW, "ImageDialog", &g_define_type_info, 0);
		g_once_init_leave (&image_dialog_type_id__volatile, image_dialog_type_id);
	}
	return image_dialog_type_id__volatile;
}



